// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//.Version October 1, 2006 |
//------------------------------------------------------------------
//| GetKeltner.mqh |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
/*
SSSSSSSSSSSSSSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSS

----------------------------- the designation of-------------------------------

Function GetKeltner is intended for the recovery of half of shiryny ofthe channel Of keltnera.
File should be placed into folder MetaTrader\.experts\.include \
  
-------------------------- the input parameters of--------------------------

GetKeltner.symbol - designation of the financial tool, on which iscalculated half of the width of the channel Of keltnera
GetKeltner.timeframe - taymfreym, on which is calculated half of thewidth of the channel Of keltnera
GetKeltner.period - period of the channel Of keltnera
nJMA.bar - number of the calculated bar.

------------------------- the output parameters of---------------------------

GetKeltner() - value of function GetKeltner.Resalt. Half of the widthof the channel Of keltnera
  
------------------------- of ---------------------------
*/
//-----------------------------------------------------------------------------------------------------------
double GetKeltner(string GetKeltner.symbol,int GetKeltner.timeframe,int GetKeltner.period,int GetKeltner.bar) 
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -- - - - - - - - - - - - - - - - -
  {
   double GetKeltner.sum = 0;
   for(int GetKeltner.iii = 0; GetKeltner.iii <  GetKeltner.period; GetKeltner.iii++)     
     GetKeltner.sum +=iHigh(GetKeltner.symbol,GetKeltner.timeframe,GetKeltner.bar+GetKeltner.iii) 
                     - iLow(GetKeltner.symbol,GetKeltner.timeframe,GetKeltner.bar+GetKeltner.iii);
   double GetKeltner.Resalt = GetKeltner.sum / GetKeltner.period;
   return(GetKeltner.Resalt);
  }  
//-------------------------------------------------------------------------------------
