/*
/ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//.Version July 1, 2006 |
Editing Nikolay Kositsin 15.06.2006 farria@mail.redcom.ru |
/ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTFm.mqh - this is the file, created for the maximum simplification
writing the indicators, which calculate their values on the basis ofdata s
the drawing of another, larger taymfreyma. Example of use -
file J2JMA_.htfm.mq4
//------------------------------------------------------------------
//| HTFm.mqh |
//| Copyright ? 2006, GS Conversion only |
//| http://www.gustis.narod.ru; gsb51@mail.ru |
//------------------------------------------------------------------
# property copyright "Copyright ? 2006, GS Conversion only"
# property link "http://www.gustis.narod.ru; gsb51@mail.ru "
/ otrisovka of indicator in the basic window
# property indicator_.chart_.window
/ a quantity of the indicator buffers
# property indicator_.buffers 1
/ the color of the indicator
# property indicator_.color1 Red
*/
// THE INPUT PARAMETERS OF THE INDICATOR OF-------------------------------------------------------------
extern int TFrame_.Period = 240; //elder period in the minutes
extern int Smooth = 48; //sglazhianiye of obtained muvinga.
//Naiboleye optimum value is equal to the ratio of the periods ofelder taymfreyma to the period of the graph
extern int Shift = 0; //cdvig indicator along the time axis
//------------------------------------------------------------------------------------------
datetime TFrame_Times[]; 
// the indicator buffers
double Ind_Buffer[];
double Vel_Buffer [];
//
int NTF,time1,weight;
//------------------------------------------------------------------
//| HTFm initialization function |
//------------------------------------------------------------------
int init() 
  { 
// the indicators of ----------------------------------------------

// the determination of the style of the performance of the graph
   SetIndexStyle(0,DRAW_LINE);
// the horizontal shift of the indicator line
   SetIndexShift(0, Shift); 
// name for the windows of data and leyba for sub"okon
   IndicatorShortName(""+Label+"");
   SetIndexLabel   (0,""+Label+""+"_HTFm");
// 2 indicator buffers are used for the calculation
   IndicatorBuffers(2);
   SetIndexBuffer(0,Ind_Buffer);
   SetIndexBuffer(1,Vel_Buffer); 
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,EmptyValue); 
// the initialization of the constants
   weight=0;
   if (Smooth>1)for(int fff=1; fff<=Smooth; fff++)weight+=fff; 
   NTF=TFrame_Period/Period();  
// the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(digits());
// the Alerts of ------------------------------------------------
   if (TFrame_Period !=1 && TFrame_Period !=5 && TFrame_Period !=15 && TFrame_Period !=30 && TFrame_Period !=60 && TFrame_Period !=240 && TFrame_Period !=1440 && TFrame_Period != 10080)
      { 
       Alert("Chart ", Symbol(), "???????? TimeFrame_period ????? ???? ?????? ?????????: 1, 5, 15, 30, 60, 240, 1440, 7200, 10080.\n" +
                                 "????????? ????? ???????????? ??????? ?????? ???????");
       TFrame_Period=Period();
      }
   if (Period()>= TFrame_Period) 
      {
       TFrame_Period = Period();
       Alert("???????? TimeFrame_period ?????? ???? ?????? ??????? ???????! ????????? ????? ???????????? ??????? ?????? ???????");
      }
//
// everything Time[ ] series of time are sorted out in the direction ofthe decrease
   ArrayCopySeries(TFrame_Times,MODE_TIME,Symbol(),TFrame_Period); 
// the completion of the initialization
   return(0); 
  } 
//------------------------------------------------------------------
//| HTFm iteration function |
//------------------------------------------------------------------
int start() 
  { 
// the introduction of the entire variables
   int TFlimit,MaxBar,MaxBarS,bar,bar0,bar1,Dbar,MaxBarTF,TFbar,limit; 
// the introduction of variables with the floating point
   double Vel0,Vel1,sum,price,lsum;
//
// the determination of the maximum values of the numbers of bars inthe cycles
   MaxBar=Bars-1; 
   MaxBarTF=iBarShift(NULL,TFrame_Period,Time[MaxBar-1],false)-2;
   MaxBarS=iBarShift(NULL,0,TFrame_Times[MaxBarTF+1],false)-Smooth;
   
//
// obtaining the already calculated bars
// the search for the last neposchitannogo bar
   if (time1!=0)
     {
       TFlimit=iBarShift(NULL,TFrame_Period,time1,false); 
       if (TFlimit<=0)
        {
         TFlimit=MaxBarTF;
         Print("The last neposchitannyy bar is not found");
         Print("The calculation of indicator will be produced on all bars");
        }
     }
   else TFlimit=MaxBarTF;
// the retention of the time of the discovery the last neposchitannogobar
   time1=TFrame_Times[1]; 
//
// initialization of zero
   if (TFlimit>=MaxBarTF)
     {
      TFlimit=MaxBarTF;
Limit=(.TFlimit Y)*.NTF of y;//.limit=.iBarSyuift(.NULL,0.TFrame_.Times[.TFlimit 1].false) 1;
      for(int nnn=MaxBar;nnn>limit;nnn--)
        {
         Vel_Buffer [nnn]=EmptyValue;
         Ind_Buffer[nnn]=EmptyValue;
        }  
     }
else limit=(.TFlimit Y)*.NTF of 2;//.limit=.iBarSyuift(.NULL,0.TFrame_.Times[.TFlimit 1].truye) 1;
//
 
   if (limit>MaxBarS)
     {
      for(int xxx=limit;xxx>MaxBarS;xxx--)
         {
         Vel_Buffer[xxx]=EmptyValue;
         Ind_Buffer[xxx]=EmptyValue;
        }  
      limit=MaxBarS;
     }   
// --------------------
   
// THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
   for(TFbar=TFlimit;TFbar>=-1;TFbar--)  
      {  
        if (TFbar!=-1)bar=iBarShift(NULL,0,TFrame_Times[TFbar],false);else bar=0; 
        Vel_Buffer[bar]=INDICATOR(TFbar+1);
        if ((TFbar==0)&&(bar==0))break;
      }
// linear interpolation of the absent values
   if (TFlimit==MaxBarTF)TFlimit--;    
   for(TFbar=TFlimit;TFbar>=-1;TFbar--) 
      {
// the determination of points and interval of interpolation
       if (TFbar!=-1)bar0=iBarShift(NULL,0,TFrame_Times[TFbar],false);else bar0=0;
       bar1=iBarShift(NULL,0,TFrame_Times[TFbar+1],false);
       Dbar=bar1-bar0;
// the determination of values at the points of interpolation
       Vel1=Vel_Buffer[bar1];
       Vel0=Vel_Buffer[bar0];
// checking to the absence of the error
       if((Vel1==0)||( Vel0==0)||(Dbar==0))
         { 
           Print("Error with obtaining of values at the points of interpolation");
           Print("The conversion of indicator will be produced on all bars");
           return(-1);
         }
// linear interpolation
       for(int iii=Dbar-1;iii>0;iii--) Vel_Buffer[bar0+iii]=Vel1+(Vel0-Vel1)*(Dbar-iii)/Dbar;
       if ((TFbar==0)&&(bar0==0))break;
      } 
//
// LWMA the smoothing of obtained muvinga
   if (Smooth> 1)
    {
     sum=0;
     lsum=0;
     bar=limit+Smooth;
     for(int sss=1;sss<=Smooth;sss++,bar--)
      {
      price=Vel_Buffer[bar];
      sum+=price*sss;
      lsum+=price;
      }
     sss=Smooth;
     for(bar=limit;bar>=0;bar--)   
      {
       Ind_Buffer[bar]=sum/weight;
       if(bar==0) break;
       price=Vel_Buffer[bar];
       sum=sum-lsum+price*Smooth;
       lsum-=Vel_Buffer[bar+sss];
       lsum+=price;
      }
    }
//
   if (Smooth==1)for(bar=limit;bar>=0;bar--)Ind_Buffer[bar]=Vel_Buffer [bar];  
    
// the completion of the calculations of the values of the indicator
    return(0);
  }
//---------------------------------------------------------------------------------

