//.Version January 7, 2007 final
//------------------------------------------------------------------
//| JLiteSeries()..mqh |
//| JMA code: Copyright ? 1998, Jurik Research |
//| http://www.jurikres.com |
//| JLiteSeries() MQL4: Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
/*

SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

----------------------------------------- of----------------------------------------------------

Function JLiteSeries() is intended for using the algorithm JLite withwriting of any indicators of tekhanaliza and
experts, for replacing the calculation of classical averaging to thisalgorithm. Function does not work, if the parameter
nJLite.limit is taken the value, equal to zero! All indicators, madeby me for JLiteSeries(), are executed taking into account
this limitation. File should be assumed into folderMetaTrader\.experts\.include \ the algorithm of function JLiteSeries()- this
the complete analog of algorithm JJMASeries, in which is absent theadaptive code. Therefore sometimes this function gives
the results, which slightly be late in comparison with JLiteSeries(),but the expenditure of computer resources for JLiteSeries()
six times lower than on JJMASeries(). Function JLiteSeries() isconveniently used for the indicators with the large depth
smoothing of the type of the strips Of bollindzhera or channels. Inone indicator it cannot be simultaneously used JJMASeries and
JLiteSeries()!!! It suffices in the text of indicator to replace forthe replacement in the indicator of function JJMASeries onJLiteSeries()
line # include to the line # include. One should consider that ifnJLite.bar is more,
than nJLite.MaxBar, then function JLiteSeries() returns value equal tozero! on this bar! I, consequently, such
value cannot be present in the denominator of any fraction in thecalculation of indicator! This version of the function
JLiteSeries(.Exp) are supported experts with its use in the userindicators, to which it is turned
expert. This version of function JLiteSeries() supports experts withits use in the code of the indicator, which
it is completely placed into the code of expert with the retention ofall cyclic operation statements! With writing of indicators andexperts s
by the use of function JLiteSeries(), one should not with variablegive names being begun with nJLite.... or dJLite...
Function JLiteSeries() can be used in the internal code of other userfunctions, but in this case it follows
to consider the fact that in each turning to this user function ineach turning to JLiteSeries()
must be its unique number (nJLite.number).

------------------------------------- of-------------------------------------------------

nJLite.number - ordinal number of turning to function JLiteSeries. (0,1, 2, 3 i.t.d....)
nJLite.dinJ - parameter, which makes it possible to change parametersnJLite.Length and nJLite.Phase on each bar. 0 - prohibition
change in the parameters, any other value - permission.
nJLite.MaxBar - maximum value, which can assume the number ofcalculated bar (nJLite.bar). It is usually equal
Bars-1- period; Where "period" - this is a quantity of bars, on whichinitial value dJLite.series not
it is calculated;
nJLite.limit - quantity of yet not calculated bars plus is one or thenumber of the last neposchitannogo bar. Must be
is compulsorily equal Bars-IndicatorCounted()-1;
nJLite.Length - depth of the smoothing
nJLite.Phase - parameter, which is changed within limits of -100...100, influence the quality of transient process;
dJLite.series - input parameter, from which is produced thecalculation of function JLiteSeries();
nJLite.bar - number of the calculated bar, the parameter must changewith the cyclic operation statement from the maximum value k
zero. Moreover its maximum value always must be equal to the value ofparameter nJMA.limit!!!

------------------------------------ of-------------------------------------------------

JJMASeries() - value of function dJLite.JLite(). With values ofnJLite.bar is more than nJLite.MaxBar-30 the function
JJMASeries() always return zero!!!
nJLite.reset - parameter, which returns according to the reference thevalue, differed from 0, if error in the calculation of functionoccurred,
0, if calculation passed normally. This parameter can be onlyvariable, but not by value!!!

----------------------------------- of-----------------------------------------------

Before the turnings to function JLiteSeries(), when a quantity ofalready calculated bars is equal to 0, (but it is still better this tomake
in the block of initializing of user indicator or expert), should bechanged to the required dimension of the internal
the buffer variables of function, for this it is necessary to turn tofunction JLiteSeries() through the auxiliary function
JJMASeriesResize with the following parameters:JJMASeriesResize(.MaxJLite.number 1); it is necessary to make theparameter
nJLite.number(.MaxJLite.number) equal to the number of turnings tofunction JLiteSeries, i.e., by one is more than
maximum nJLite.number.
    
-------------------------------------- of-------------------------------------------------
  
With the fixing of indicators and experts their codes can contain theerrors, for explaining reasons for which should be looked the ravine
file. All errors function JLiteSeries() writes in the ravine file inthe folder of \.MetaTrader\.EKhPERTS\.LOGS \. if, before the rotationk
of function JLiteSeries() in the code, which preceded function, aroseMQL4 error, then function will write down into the ravine file thecode
error and the content of error. If with the fulfillment of functionJLiteSeries() in algorithm JLiteSeries() occurred MQL4
error, then function will also write down into the ravine file thecode of error and the content of error. With the incorrect task of thenumber of the rotation
to function JLiteSeries() nJLite.number or incorrect determining ofthe dimension of the buffer variables nJLiteResize.Size into theravine
file will be recorded communication about the incorrect determinationof these parameters. Also into the ravine file is written informationwith
the incorrect determination of parameter nJLite.limit. If with thefulfillment of the function of initialization init() occurred failurewith
a change in the sizes of the buffer variables of functionJLiteSeries(), then function JLiteSeriesResize() will write down intothe ravine the file
information about an unsuccessful change in the sizes of buffervariables. If with the turning to function JLiteSeries() through
the external cyclic operation statement was disrupted the correctsequence of changing the parameter nJMA.bar, then file will be intothe ravine
is recorded this information. One should consider that some errors ofthe program code will generate further errors in
its performance and therefore, if function JLiteSeries() writes in theravine file immediately several errors, then removed them should be
by way of the time of appearance. In the correctly written indicatorfunction JLiteSeries() can make record into the ravine
file only with disruptions of the work of operating system. Exceptionis the record of a change in the sizes of the buffer
variables during reloading of indicator or expert, which occurs witheach call of function init().
  
--------------------------------- of--------------------------------------------

/ the determination of functions JLiteSeries()
# include
//------------------------------------------------------------------
//| Custom indicator initialization function |
//------------------------------------------------------------------
int init()
{
/ the determination of the style of the performance of the graph
SetIndexStyle (0, to.drash_.line);
/ 1 indicator buffer is used for the calculation
SetIndexBuffer(0.Ind_.Buffer);
/ a change in the sizes of the buffer variables of functionJLiteSeries, nJLite.number=1(Odno turning to function JLiteSeries)
if(.JJMASeriesResize(1)==0).return(- 1);

return(0);
}
//------------------------------------------------------------------
//| Custom indicator function |
//------------------------------------------------------------------
int start()
{
/ the introduction of entire variables and obtaining the alreadycalculated bars
int reset.bar.MakhBar.limit.chounted_.bars=.IndichatorChounted();
/ checking to the possible errors
if (counted_.bars
/ the last calculated bar must be converted (without this conversionfunction JLiteSeries() its calculation perform not it will be!!!)
if (counted_.bars 0) counted_.bars;
/ the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=.Bars-counted_.bars-1;
MaxBar=.Bars-1;
/
for(.bar=.limit;.bar = 0;.bar)
(
Double Series=.Close[.bar ];
/ turning to function JLiteSeries() after number 0 for calculating thebuffer Ind_.Buffer[
//parametry nJLite.Phase and nJLite.Length do not change on each bar(nJLite.din=0)
DoubleResalt=.JJMASeries(0,0,.MaxBar,.limit,.Phase,.Length,.Series,.bar,.reset);
if (reset!=0).return(-1);
Ind_.Buffer[.bar]=.Resalt;
}
return(0);
}
/

*/
//.SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
//|
//.SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

// SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
double dJLite.fB0,dJLite.fD0,dJLite.fA8[1],dJLite.fA8m[1],dJLite.fC0[1],dJLite.fC0m[1],dJLite.fC8[1];
double dJLite.fC8m[1],dJLite.Kg[1],dJLite.Pf[1],dJLite.fB0dJLite.f20,dJLite.f20,dJLite.f30,dJLite.f40;
double dJLite.JLite[1],dJLite.JLitem[1];
int    nJLite.TIME[1],nJLite.n,nJLite.Error,nJLite.Tnew,nJLite.Told,nJLite.size,nJLite.Resize;

//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
double JJMASeries
  (
    int nJLite.number, int    nJLite.din,    int nJLite.MaxBar, int  nJLite.limit, 
    int nJLite.Phase,  int nJLite.Length, double dJLite.series, int  nJLite.bar,    int& nJLite.reset
  )
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
{
nJLite.n=nJLite.number;

nJLite.reset=1;
//===== of====================================================================================================
if (nJLite.bar==nJLite.limit)
 {
// checking to the initialization of function JLiteSeries()
  if(nJLite.Resize<1)
   {
    Print("JLiteSeries number ="+nJLite.n+
         ". ?? ???? ??????? ????????? ???????? ???????? ?????????? ???????? JLiteSeriesResize()");
    if(nJLite.Resize==0)
          Print("JLiteSeries number ="+nJLite.n+
                ". ??????? ???????? ????????? ? ??????? JLiteSeriesResize() ? ???? ?????????????");
         
    return(0.0);
   }
// checking to the error in execution of the program code, whichpreceded function JLiteSeries()
  nJLite.Error=GetLastError();
  if(nJLite.Error>4000)
   {
    Print("JLiteSeries number ="+nJLite.n+
        ". ? ????, ?????????????? ????????? ? ??????? JLiteSeries() number = "
                                                                    +nJLite.n+" ??????!!!");
    Print("JLiteSeries number ="+nJLite.n+ ". ",JLite_ErrDescr(nJLite.Error));  
   }

// checking to the error in the task of the variables nJLite.number andnJLiteResize.Size
  nJLite.size=ArraySize(dJLite.fC0);
  if (nJLite.size< nJLite.n) 
   {
    Print("JLiteSeries number ="+nJLite.n+
                ". ??????!!! ??????????? ?????? ???????? ?????????? nJLite.number="
                                                          +nJLite.n+" ??????? JLiteSeries()");
    Print("JLiteSeries number ="+nJLite.n+
                ". ??? ??????????? ?????? ????????  ?????????? nJLiteResize.Size="
                                                  +nJLite.size+" ??????? JJMASeriesResize()");
    return(0.0);
   }
 }
// checking to the error in the sequence of changing the variablenJLite.bar
if((nJLite.limit>=nJLite.MaxBar)&&(nJLite.bar==0))
    if((nJLite.MaxBar>30)&&(nJLite.TIME[nJLite.n]==0))
                  Print("JLiteSeries number ="+nJLite.n+
                        ". ??????!!! ???????? ?????????? ?????????????????? ????????? ????????? nJLite.bar ??????? ?????????? ?????!!!");  
//==============================================================================================================================
if (nJLite.bar> nJLite.MaxBar){nJLite.reset=0;return(0.0);}
if((nJLite.bar==nJLite.MaxBar)||(nJLite.din!=0))
  {
// SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
   double dJLite.Dr;
   if(nJLite.Length < 1.0000000002) dJLite.Dr = 0.0000000001;
   else dJLite.Dr= (nJLite.Length - 1.0) / 2.0;
   dJLite.Kg[nJLite.n] = 0.9*dJLite.Dr/(dJLite.Dr + 2.0);
//- -
   if((nJLite.Phase >= -100)&&(nJLite.Phase <= 100))dJLite.Pf[nJLite.n] = nJLite.Phase / 100.0 + 1.5;
   if (nJLite.Phase >  100) dJLite.Pf[nJLite.n] = 2.5;
   if (nJLite.Phase < -100) dJLite.Pf[nJLite.n] = 0.5;
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
  }

//- -
if((nJLite.bar==nJLite.limit)&&(nJLite.limit<nJLite.MaxBar))
  {
// SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
   nJLite.Tnew=Time[nJLite.limit+1];
   nJLite.Told=nJLite.TIME[nJLite.n];
//- -
   if(nJLite.Tnew==nJLite.Told)
    {
     dJLite.fC0[nJLite.n]=dJLite.fC0m[nJLite.n];dJLite.fC8  [nJLite.n]=dJLite.fC8m  [nJLite.n];
     dJLite.fA8[nJLite.n]=dJLite.fA8m[nJLite.n];dJLite.JLite[nJLite.n]=dJLite.JLitem[nJLite.n];
    }
//- - checking to the errors
   if(nJLite.Tnew!=nJLite.TIME[nJLite.n])
    {
     nJLite.reset=-1;
//- - the indication of error in the calculation of the inputparameter nJLite.limit of function JLiteSeries()
     if (nJLite.Tnew>nJLite.TIME[nJLite.n])
      {
       Print("JLiteSeries number ="+nJLite.n+
              ". ??????!!! ???????? nJLite.limit ??????? JLiteSeries() ??????, ??? ??????????");
      }
    else 
      { 
       int nJLite.LimitERROR=nJLite.limit+1-iBarShift(NULL,0,nJLite.TIME[nJLite.n],TRUE);
       Print("JLiteSeries number ="+nJLite.n+
            ". ??????!!! ???????? nJLite.limit ??????? JLiteSeries() ??????, ??? ?????????? ?? "
                                                                                +nJLite.LimitERROR+"");
      }
//- - the recovery through nJLite.reset=-1; error in the calculationof function JLiteSeries
    return(0);
   }
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
  }
if ((nJLite.bar==1)&&( nJLite.limit!=1))
  {
//- - SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
   dJLite.fC0m[nJLite.n]=dJLite.fC0[nJLite.n];dJLite.fC8m  [nJLite.n]=dJLite.fC8  [nJLite.n];
   dJLite.fA8m[nJLite.n]=dJLite.fA8[nJLite.n];dJLite.JLitem[nJLite.n]=dJLite.JLite[nJLite.n];
   nJLite.TIME[nJLite.n]=Time[2];
//- -SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
  }

dJLite.f30 = MathPow(dJLite.Kg[nJLite.n], 1);
dJLite.fC0[nJLite.n] =(1.0 - dJLite.f30) * dJLite.series + dJLite.f30 * dJLite.fC0[nJLite.n];
dJLite.fC8[nJLite.n] =(dJLite.series - dJLite.fC0[nJLite.n]) 
                  * (1.0 - dJLite.Kg[nJLite.n]) + dJLite.Kg[nJLite.n] * dJLite.fC8[nJLite.n];
dJLite.fD0 = dJLite.Pf[nJLite.n] * dJLite.fC8[nJLite.n] + dJLite.fC0[nJLite.n];
dJLite.f20 = dJLite.f30 *(-2.0);
dJLite.f40 = dJLite.f30 * dJLite.f30;
dJLite.fB0 = dJLite.f20 + dJLite.f40 + 1.0;
dJLite.fA8[nJLite.n] =(dJLite.fD0 - dJLite.JLite[nJLite.n]) * dJLite.fB0 
                                                         + dJLite.f40 * dJLite.fA8[nJLite.n];
dJLite.JLite[nJLite.n] = dJLite.JLite[nJLite.n] + dJLite.fA8[nJLite.n];
//
nJLite.Error=GetLastError();
// checking to the error in execution of the program code of functionJLiteSeries()
if(nJLite.Error>1)
  {
   Print("JLiteSeries number = "nJLite.n". With the performance of functionJLiteSeries() occurred the error!!!");
   Print("JLiteSeries number ="+nJLite.n+ ". ",JLite_ErrDescr(nJLite.Error));  
   return(0.0);
  }
nJLite.reset=0;
if (nJLite.bar>=nJLite.MaxBar-30-2*nJLite.Length)return(0.0);
else return(dJLite.JLite[nJLite.n]);
// the completion of the calculations of function JLiteSeries() of--------------------------
}
//- ---------------------------------------------------------------------------------------------

//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
//JLiteSeriesReset - this is additional function for changing thesizes of buffer variables |
//function JLiteSeries. Example of the rotation: JLiteSeriesReset(5);where 5 - this is the number of turnings to |
//JLiteSeries() in the text of indicator. This turning to functionJLiteSeriesReset should be placed |
//into the block of initializing of user indicator or expert |
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
int JJMASeriesResize(int nJLiteResize.Size)
 {
//
  if(nJLiteResize.Size<1)
   {
    Print("JJMASeriesResize: Error!!! Parameter nJLiteResize.Size cannot be lessthan one!!!");
    nJLite.Resize=-1; 
    return(0);
   }  
  int nJLiteResize.reset,nJLiteResize.cycle;
//- -
  while(nJLiteResize.cycle==0)
   {
// SSSSSSSSSSSSSSSSSSSSSSSS
    if(ArrayResize(dJLite.Kg,    nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.Pf,    nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.fA8,   nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.fC0,   nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.fC8,   nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.JLite, nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.fA8m,  nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.fC0m,  nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.fC8m,  nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(dJLite.JLitem,nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
    if(ArrayResize(nJLite.TIME,  nJLiteResize.Size)==0){nJLiteResize.reset=-1;break;}
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
    nJLiteResize.cycle=1;
   }
//- -
  if(nJLiteResize.reset==-1)
   {
    Print("JLiteSeriesResize: Error!!! It was impossible to change the sizes ofthe buffer variables of function JLiteSeries().");
    int nJLiteResize.Error=GetLastError();
    if(nJLiteResize.Error>4000)Print("JJMASeriesResize(): ",JLite_ErrDescr(nJLiteResize.Error));       
    nJLite.Resize=-2;
    return(0);
   }
  else  
   {
    Print("JLiteSeriesResize: JLiteSeries() size = "nJLiteResize.Size"");
    nJLite.Resize=nJLiteResize.Size;
    return(nJLiteResize.Size);
   }  
//
 }
//- ---------------------------------------------------------------------------------------------
/*
//- ----------------------------------------------------------------------------------------------------
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
JJMASeriesAlert - this is additional function for the indication oferror in the task of external variables |
function JLiteSeries. |
-------------------------- the input parameters of-------------------------- |
JLiteSeriesAlert.Number |
JLiteSeriesAlert.ExternVar the value of external variable forparameter nJLite.Length |
JLiteSeriesAlert.name the name of external variable for parameternJLite.Phase, if JLiteSeriesAlert.Number=0 |
or nJLite.Phase, if JLiteSeriesAlert.Number=1. |
-------------------------- an example of the use of----------------------- |
int init() |
/ |
Here some initialization of variables and buffers |
|
/ the installation of Alerts at the inadmissible values of externalvariables |
JJMASeriesAlert(0, ".Lengtyuy",.Lengtyuy); |
JJMASeriesAlert(0, ".Lengtyu2",.Lengtyu2); |
JJMASeriesAlert(1, ".Pyuasey",.Pyuasey); |
JJMASeriesAlert(1, ".Pyuase2",.Pyuase2); |
/ the completion of initialization |
return(0); |
} |
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
*/
void JJMASeriesAlert
 (
  int JLiteSeriesAlert.Number, string JLiteSeriesAlert.name, int JLiteSeriesAlert.ExternVar
 )
 {
// the installation of Alerts at the inadmissible values of the inputparameters of ==========================
  if(JLiteSeriesAlert.Number==0)if(JLiteSeriesAlert.ExternVar<1)
          {Alert("???????? "+JLiteSeriesAlert.name+" ?????? ???? ?? ????? 1" 
          + " ?? ????? ???????????? " +JLiteSeriesAlert.ExternVar+ " ????? ????????????  1"  );}
  if(JLiteSeriesAlert.Number==1)
   {
    if(JLiteSeriesAlert.ExternVar<-100)
          {Alert("???????? "+JLiteSeriesAlert.name+" ?????? ???? ?? -100 ?? +100" 
          + " ?? ????? ???????????? "+JLiteSeriesAlert.ExternVar+  " ????? ???????????? -100");}
    if(JLiteSeriesAlert.ExternVar> 100)
          {Alert("???????? "+JLiteSeriesAlert.name+" ?????? ???? ?? -100 ?? +100" 
          + " ?? ????? ???????????? "+JLiteSeriesAlert.ExternVar+  " ????? ????????????  100");}
   }
 }
//- ---------------------------------------------------------------------------------------------

//transfer is conducted by Nikolai kositsin 01.12.2006
//------------------------------------------------------------------
//| JLite_.ErrDescr_.RUS(.MQL4)..mqh |
//| Copyright ? 2004, MetaQuotes Software Corp. |
//| http://www.metaquotes.net/ |
//------------------------------------------------------------------
string JLite_ErrDescr(int error_code)
 {
  string error_string;
//
  switch(error_code)
    {
// MQL4 error
     case 4000: error_string="??? ?????? = "+error_code+". ??? ??????";                                                  break;
     case 4001: error_string="??? ?????? = "+error_code+". ???????????? ????????? ???????";                              break;
     case 4002: error_string="??? ?????? = "+error_code+". ?????? ??????? ?? ????????????? ??? ???????";                 break;
     case 4003: error_string="??? ?????? = "+error_code+". ??? ?????? ??? ????? ???????";                                break;
     case 4004: error_string="??? ?????? = "+error_code+". ???????????? ????? ????? ???????????? ??????";                break;
     case 4005: error_string="??? ?????? = "+error_code+". ?? ????? ??? ?????? ??? ???????? ??????????";                 break;
     case 4006: error_string="??? ?????? = "+error_code+". ??? ?????? ??? ?????????? ?????????";                         break;
     case 4007: error_string="??? ?????? = "+error_code+". ??? ?????? ??? ????????? ??????";                             break;
     case 4008: error_string="??? ?????? = "+error_code+". ???????????????????? ??????";                                 break;
     case 4009: error_string="??? ?????? = "+error_code+". ???????????????????? ?????? ? ???????";                       break;
     case 4010: error_string="??? ?????? = "+error_code+". ??? ?????? ??? ?????????? ???????";                           break;
     case 4011: error_string="??? ?????? = "+error_code+". ??????? ??????? ??????";                                      break;
     case 4012: error_string="??? ?????? = "+error_code+". ??????? ?? ??????? ?? ????";                                  break;
     case 4013: error_string="??? ?????? = "+error_code+". ??????? ?? ????";                                             break;
     case 4014: error_string="??? ?????? = "+error_code+". ??????????? ???????";                                         break;
     case 4015: error_string="??? ?????? = "+error_code+". ???????????? ??????? (never generated error)";                break;
     case 4016: error_string="??? ?????? = "+error_code+". ???????????????????? ??????";                                 break;
     case 4017: error_string="??? ?????? = "+error_code+". ?????? DLL ?? ?????????";                                     break;
     case 4018: error_string="??? ?????? = "+error_code+". ?????????? ????????? ??????????";                             break;
     case 4019: error_string="??? ?????? = "+error_code+". ?????????? ??????? ???????";                                  break;
     case 4020: error_string="??? ?????? = "+error_code+". ?????? ??????? ???????????? ??????? ?? ?????????";            break;
     case 4021: error_string="??? ?????? = "+error_code+". ???????????? ?????? ??? ??????, ???????????? ?? ???????";     break;
     case 4022: error_string="??? ?????? = "+error_code+". ??????? ?????? (never generated error)";                      break;
     case 4050: error_string="??? ?????? = "+error_code+". ???????????? ?????????? ?????????? ???????";                  break;
     case 4051: error_string="??? ?????? = "+error_code+". ???????????? ???????? ????????? ???????";                     break;
     case 4052: error_string="??? ?????? = "+error_code+". ?????????? ?????? ????????? ???????";                         break;
     case 4053: error_string="??? ?????? = "+error_code+". ?????? ???????";                                              break;
     case 4054: error_string="??? ?????? = "+error_code+". ???????????? ????????????? ???????-?????????";                break;
     case 4055: error_string="??? ?????? = "+error_code+". ?????? ????????????????? ??????????";                         break;
     case 4056: error_string="??? ?????? = "+error_code+". ??????? ????????????";                                        break;
     case 4057: error_string="??? ?????? = "+error_code+". ?????? ????????? ??????????? ??????????";                     break;
     case 4058: error_string="??? ?????? = "+error_code+". ?????????? ?????????? ?? ??????????";                         break;
     case 4059: error_string="??? ?????? = "+error_code+". ??????? ?? ????????? ? ???????? ??????";                      break;
     case 4060: error_string="??? ?????? = "+error_code+". ??????? ?? ????????????";                                     break;
     case 4061: error_string="??? ?????? = "+error_code+". ?????? ???????? ?????";                                       break;
     case 4062: error_string="??? ?????? = "+error_code+". ????????? ???????? ???? string";                              break;
     case 4063: error_string="??? ?????? = "+error_code+". ????????? ???????? ???? integer";                             break;
     case 4064: error_string="??? ?????? = "+error_code+". ????????? ???????? ???? double";                              break;
     case 4065: error_string="??? ?????? = "+error_code+". ? ???????? ????????? ????????? ??????";                       break;
     case 4066: error_string="??? ?????? = "+error_code+". ??????????? ???????????? ?????? ? ????????? ??????????";      break;
     case 4067: error_string="??? ?????? = "+error_code+". ?????? ??? ?????????? ???????? ????????";                     break;
     case 4099: error_string="??? ?????? = "+error_code+". ????? ?????";                                                 break;
     case 4100: error_string="??? ?????? = "+error_code+". ?????? ??? ?????? ? ??????";                                  break;
     case 4101: error_string="??? ?????? = "+error_code+". ???????????? ??? ?????";                                      break;
     case 4102: error_string="??? ?????? = "+error_code+". ??????? ????? ???????? ??????";                               break;
     case 4103: error_string="??? ?????? = "+error_code+". ?????????? ??????? ????";                                     break;
     case 4104: error_string="??? ?????? = "+error_code+". ????????????? ????? ??????? ? ?????";                         break;
     case 4105: error_string="??? ?????? = "+error_code+". ?? ???? ????? ?? ??????";                                     break;
     case 4106: error_string="??? ?????? = "+error_code+". ??????????? ??????";                                          break;
     case 4107: error_string="??? ?????? = "+error_code+". ???????????? ???????? ???? ??? ???????? ???????";             break;
     case 4108: error_string="??? ?????? = "+error_code+". ???????? ????? ??????";                                       break;
     case 4109: error_string="??? ?????? = "+error_code+". ???????? ?? ?????????";                                       break;
     case 4110: error_string="??? ?????? = "+error_code+". ??????? ??????? ?? ?????????";                                break;
     case 4111: error_string="??? ?????? = "+error_code+". ???????? ??????? ?? ?????????";                               break;
     case 4200: error_string="??? ?????? = "+error_code+". ?????? ??? ??????????";                                       break;
     case 4201: error_string="??? ?????? = "+error_code+". ????????? ??????????? ???????? ???????";                      break;
     case 4202: error_string="??? ?????? = "+error_code+". ?????? ?? ??????????";                                        break;
     case 4203: error_string="??? ?????? = "+error_code+". ??????????? ??? ???????";                                     break;
     case 4204: error_string="??? ?????? = "+error_code+". ??? ????? ???????";                                           break;
     case 4205: error_string="??? ?????? = "+error_code+". ?????? ????????? ???????";                                    break;
     case 4206: error_string="??? ?????? = "+error_code+". ?? ??????? ????????? ???????";                                break;
     case 4207: error_string="??? ?????? = "+error_code+". ?????? ??? ?????? ? ????????";                                break;
     default:   error_string="??? ?????? = "+error_code+". ??????????? ??????";
    }
//
  return(error_string);
 }
//------------------------------------------------------------------


