//Version  October 1 , 2006     
//+------------------------------------------------------------------+
//|                                                 4c_Parabolic.mq4 |
//|                               Copyright ? 2006, Nikolay Kositsin | 
//|                                Khabarovsk, farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of indicator bufferov
#property indicator_buffers 4
//the color of the indicator
#property indicator_color1 Yellow 
#property indicator_color2 Magenta
#property indicator_color3 Lime 
#property indicator_color4 Red
//the thickness of the indicator lines
#property indicator_width1 0
#property indicator_width2 0
#property indicator_width3 0 
#property indicator_width4 0
//THE INPUT PARAMETERS OF THE INDICATOR of yuyuyuyuyuyuzhzh
extern double       Step = 0.02;
extern double    Maximum = 0.2;
extern int Trend_.Minimum = 5; //the minimum speed of trend in thepoints
/
//indicator buffery
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];
double SarBuffer[];
//the introduction of the entire global variables
int bar;
//the introduction of constants and global variables with the floatingpoint
double dT_min,low,low1,high,high1,SAR,ABS_trend,SAR1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
{  
//5 indicator bufferov are used for the calculation
IndicatorBuffers(5);
SetIndexBuffer(0,UpBuffer1); 
SetIndexBuffer(1,DnBuffer1); 
SetIndexBuffer(2,UpBuffer2);
SetIndexBuffer(3,DnBuffer2); 
SetIndexBuffer(4,SarBuffer);
//the style of the performance of graph in the form of the pointtargets
SetIndexStyle(0,DRAW_ARROW); 
SetIndexStyle(1,DRAW_ARROW); 
SetIndexStyle(2,DRAW_ARROW); 
SetIndexStyle(3,DRAW_ARROW); 
SetIndexArrow(0,159); 
SetIndexArrow(1,159); 
SetIndexArrow(2,159); 
SetIndexArrow(3,159); 
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);
SetIndexEmptyValue(1,0.0);
SetIndexEmptyValue(2,0.0);
SetIndexEmptyValue(3,0.0);
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("Parabolic( Step="+Step+", Maximum="+Maximum+")"); 
SetIndexLabel (0, "lower_Up_Trend");
SetIndexLabel (1, "lower_Down_Trend"); 
SetIndexLabel (2, "Up_Trend");
SetIndexLabel (3, "Down_Trend"); 
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//the initialization of the constant
dT_min=Trend_Minimum*Point;
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+
//| 4c_Parabolic                                                     |
//+------------------------------------------------------------------+
int start()
{
if(Bars-1<2) return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int MaxBar,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-1;
limit=MaxBar-counted_bars;
if (limit>MaxBar-1){limit=MaxBar-1; SarBuffer[MaxBar]=0; }
//----
for (bar=limit;bar>=0;bar--)
   {
     SarBuffer[bar]=iSAR(NULL,0,Step,Maximum,bar);
     //----  
     SAR=SarBuffer[bar];
     SAR1=SarBuffer[bar+1];
     //----
     low=Low[bar];
     high=High[bar];
     low1=Low[bar+1];
     high1=High[bar+1];
     //----
     Ind_SAR();
     //----
     if((SAR1>=high1)&&(SAR<high)&&(SAR>low )){SAR=low-Point ;SarBuffer[bar]=SAR;Ind_SAR();}
     if((SAR1<=low1 )&&(SAR>low )&&(SAR<high)){SAR=high+Point;SarBuffer[bar]=SAR;Ind_SAR();}
   }
//----
return(0);
}
//+--------------------------------------------------------------------+
void Ind_SAR()
  {
     //----
     UpBuffer1[bar]=0.0;
     DnBuffer1[bar]=0.0;
     UpBuffer2[bar]=0.0;
     DnBuffer2[bar]=0.0; 
     //----  
     if(((SAR>=high)&&(SAR1>=high1))||((SAR<=low)&&(SAR1<=low1)))
     ABS_trend=MathAbs(SAR-SAR1);else ABS_trend=0.0;
     //----
     if(SAR>=high)if(ABS_trend<dT_min)DnBuffer1[bar]=SAR;else DnBuffer2[bar]=SAR;                
     if(SAR<=low )if(ABS_trend<dT_min)UpBuffer1[bar]=SAR;else UpBuffer2[bar]=SAR;
  }
