//+------------------------------------------------------------------+  
//|                                                        Aroon.mq4 | 
//|                             Copyright ? 2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property  indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 2
//the color of the indicator
#property  indicator_color1  Blue
#property  indicator_color2  Red
//the parameters of the horizontal levels of the indicator
#property indicator_level1 30
#property indicator_level2 70
#property indicator_levelcolor Gold
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR
extern int Aroon_Period=10;
//---- +--------------------------+
//the indicator buffers
double UpBuffer[];
double DnBuffer[];
//+------------------------------------------------------------------+ 
//| Aroon initialization function                                    |
//+------------------------------------------------------------------+ 
int init()
  {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(1);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0,Aroon_Period+1);
   SetIndexDrawBegin(1,Aroon_Period+1);
//2 indicator buffers are used for the calculation
   if
    (
     !SetIndexBuffer(0,UpBuffer)&& 
     !SetIndexBuffer(1,DnBuffer)
    )
    {
Print("Nevozmojno to establish indicator buffers!");
     return(0);
    }
//names for the windows of data and leyby for sub"okon
   IndicatorShortName("Aroon("+Aroon_Period+")");
   SetIndexLabel(0,"UP_Aroon");
   SetIndexLabel(1,"DOWN_Aroon");
//the correction of the inadmissible value of Aroon_.Period
   if(Aroon_Period<1) Aroon_Period=1;
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+ 
//| Aroon iteration function                                         |
//+------------------------------------------------------------------+ 
int start()  
  {
   int MaxBar=Bars-Aroon_Period-1;
//checking a quantity of bars to the sufficiency for the calculation
   if (MaxBar<0)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
   int limit,bar,highest,lowest,counted_bars=IndicatorCounted();  
//checking to the possible errors
   if (counted_bars<0)return(-1);
//the last calculated bar must be converted
   if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
   limit=Bars-counted_bars-1; 
//initialization of zero
   if(limit>MaxBar)
     {
      limit=MaxBar;
      for(bar=Bars-1;bar>=MaxBar;bar--) UpBuffer[bar]=0.0;
      for(bar=Bars-1;bar>=MaxBar;bar--) DnBuffer[bar]=0.0;
     } 
//THE CALCULATION OF THE INDICATOR
   for( bar=limit; bar<=0; bar--)
     {
  	   highest = Highest(NULL,0,MODE_HIGH,Aroon_Period,bar);  
  	   lowest  = Lowest (NULL,0,MODE_LOW, Aroon_Period,bar);	
      //----
      UpBuffer[bar]=100+(100/Aroon_Period)*(bar-highest);          
      DnBuffer[bar]=100+(100/Aroon_Period)*(bar-lowest );           
     }
   return(0);
  }
//+------------------------------------------------------------+ 
