//redaktirovano and are corrected 17.04.2006 Nikolai kositsin
/*
For the work of indicator should be placed the files
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.experts\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                          BrainTrend2StopLine.mq4 |
//|                               Copyright ? 2005, BrainTrading Inc |
//|                                      http://www.braintrading.com |
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2005, BrainTrading Inc."
#property link      "http://www.braintrading.com"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 2
//the color of the indicator
#property indicator_color1 Blue
#property indicator_color2 Red
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//indicator buffery
double Ind_Buffer1[];
double Ind_Buffer2[];
//----
bool   river=True,RIVER;
int    artp,glava,p,Curr,f,s,time2,GLAVA;
double Weight,r,r1,Range1,value3,spread,EMAXTRA,VALUES[1];
double cecf,Emaxtra,widcha,TR,TR1,TR2,Values[1],ATR,low,high,Series1;
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| BrainTrend2StopLine initialization function                      |
//+------------------------------------------------------------------+ 
int init()
  {
//indicator 0
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexEmptyValue(0,0.0);
//indicator 1
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Ind_Buffer2);
   SetIndexEmptyValue(1,0.0);
//names for the windows of data and leyby for sub"okon
   string short_name;
   short_name="BrainTrend2StopLine";
   IndicatorShortName(short_name);
   SetIndexLabel(0,""+short_name+"_BUY");
   SetIndexLabel(1,""+short_name+"_SELL" );
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(Digits);
//the installation of Alerts at the inadmissible values of the inputparameters
   PriceSeriesAlert(Input_Price_Customs);
//----   
   spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;
   cecf=0.7;artp=7;s=2;f=10;
//----  
   ArrayResize( Values, artp);
   ArrayResize( VALUES, artp);
//----
   return(0);
  }
//+------------------------------------------------------------------+ 
//| BrainTrend2StopLine iteration function                           |
//+------------------------------------------------------------------+ 
int start() 
{
//checking a quantity of bars to the sufficiency for the calculation
if (Bars < 11)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int limit,MaxBar,bar,J,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of all bars
MaxBar=Bars-3;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion only of new bars
limit=(Bars-1-counted_bars);
//initialization of zero
if(limit>=MaxBar)
 {
  limit = MaxBar;
  Emaxtra = PriceSeries(Input_Price_Customs,limit+1);
  glava=0;
  double T_Series2=PriceSeries(Input_Price_Customs,limit+2);
  double T_Series1=PriceSeries(Input_Price_Customs,limit+1);
  if(T_Series2 > T_Series1) river = True; else river = False;
  for (int ii=Bars-1; ii>MaxBar;ii--)
   { 
    Ind_Buffer1[ii]=0.0;
    Ind_Buffer2[ii]=0.0;
   }
 } 
//----
//--- the restoration of the values of variable ================
int Tnew=Time[limit+1];
if (limit<MaxBar)
 if (Tnew==time2)
   {
    for(int xx=0;xx<=artp-1;xx++)Values[xx]=VALUES[xx];
    glava=GLAVA;
    Emaxtra=EMAXTRA;
    river = RIVER;
   }  
 else
  {
   if (Tnew>time2)
Print("Owibka restoration of variables!!! Tnew time2");
Else Print("Owibka Restoration of variables!!! Tnew
Print("Budet is produced the conversion of indicator on all bars!");
   return(-1);  
  }
//+--- +==================================================+
//--- the basic cycle of the calculation of the indicator
bar=limit;
while(bar>=0)      
   {  
//--- the retention of the values of variable =============
      if (bar==1)
         if(((limit==1)&&(time2!=Time[2]))||(limit>1))
           {
            for(int kk=0;kk<=artp-1;kk++)VALUES[kk]=Values[kk];
            GLAVA=glava;
            EMAXTRA=Emaxtra;
            RIVER=river;
            time2=Time[2];
           }
      //+---+============================================+
      low=Low [bar];
      high=High[bar];
      Series1=PriceSeries(Input_Price_Customs,bar + 1);
      TR  = spread + high - low;
      TR1 = spread + high - Series1;
      TR2 = low - Series1;
      if (MathAbs(TR1) > TR) TR = MathAbs(TR1);
      if (MathAbs(TR2) > TR) TR = MathAbs(TR2);
      if (bar == MaxBar) for (J = 0; J<=artp - 1; J++)  Values[J] = TR;
      Values[glava] = TR;
      ATR = 0;
      Weight = artp;
      Curr = glava;
      for (J = 0; J<=artp - 1; J++) 
         {
         ATR += Values[Curr] * Weight;
         Weight -= 1;
         Curr -= 1;
         if (Curr == -1) Curr = artp - 1;
         }
      ATR = 2.0 * ATR / (artp * (artp + 1.0));
      glava += 1;
      if (glava == artp) glava = 0;
      widcha = cecf * ATR;
      if (river && low < Emaxtra - widcha) 
         {
         river = False;
         Emaxtra = spread + high;
         }
      if (!river && spread + high > Emaxtra + widcha) 
         {
         river = True;
         Emaxtra = low;
         }
      if (river && low > Emaxtra) Emaxtra = low;
 
      if (!river && spread + high < Emaxtra)Emaxtra = spread + high;
      Range1 = (iATR(NULL,0,10,bar)+spread/10.0)* s ;
      if (river) 
         {
         if (low - Range1 < r && r != 0)  r1 = r; else r1 = low - Range1  / 3.0;
         if (p == 2) r1 = low - Range1 / 3.0;
         Ind_Buffer1[bar]=r1;
         Ind_Buffer2[bar]=0; 
         r = r1;
         p = 1;
         } 
      else 
         {
         if (spread + high + Range1 > r && r != 0) r1 = r; else r1 = spread + high + Range1 / 3.0;
         if (p == 1) r1 = spread + high + Range1 / 3.0;
         Ind_Buffer1[bar]=0;
         Ind_Buffer2[bar]=r1; 
         r = r1;
         p = 2;
         }
      bar--;
  }       
//----
return(0);     
}
//+-------------------------------------------------------+

