//+------------------------------------------------------------------+
//|                                                Price Channel.mq4 |
//|                                                                  |
//|                                       http://forex.kbpauk.ru/    |
//+------------------------------------------------------------------+
#property link      "http://forex.kbpauk.ru/"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of indicator bufferov
#property indicator_buffers 3
//the color of the indicator
#property indicator_color1 Lime
#property indicator_color2 Blue
#property indicator_color3 Red
//the style of lines Bollinger Bands
#property indicator_style1 4
#property indicator_style2 2
#property indicator_style3 4
//THE INPUT PARAMETERS OF THE INDICATOR OF----------------------------
extern int ChannelPeriod=14;///the period of the indicator
extern int Shift = 0; //cdvig indicator along the time axis
//---- +--------------------------------------------------------+
//indicator buffery
double UpBuffer[];
double DnBuffer[];
double MdBuffer[];
//+------------------------------------------------------------------+
//| Price Channel initialization function                            |
//+------------------------------------------------------------------+
int init()
  {
//the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
//the determination of the style of the performance of the graph
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
//3 indicator buffera are used for the calculation
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,MdBuffer);
   SetIndexBuffer(2,DnBuffer);
//name for the windows of data and leyba for sub"okon
   string short_name="Price Channel("+ChannelPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Up Channel");
   SetIndexLabel(1,"Middle Channel");
   SetIndexLabel(2,"Down Channel");
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0,ChannelPeriod+Shift);
   SetIndexDrawBegin(1,ChannelPeriod+Shift);
   SetIndexDrawBegin(2,ChannelPeriod+Shift);
//the horizontal shift of the indicator line
   SetIndexShift (0, Shift); 
   SetIndexShift (1, Shift);
   SetIndexShift (2, Shift);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+
//| Price Channel                                                    |
//+------------------------------------------------------------------+
int start()
  {
//checking a quantity of bars to the sufficiency for the calculation
   if(Bars<=ChannelPeriod)return(0);
//the introduction of variables with the floating point
double high,low,price;
//the introduction of entire variables and obtaining the alreadycalculated bars
int bar,kk,counted_bars=IndicatorCounted(); 
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//initialization of zero
if(counted_bars<1)for(bar=1;bar<=ChannelPeriod;bar++) 
     {
      UpBuffer[Bars-bar]=0.0;
      DnBuffer[Bars-bar]=0.0;
      MdBuffer[Bars-bar]=0.0;
     }
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
bar=Bars-ChannelPeriod-1;
if(counted_bars>=ChannelPeriod) bar=Bars-counted_bars-1;
//the basic cycle of the calculation of the indicator
while(bar>=0)
     {
       high=High[bar]; 
       low=Low[bar]; 
       kk=bar-1+ChannelPeriod;
       //----
       while(kk>=bar)
        {
         price=High[kk];
         if(high<price) high=price;
         price=Low[kk];
         if(low>price)  low=price;
         kk--;
        } 
       UpBuffer[bar]=high;
       DnBuffer[bar]=low;
       MdBuffer[bar]=(high+low)/2;
       bar--;
     }
return(0);
  }
//+-----------------------------------------------------------------------------+
