/*
For the work of indicator should be placed the file
JJMASeries.mqh
in the folder (directory): MetaTrader\.experts\.include \
*/
//------------------------------------------------------------------
//| JPrice Channel.mq4 |
//| |
//| http://forex.kbpauk.ru/ |
//------------------------------------------------------------------
# property link "http://forex.kbpauk.ru/"
// otrisovka of indicator in the main window
#property indicator_chart_window 
// a quantity of the indicator buffers
#property indicator_buffers 3
// the color of the indicator
#property indicator_color1 Lime
#property indicator_color2 Magenta
#property indicator_color3 Red
// the style of lines Bollinger Bands
#property indicator_style1 4
#property indicator_style2 2
#property indicator_style3 4
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Channel_.Period = 14; //the period of the channel
extern int Smooth = 8; //the depth of the smoothing of the centerline
extern int Smooth_.Phase = y00;// the parameter of smoothing, which ischanged within limits of -100... 100, influence the quality oftransient process;
extern int Ind_.Shift = 0; //cdvig indicator along the time axis
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double UpBuffer[];
double DnBuffer[];
double MdBuffer[];
//------------------------------------------------------------------
// introduction to function JJMASeries
// introduction to function JJMASeriesResize
// introduction to function JJMASeriesAlert
// introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//------------------------------------------------------------------
//| Price Channel initialization function |
//------------------------------------------------------------------
int init()
  {
   string short_name;
// the styles of the image of the indicator
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
// 3 indicator buffers are used for the calculation
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,MdBuffer);
   SetIndexBuffer(2,DnBuffer);
// the horizontal shift of the indicator lines
   SetIndexShift (0, Ind_Shift); 
   SetIndexShift (1, Ind_Shift); 
   SetIndexShift (2, Ind_Shift); 
// name for the windows of data and leyba for sub"okon
   short_name="Price Channel("+Channel_Period+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Up Channel");
   SetIndexLabel(1,"Middle Channel");
   SetIndexLabel(2,"Down Channel");
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0,Channel_Period);
   SetIndexDrawBegin(1,Channel_Period+30);
   SetIndexDrawBegin(2,Channel_Period);
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
// a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
   if (JJMASeriesResize(1)!=1)return(-1);
// the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"Channel_Period",Channel_Period);
   JJMASeriesAlert (0,"Smooth",Smooth);
   JJMASeriesAlert (1,"(Smooth_Phase", Smooth_Phase);
// korektsiya of the inadmissible value of parameter Channel_.Period
   if(Channel_Period<1)Channel_Period=1; 
// the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
// the completion of the initialization
   return(0);
  }
//------------------------------------------------------------------
//| Price Channel iteration function |
//------------------------------------------------------------------
int start()
  {
// checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=Channel_Period)return(0);
// the introduction of variables with the floating point
double high,low,price,Temp_Series,Resalt;
// the introduction of entire variables and obtaining the alreadycalculated bars
int limit,reset,MaxBar,bar,ii,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1;MaxBar=Bars-1-Channel_Period;
// korektsiya of the starting raschetogo bar in the cycle
// initialization of zero
if (limit>=MaxBar)
    {
     for(bar=limit;bar>=MaxBar;bar--)
      {
       UpBuffer[bar]=0.0;    
       DnBuffer[bar]=0.0;
       MdBuffer[bar]=0.0;
      }
     limit=MaxBar;
    }
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
bar=limit;
while(bar>=0)
  {
      high=High[bar]; low=Low[bar]; 
      ii=bar-1+Channel_Period;
      while(ii>=bar)
        {
         price=High[ii];
         if(high<price)high=price;
         price=Low[ii];
         if(low>price) low=price;
         ii--;
        } 
     UpBuffer[bar]=high;
     DnBuffer[bar]=low;
     Temp_Series=(high+low)/2;
     
// turning to function JJMASeries after to numbers 0. ParametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
    Resalt=JJMASeries(0,0,MaxBar,limit,Smooth_Phase,Smooth,Temp_Series,bar,reset);
// checking to the absence of error in the previous operation
    if(reset!=0)return(-1);
    MdBuffer[bar]=Resalt;
     
      bar--;
  }
return(0);
 }
//------------------------------------------------------------------

