/*
For the work of indicator should be placed the files
T3Series.mqh
PriceSeries.mqh
GetDigVelue.mqh
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#..mq4
in the folder (directory): MetaTrader\.indicators \
*/
//------------------------------------------------------------------
//| T3.6DigBollinger Bands.mq4 |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
// otrisovka of indicator in the main window
#property indicator_chart_window 
// a quantity of the indicator buffers
#property indicator_buffers 7
// the color of the indicator
#property indicator_color1 Gray 
#property indicator_color2 Red
#property indicator_color3 Blue 
#property indicator_color4 Lime
#property indicator_color5 Blue
#property indicator_color6 Red
#property indicator_color7 Gray 
// the style of the lines of the indicator
#property indicator_style1 4
#property indicator_style2 2
#property indicator_style3 4
#property indicator_style4 4
#property indicator_style5 4
#property indicator_style6 2
#property indicator_style7 4
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Bands_.Period = 100; //the period of averaging J2BollingerBands
extern double Bands_.Deviations = 2.0; //deviatatsiya
extern int MA_.method = 0; //the method of the averaging
extern int MA_.Smooth = 20; //the depth of the smoothing of thatobtained Moving Avereges
extern int Bands_.Smooth = 20; //the depth of the smoothing of thoseobtained Bollinger Bands
extern int Smooth_.Curvature = 100; //the parameter of smoothing,which is changed within limits of -100... 100, influence the qualityof transient process;
extern int Step = 6; //the parameter, the opredelyashchiy size of thefluctuations of those taken for flet or step of the discreteness
extern int Bands_.Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
TO //(0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH, Y0-0.SHCH*.TRENDFOLLOSH,
//yy-.Yueiken Ashi High, y2-.Yueiken Ashi Low, ye-.Yueiken Ashi Open,yya-.Yueiken Ashi Close.)
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double UpperBuffer3  [];
double UpperBuffer2  [];
double UpperBuffer1  [];
double T3MovingBuffer[];
double LowerBuffer1  [];
double LowerBuffer2  [];
double LowerBuffer3  [];
double Series_buffer [];
// constant with the floating point
double Norma;
//------------------------------------------------------------------
// introduction to function T3Series
// introduction to function T3SeriesResize
// introduction to function T3SeriesAlert
// introduction to function T3_.ErrDescr
#include <T3Series.mqh> 
//------------------------------------------------------------------
// introduction to function PriceSeries
// introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//------------------------------------------------------------------
// introduction to function GetDigVelue
#include <GetDigVelue.mqh>
//------------------------------------------------------------------
//| T3.6Bollinger Bands initialization function |
//------------------------------------------------------------------
int init()
  {
// the determination of the style of the performance of the graph
   SetIndexStyle(0,DRAW_LINE); 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE); 
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE); 
   SetIndexStyle(6,DRAW_LINE);
// 4 indicator buffers are used for the calculation
   IndicatorBuffers(8);
   SetIndexBuffer(0,UpperBuffer3 );
   SetIndexBuffer(1,UpperBuffer2 );
   SetIndexBuffer(2,UpperBuffer1 );
   SetIndexBuffer(3,T3MovingBuffer);
   SetIndexBuffer(4,LowerBuffer1 );
   SetIndexBuffer(5,LowerBuffer2 );
   SetIndexBuffer(6,LowerBuffer3 );
   SetIndexBuffer(7,Series_buffer);
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
   SetIndexEmptyValue(3,0);
   SetIndexEmptyValue(4,0);
   SetIndexEmptyValue(5,0);
   SetIndexEmptyValue(6,0);
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int drawbegin=100+Bands_Shift;
   SetIndexDrawBegin(0,drawbegin);
   SetIndexDrawBegin(1,drawbegin);
   SetIndexDrawBegin(2,drawbegin);
   SetIndexDrawBegin(3,drawbegin);
   SetIndexDrawBegin(4,drawbegin);
   SetIndexDrawBegin(5,drawbegin);
   SetIndexDrawBegin(6,drawbegin);
// the horizontal shift of the indicator lines
   SetIndexShift (0, Bands_Shift); 
   SetIndexShift (1, Bands_Shift); 
   SetIndexShift (2, Bands_Shift); 
   SetIndexShift (3, Bands_Shift); 
   SetIndexShift (4, Bands_Shift); 
   SetIndexShift (5, Bands_Shift); 
   SetIndexShift (6, Bands_Shift); 
// name for the windows of data and leyba for sub"okon
   IndicatorShortName ("T3.4Bollinger Bands( Period="+Bands_Period+", Deviations="+Bands_Deviations+")"); 
   SetIndexLabel (0, "Upper3 Bands");
   SetIndexLabel (1, "Upper2 Bands");
   SetIndexLabel (2, "Upper1 Bands"); 
   SetIndexLabel (4, "Lower1 Bands"); 
   SetIndexLabel (5, "Lower2 Bands"); 
   SetIndexLabel (6, "Lower3 Bands"); 
   string Moving;
   switch(MA_method)
           {
            case  0: Moving= "T3SMA";break;
            case  1: Moving= "T3EMA";break;
            case  2: Moving="T3SSMA";break;
            case  3: Moving="T3LWMA";break;
            default: Moving="T3SMA";
           }
   SetIndexLabel (3, "Moving Avereges "+Moving+" ("+Bands_Period+")");
// the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
// a change in the sizes of the buffer variables of function T3Series,nT3.number=7(Sem6 turnings to function T3Series)
   if (Bands_Smooth<=1){if (T3SeriesResize(1)!=1)return(-1);}else if (T3SeriesResize(7)!=7)return(-1);
// the installation of Alerts at the inadmissible values of theexternal variables
   T3SeriesAlert(0,"MA_Smooth",MA_Smooth);
   T3SeriesAlert(0,"Bands_Period",Bands_Period);
   PriceSeriesAlert(Input_Price_Customs);
   if((MA_method<0)||(MA_method>3))
          Alert("???????? MA_method ?????? ???? ?? 0 ?? 3" + " ?? ????? ???????????? " 
                                                                +MA_method+ " ????? ???????????? 0");
// korektsiya of the inadmissible value of parameter Bands_.Period
   if(Bands_Period<1)Bands_Period=1; 
// the initialization of the constants
   Norma=Step*Point;
// the completion of the initialization
   return(0);
  }
//------------------------------------------------------------------
//| T3.6Bollinger Bands iteration function |
//------------------------------------------------------------------
int start()
  {
// checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=Bands_Period) return(0);
// the introduction of variables with the floating point
double deviation1,deviation2,deviation3,Temp_Series,sum,midline,priceswing,Resalt;
// the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,MaxBarBB,MaxBarBB1,bar,kk,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
// (without this conversion for counted_.bars function T3Series it willwork incorrectly!!!)
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Bars-counted_bars-1;MaxBar=Bars-1-Bands_Period;MaxBarBB=MaxBar-30-Bands_Period;MaxBarBB1=MaxBarBB-1;
// the load of input prices into the buffer for the calculation
for(bar=limit;bar>=0;bar--)Series_buffer[bar]=PriceSeries(Input_Price_Customs,bar);
// checking bar to the sufficiency for calculation Bollinger Bands
// initialization of zero
if (limit>MaxBar)
     {
      for(bar=limit;bar>=MaxBar;bar--)T3MovingBuffer[bar]=0;
      limit=MaxBar;
     }
// the cycle of calculation Moving Avereges
for(bar=limit;bar>=0;bar--)
  {
// formula for calculation Moving Avereges
   Temp_Series=iMAOnArray(Series_buffer,0,Bands_Period,0,MA_method, bar);
// the smoothing of that obtained Moving Avereges
// turning to function T3Series after number 0. ParametersnT3.Curvature and nT3.Length do not change on each bar (nT3.din=0)
   midline=T3Series(0,0,MaxBar,limit,Smooth_Curvature,MA_Smooth,Temp_Series,bar,reset);
// checking to the absence of error in the previous operation
   if(reset!=0)return(-1);     
   T3MovingBuffer[bar]=GetDigVelue(Norma,midline);    
// CALCULATION Bollinger Bands
// initialization of zero
   if (bar>MaxBarBB)
      {
       UpperBuffer2[bar]=0;
       UpperBuffer1[bar]=0;
       LowerBuffer1[bar]=0;
       LowerBuffer2[bar]=0;
       continue;
      }
//
   sum=0.0;
   kk=bar+Bands_Period-1;
   while(kk>=bar)
      {
       priceswing=PriceSeries(Input_Price_Customs,kk)-midline;
       sum+=priceswing*priceswing;
       kk--;
      }
   deviation2=Bands_Deviations*MathSqrt(sum/Bands_Period);     
   deviation1=0.5*deviation2;
   deviation3=1.5*deviation2;
   if (Bands_Smooth>1)
      {
// calculation and T3 smoothing Bollinger Bands
//----------------------------------------------------------------------------------------
// four parallel turnings to function T3Series after numbers 1, 2, 3,4, 5, 6.
// parameters nT3.Length not menya.ttsya on each bar (nT3.din=0)
//----------------------------------------------------------------------------------------
         Resalt=T3Series(1,0,MaxBarBB1,limit,Smooth_Curvature,Bands_Smooth ,midline+deviation3,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         UpperBuffer3[bar]=GetDigVelue(Norma,Resalt);  
//----------------------------------------------------------------------------------------
         Resalt=T3Series(2,0,MaxBarBB1,limit,Smooth_Curvature,Bands_Smooth ,midline+deviation2,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         UpperBuffer2[bar]=GetDigVelue(Norma,Resalt); 
//----------------------------------------------------------------------------------------
         Resalt=T3Series(3,0,MaxBarBB1,limit,Smooth_Curvature,Bands_Smooth ,midline+deviation1,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         UpperBuffer1[bar]=GetDigVelue(Norma,Resalt); 
//----------------------------------------------------------------------------------------
         Resalt=T3Series(4,0,MaxBarBB1,limit,Smooth_Curvature,Bands_Smooth ,midline-deviation1,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         LowerBuffer1[bar]=GetDigVelue(Norma,Resalt); 
//----------------------------------------------------------------------------------------
         Resalt=T3Series(5,0,MaxBarBB1,limit,Smooth_Curvature,Bands_Smooth ,midline-deviation2,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         LowerBuffer2[bar]=GetDigVelue(Norma,Resalt); 
//----------------------------------------------------------------------------------------
         Resalt=T3Series(6,0,MaxBarBB1,limit,Smooth_Curvature,Bands_Smooth ,midline-deviation3,bar,reset);
// checking to the absence of error in the previous operation
         if(reset!=0)return(-1); 
         LowerBuffer3[bar]=GetDigVelue(Norma,Resalt);       
//----------------------------------------------------------------------------------------
      }
   else 
      {
// calculation Bollinger Bands without T3 smoothing
         UpperBuffer3[bar]=GetDigVelue(Norma,midline+deviation3);  
         UpperBuffer2[bar]=GetDigVelue(Norma,midline+deviation2); 
         UpperBuffer1[bar]=GetDigVelue(Norma,midline+deviation1); 
         LowerBuffer1[bar]=GetDigVelue(Norma,midline-deviation1); 
         LowerBuffer2[bar]=GetDigVelue(Norma,midline-deviation2); 
         LowerBuffer3[bar]=GetDigVelue(Norma,midline-deviation3);  
      }
      
   }
// the completion of the calculations of the values of the indicator
   return(0);
  }
//-------------------------------------------------------------------------------------


