//redaktirovano and are corrected 1.07.2006 Nikolai kositsin
/*
For the work of indicator should be placed the files
JMASeries.mqh
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.experts\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                        AMAJ2.mq4 | 
//|                             Copyright ? 2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1
//the color of the indicator
#property indicator_color1 Red
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int AMA_.Period = ";//period AMA
extern int nfast = 3; //the minimum value of period AMA
extern int nslow = e0;///the mmaksimal'noye value of period AMA
extern double                G = 2.0;// 
extern int Phase = 0; //the parameter, which is changed within limitsof -100... 100, influence the quality of transient process;
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double JkAMAbuffer[];
int period_Swing;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| AMAJ2 initialization function                                    |
//+------------------------------------------------------------------+ 
int init()
  {
//the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
//the determination of the style of the performance of the graph
   SetIndexStyle(0,DRAW_LINE);
//1 indicator buffer is used for the calculation
   SetIndexBuffer(0,JkAMAbuffer); 
//the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"AMA_Period",AMA_Period);
   JJMASeriesAlert (1,"Phase", Phase);
   PriceSeriesAlert(Input_Price_Customs);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=3(Tri turning to function JJMASeries)
   if (JJMASeriesResize(3)!=3)return(-1);
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0.0); 
//----  
   period_Swing=nslow-nfast;
//----
   return(0);
  }
//+------------------------------------------------------------------+ 
//| AMAJ2 iteration function                                         |
//+------------------------------------------------------------------+ 
int start()
  {
//checking a quantity of bars to the sufficiency for the calculation
if (Bars<AMA_Period+nslow)return(0);
double noise,AMA,signal,ER,NR,NRG,Price,Resalt;
//the introduction of entire variables and obtaining the alreadycalculated bars
int limit,reset,MaxBar1,MaxBar2,MaxBar3,bar,Length,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar1=Bars-AMA_Period-nslow;
MaxBar2=MaxBar1-30;
MaxBar3=MaxBar2-30;
bar=Bars-counted_bars-1; 
if(limit>MaxBar1)limit=MaxBar1;
limit=bar;
//the basic cycle
while (bar>=0)
     {
//the calculation of the effectiveness ratio of Kauffmann ER
      noise=Point/100000;
      for(int jj=0;jj<AMA_Period;jj++)
                noise=noise+MathAbs(PriceSeries(Input_Price_Customs,bar+jj)-PriceSeries(Input_Price_Customs,bar+jj+1));
      signal=MathAbs(PriceSeries(Input_Price_Customs,bar)-PriceSeries(Input_Price_Customs,bar+AMA_Period));
      ER=signal/noise;
      ER=JJMASeries(0,0,MaxBar1,limit,100,10,ER,bar,reset);
//the calculation of the depth of the smoothing
      NR=1-ER;
      NRG=MathPow(NR, G); 
      Length=nfast+NRG*period_Swing;
      //---- 
      Price=PriceSeries(Input_Price_Customs,bar);
//the turning to function JJMASeries after number 0, parameternJMA.Length change on each bar (nJMA.din=1)
      Resalt=JJMASeries(1,1,MaxBar2,limit,Phase,Length,Price,bar,reset);
//checking to the absence of error in the previous operation
      if(reset!=0)return(-1);
//the turning to function JJMASeries after number 0, parameternJMA.Length change on each bar (nJMA.din=1)
      Resalt=JJMASeries(2,1,MaxBar3,limit,Phase,Length, Resalt,bar,reset);
//checking to the absence of error in the previous operation
      if(reset!=0)return(-1);
      JkAMAbuffer[bar]=Resalt;
      bar--;
     }
//----
   return(0);
  }
//+--------------------------------------------------------------------------+

