//redaktirovano and are corrected 1.07.2006 Nikolai kositsin
/*
For the work of indicator should be placed the files
JMASeries.mqh
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.experts\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                         JAMA.mq4 | 
//|                         JAMA: Copyright ? 2006, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1
//the color of the indicator
#property indicator_color1 Red
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int period_.AMA = y0;//period AMA
extern int nfast = 3; //the minimum value of period AMA
extern int nslow = e0;///the mmaksimal'noye value of period AMA
extern double G = of y.0;///the degree, into which is raised smoothingout konsttanta
extern int Length = 5; //the depth of the smoothing
extern int Phase = 0; //the parameter, which is changed within limitsof -100... 100, influence the quality of transient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double JkAMAbuffer[];
//the introduction of constants with the floating point
double dSC,slowSC,fastSC,Resalt;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+   
//| JAMA initialization function                                     |
//+------------------------------------------------------------------+ 
int init()
  {
//the determination of the style of the performance of the graph
   SetIndexStyle (0,DRAW_LINE); 
//1 indicator buffer is used for the calculation
   SetIndexBuffer(0,JkAMAbuffer); 
//the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"Length",Length);
   JJMASeriesAlert (1,"Phase", Phase);
   PriceSeriesAlert(Input_Price_Customs);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
   if (JJMASeriesResize(1)!=1)return(-1);
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0.0); 
//the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
//the horizontal shift of the indicator line
   SetIndexShift (0, Shift); 
//name for the windows of data and leyba for sub"okon
   IndicatorShortName ("JAMA( period_AMA="+period_AMA+", G="+G+", Length="+Length+")"); 
   SetIndexLabel (0, "JAMA");  
//----  
   slowSC=(2.0 /(nslow+1));
   fastSC=(2.0 /(nfast+1)); 
   dSC=fastSC-slowSC; 
//----
   return(0);
  }
//+------------------------------------------------------------------+ 
//| JAMA iteration function                                          |
//+------------------------------------------------------------------+ 
int start()
  {
//checking a quantity of bars to the sufficiency for the calculation
if (Bars<period_AMA+2)return(0);
//the introduction of variables with the floating point
double noise,AMA,signal,ER,ERSC,SSC,Resalt;
//the introduction of entire variables and obtaining the alreadycalculated bars
int limit,reset,MaxBar,bar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-period_AMA-2;
bar=Bars-counted_bars-1; 
//initialization of zero
if (bar>MaxBar)
      {
       for (int ii=bar; ii>MaxBar;ii--)JkAMAbuffer[ii]=0.0;
       bar=MaxBar;
       AMA=PriceSeries(Input_Price_Customs,bar + 1);
      }
else AMA=JkAMAbuffer[bar+1];
limit=bar;
//the basic cycle
while (bar>=0)
     {
      noise=Point/100000;
      for(int jj=0;jj<period_AMA;jj++)
                noise=noise+MathAbs(PriceSeries(Input_Price_Customs,bar+jj)-PriceSeries(Input_Price_Customs,bar+jj+1));
      signal=MathAbs(PriceSeries(Input_Price_Customs,bar)-PriceSeries(Input_Price_Customs,bar+period_AMA));
      ER =signal/noise;
      ERSC=ER*dSC;
      SSC=ERSC+slowSC;
      AMA=AMA+(MathPow(SSC,G)*(Close[bar]-AMA));
//JMA the smoothing of the obtained indicator
//the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
      Resalt=JJMASeries(0,0,MaxBar,limit,Phase,Length,AMA,bar,reset);
//checking to the absence of error in the previous operation
      if(reset!=0)return(-1);
      JkAMAbuffer[bar]=Resalt;
      bar--;
     }
//----
   return(0);
  }
//+--------------------------------------------------------------+

