/*
For the work of indicator should be placed the files
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
JJMA.mq4
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                     JJMA_htf.mq4 |
//|                             Copyright ? 2005, GS  Convrsion only |
//|                    http://www.gustis.narod.ru;     gsb51@mail.ru |
//+------------------------------------------------------------------+ 
#property copyright "  Copyright ? 2005, GS  Convrsion only"
#property link      " http://www.gustis.narod.ru;  gsb51@mail.ru"
//otrisovka of indicator in the basic window
#property indicator_chart_window
//a quantity of the indicator buffers
#property indicator_buffers  1
//the color of the indicator
#property indicator_color1 Red
//the thickness of the indicator line
#property indicator_width1 3
//the thickness of the indicator line
#property indicator_style1 0
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Length = 5; //the depth of the smoothing
extern int Phase = 100; //the parameter of smoothing, which is changedwithin limits of -100... 100, influence the quality of transientprocess;
extern int Shift = 0; //cdvig indicator along the time axis
extern int TFrame_.Period=240; //elder period in the minutes
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
datetime TFrame_Times[]; 
//the indicator buffers
double Ind_Buffer[];
//----
int NTF,time1;
//+------------------------------------------------------------------+ 
//| JJMA_htf initialization function                                 | 
//+------------------------------------------------------------------+ 
int init() 
  { 
//the indicators of ----------------------------------------------

//the style of the performance of graph in the form of that broken
   SetIndexStyle(0,DRAW_SECTION);
//the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
   SetIndexShift(0, Shift); 
   SetIndexLabel(0,"JJMA_htf");
   SetIndexBuffer(0,Ind_Buffer); 
   SetIndexEmptyValue(0,0.0); 
   NTF=TFrame_Period/Period();  
//the Alerts of ------------------------------------------------
   if (TFrame_Period !=1 && TFrame_Period !=5 && TFrame_Period !=15 && TFrame_Period !=30 && TFrame_Period !=60 && TFrame_Period !=240 && TFrame_Period !=1440 && TFrame_Period != 10080)
      { 
Alert(".Chart", Symbol(), "parameter TimeFrame_.period can be onlyfollowing: 1, 5, 15, 30, 60, 240, 1440, 7200, y0080.\.n "
"indicator will use the current period of graph");
       TFrame_Period=Period();
      }

   if (Period()>= TFrame_Period) 
      {
       TFrame_Period = Period();
Alert("Parametr TimeFrame_.period Must be more than the period ofgraph! Indicator will use the current period of graph");
      }
     
//-------------------------------------------------------------------- 
//everything Time[ ] series of time are sorted out in the direction ofthe decrease
   ArrayCopySeries(TFrame_Times,MODE_TIME,Symbol(),TFrame_Period); 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| JJMA_htf iteration function                                      | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int MaxBar,bar,MaxBarTF,TFbar,start_bar;
   //----
   MaxBar=Bars-1; 
   //----
   MaxBarTF=MathFloor(MaxBar/NTF);
//the search for the last neposchitannogo bar
   if (time1!=0)
       {
        TFbar=iBarShift(NULL,TFrame_Period,time1,true);
        if (TFbar<0)
          {
           TFbar=MaxBarTF;
Print("Terminal recently was connected to the Internet. The number ofthe last neposchitannogo bar is not found!");
Print("Budet is produced the conversion of indicator on all bars");
          }
       }
   else TFbar=MaxBarTF;
//initialization of zero
   if (TFbar>=MaxBarTF)
    {
     start_bar=iBarShift(NULL,0,TFrame_Times[TFbar],false);
     for(bar=MaxBar;bar>start_bar;bar--)Ind_Buffer[bar]=0;  
     TFbar=MaxBarTF;
    }
//the retention of the time of the discovery last neposchitannogobpra
   time1=TFrame_Times[1]; 
//preliminary nitsializatsiya with all zero neposchitannykh values ofthe indicator
   start_bar=iBarShift(NULL,0,TFrame_Times[TFbar],false);
   for(bar=start_bar;bar>=0;bar--)Ind_Buffer[bar]=0; 
   
//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
   while(TFbar>=-1)  
      {  
        bar=iBarShift(NULL,0,TFrame_Times[TFbar],true)+1; 
        Ind_Buffer[bar]=iCustom(NULL,TFrame_Period,"JJMA",Length,Phase,0,Input_Price_Customs,0,TFbar+1);
        TFbar--;
      }      
//the completion of the calculations of the values of the indicator
    return(0);
  }
//----+ +-------------------------------------------------------+
