/*
For the work of indicator should be placed the files
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                             JMoving Avereges.mq4 | 
//|         JMoving Avereges: Copyright ? 2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Red 
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int MA_.period = 8; //the depth of the first smoothing
extern int MA_.method = 0; //the method of the averaging
extern int Smooth = 8; //the depth of the smoothing
extern int Smooth_.Phase = y00;///the parameter of smoothing, which ischanged within limits of -100... 100, influence the quality oftransient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Series_buffer[];
double JMovingBuffer[];
//variables with the floating point
double Temp_Series,Resalt;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JMoving Avereges initialization function                         | 
//+------------------------------------------------------------------+  
int init() 
{  
//the determination of the style of the performance of the graph
SetIndexStyle (0,DRAW_LINE); 
//2 indicator buffers of ispol'zovan.s for the calculation
IndicatorBuffers(2);
SetIndexBuffer(0,JMovingBuffer);
SetIndexBuffer(1,Series_buffer);
//the horizontal shift of the indicator line
SetIndexShift (0, Shift);  
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0); 
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("JMoving Avereges( MA_period="+MA_period+", MA_method="+MA_method+", Shift="+Shift+")"); 
SetIndexLabel (0, "JMoving Avereges"); 
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//a change in the sizes of the buffer variables of functionJLiteSeries, nJMAnumber=1(Odno turning to function JLiteSeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"MA_period",MA_period);
JJMASeriesAlert (0,"Smooth",Smooth);
JJMASeriesAlert (1,"Smooth_Phase",Smooth_Phase);
PriceSeriesAlert(Input_Price_Customs);
if(.MA_.method
"you introduced that not admitted" MA_.method "will be used 0");}
if(.MA_.method e){.Alert("Parametr MA_.method it must be from 0 to 3"
"you introduced that not admitted" MA_.method "will be used 0");}
PriceSeriesAlert(Input_Price_Customs);
//korektsiya of the inadmissible value of parameter MA_.period
if(MA_period<1)MA_period=1; 
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| JMoving Avereges iteration function                              | 
//+------------------------------------------------------------------+  
int start() 
{ 
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<MA_period+31)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,bar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
//(bez of this conversion for counted_.bars function JJMASeries willwork incorrectly!!!)
if (counted_bars>0)counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Bars-counted_bars-1; MaxBar=Bars-1-MA_period; 
//load into the buffer of the initial prices
for(bar=limit;bar>=0;bar--)Series_buffer[bar]=PriceSeries(Input_Price_Customs,bar);
//korektsiya of the starting raschetogo bar in the cycle
//initialization of zero
if (limit>MaxBar)
   {
    for(bar=limit;bar>=MaxBar;bar--)JMovingBuffer[bar]=0;
    limit=MaxBar;
   }

//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(bar=limit;bar>=0;bar--)
  {
//formula for calculating the indicator
  Temp_Series=iMAOnArray(Series_buffer,0,MA_period,0,MA_method, bar);
//the smoothing of that obtained Moving Avereges
//turning to function JJMASeries after number 0. ParametersnJJMA.Length and nJJMA.Phase not menya.ttsya on each bar(nJJMA.din=0)
  Resalt=JJMASeries(0,0,MaxBar,limit,Smooth_Phase,Smooth,Temp_Series,bar,reset);
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1);
  JMovingBuffer[bar]=Resalt; 
  }
//the completion of the calculations of the values of the indicator
return(0); 
} 

//+---------------------------------------------------------------+

