/*
//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+ 
//Version  July 1, 2006                                              |
Editing   Nikolay Kositsin  15.06.2006  farria@mail.redcom.ru        |
//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+ 
*/
//+------------------------------------------------------------------+ 
//|                                                       JVIDYA.mg4 |
//|                                Copyright ? 2000 Tushar S. Chande |
//|                                                                  |
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2000 Tushar S. Chande"
#property link ""
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Red 
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int VIDYA_.period = 9; //the period
extern int JMA_.Smooth = 6; //depth JMA of the smoothing
extern int JMA_.Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of transient process;
extern int Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-Price, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Price, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Price.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer[];
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+   
//| JVIDYA initialization function                                   |
//+------------------------------------------------------------------+  
int init()
{
//the style of the performance of the graph
SetIndexStyle(0,DRAW_LINE);
//1 indicator buffer is used for the calculation
SetIndexBuffer(0,Ind_Buffer);
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);
//name for the windows of data and leyba for sub"okon
IndicatorShortName("JVIDYA");
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
SetIndexDrawBegin(0,VIDYA_period+30); 
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1); 
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"VIDYA_period",VIDYA_period);
JJMASeriesAlert (0,"JMA_Smooth",JMA_Smooth);
JJMASeriesAlert (1,"JMA_Phase", JMA_Phase);
PriceSeriesAlert(Input_Price_Customs);
//the horizontal shift of the indicator line
SetIndexShift (0, Shift); 
//the completion of the initialization
return(0);
}
//+------------------------------------------------------------------+  
//| JVIDYA iteration function                                        |
//+------------------------------------------------------------------+  
int start()
{ 
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<VIDYA_period+31)return(0);
//the introduction of the variables of the memory
static int time2;static double VIDYA;
double UpSum,DnSum,Up,Dn,JVIDYA,Price,Price0,Price1,AbsCMO,SC,Vidya;
//the introduction of entire variables and obtaining the alreadycalculated bars
int bar,limit,MaxBar,reset,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of all bars
MaxBar = Bars-1-VIDYA_period;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1;
//initialization of zero
if(limit>=MaxBar)
  {
    limit=MaxBar;
    Vidya=PriceSeries(Input_Price_Customs, MaxBar);
    for(bar = Bars-1; bar >= MaxBar; bar--)Ind_Buffer[bar] = 0;    
  }
//--- the restoration of the values of variable ======
int Tnew=Time[limit+1];
if (limit<MaxBar)
  if (Tnew==time2)Vidya=VIDYA;
  else 
   {
if (Tnew time2).Print("Owibka restoration of variables. Tnew time2");
Else Print("Owibka Restoration of variables. Tnew
Print("Budet is produced the conversion of indicator on all bars");
    return(-1);  
   }
//+--- +==========================================+
  
//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for (bar=limit;bar>=0;bar--) 
 {
//--- the retention of the values of variable ====
   if (bar==1)
     if(((limit==1)&&(time2==Time[2]))||(limit>1))
       {
         time2=Time [2];
         VIDYA=Vidya;
       }
  //+---+====================================+     
  UpSum=0; 
  DnSum=0; 
  //---
  for (int iii=VIDYA_period;iii>=0;iii--) 
   {
     Up = 0; 
     Dn = 0; 
     Price0=PriceSeries(Input_Price_Customs, bar+iii);
     Price1=PriceSeries(Input_Price_Customs, bar+iii+1);
     if (Price0 > Price1)Up = Price0-Price1; 
     if (Price0 < Price1)Dn = MathAbs(Price0-Price1); 
     UpSum +=  Up; 
     DnSum +=  Dn; 
   } 
   //---
  if (UpSum+DnSum >0)AbsCMO=MathAbs((UpSum-DnSum)/(UpSum+DnSum));  
  Price0=PriceSeries(Input_Price_Customs, bar);
  Vidya=AbsCMO*Price0+(1-AbsCMO)*Vidya; 
//JMA the smoothing of the obtained indicator, parameter nJMA.MaxBaris reduced by the size of filter nf
//the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
  JVIDYA=JJMASeries(0,0,MaxBar,limit,JMA_Phase,JMA_Smooth,Vidya,bar,reset);
//checking to the absence of error in the previous operation
  if(reset!=0)return(-1);
  //----
  Ind_Buffer[bar] = JVIDYA; 
 }
//THE COMPLETION OF THE BASIC CYCLE
return(0);
}
//+------------------------------------------------------+

