/*
For the work of indicator should be placed the files
JJMASeries.mqh
JurXSeries.mqh
PriceSeries.mqh
3c_BB_Osc2.mqh  
in the folder (directory): MetaTrader\.experts\.include \
JCCIX.mq4 
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+  
//|                                                    3c_JCCIX2.mq4 |
//|                             Copyright ? 2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 8 
//the color of the indicator
#property indicator_color1 LimeGreen 
#property indicator_color2 BlueViolet 
#property indicator_color3 Magenta
#property indicator_color4 Purple
//Bollinger Bands color
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_color7 Crimson
#property indicator_color8 Crimson
//the thickness of the indicator lines
#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 1 
#property indicator_width4 1
//the style of the envelope
#property indicator_style1 4
//the style of lines Bollinger Bands
#property indicator_style5 4
#property indicator_style6 4
#property indicator_style7 4
#property indicator_style8 4
//the parameters of the horizontal levels of the indicator
#property indicator_level1  0.0
#property indicator_level2  0.8
#property indicator_level3 -0.8
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
//the input parameters of the rapid one-color JCCIX
extern int JJMA.Length1 = 5; //depth JJMA of the smoothing of theinput price
extern int JurX.Length1 = 8; //depth JurX of the smoothing of theobtained indicator
extern int JJMA.Phase1 = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of perekhodny.kh of theprocesses of the smoothing
extern int Input_.Price_.Customs1 = 0;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//-----------------------------------------------------------------------------------------------------------+
//the input parameters of the slow trichromatic JCCIX
extern int JJMA.Length2 = 22; //depth JJMA of the smoothing of theinput price
extern int JurX.Length2 = 44; //depth JurX of the smoothing of theobtained indicator
extern int JJMA.Phase2 = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of perekhodny.kh of theprocesses of the smoothing
extern int Input_.Price_.Customs2 = 0;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//the style of the performance of the horizontal levels of theindicators
extern int Levels_.Style = 3; //the style of the level lines
extern int Levels_.Width = 0; //the thickness of the level lines
extern color Levels_.Color = SlateGray; //the color of the levellines
//---- -------------------------------------------------------------------------------------------------------------------------------+
//introduction to function COUNT_.begin() for enumerating the numberof the bar, beginning from which will otrisovyvat'sya indicator andcalculated Bollinger Bands
int COUNT_begin()
  {
   int count_begin=2*JurX.Length2+30;
   return(count_begin);
  }
//introduction to function digits() for the installation of the sizeof accuracy (quantity of signs after decimal point) for thevisualization of the values of the indicator
int digits(){return(2);}
//the installation of the values of indicator, which not will be seenon the graph
int EmptyValue=0.0;
//the determination of the name indicator
string Label = "JCCIX";

//the start in the text of the indicator of its basic text
#include <3c_BB_Osc2.mqh> 
//---- +-----------------------------------------------+
//introduction to function INDICATOR1 of--------------------------------------------------------------------------------------
//turning to initial indicator for obtaining the i.chkhodnykh values
double INDICATOR1(int INDICATOR1.bar)
 {
  return( iCustom( NULL, 0, "JCCIX", JJMA.Length1, JurX.Length1, JJMA.Phase1, Input_Price_Customs1, 0,INDICATOR1.bar) );
 }
//introduction to function INDICATOR2 of--------------------------------------------------------------------------------------
//turning to initial indicator for obtaining the i.chkhodnykh values
double INDICATOR2(int INDICATOR2.bar)
 {
  return( iCustom( NULL, 0, "JCCIX", JJMA.Length2, JurX.Length2, JJMA.Phase2, Input_Price_Customs2, 0, INDICATOR2.bar) );
 }
//---- ------------------------------------------------------------------------------------------------------------------+


