/*
For the work of indicator should be placed the files
JMASeries.mqh,
JUR001Series.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \

the "description of the indicator Of t.DeMarka"
In vnogiye the packets of technical is included the indicator,proposed
T.DeMarkom. Close one in the sense to DMI, but is more simplycomputed
(DEMARK in contrast to ADX, are considered only extreme prices, butnot
the price of closing) it gives visual signals and on the level withothers
by oscillators it can be used for constructing the commercial systems.
Determination of the indicator: if today's high above yesterday'shigh, then
we accumulate the appropriate differences, if today's low is below
yesterday's, then we separately accumulate the appropriate differences(and those and
others - positive values). Quantity of spark plugs n, on which
accumulation (averaging), occurs, it is the parameter
the indicator, equal to the fraction: DEMARK = (accumulated after n ofspark plugs differences
high - high[-1 ])/((accumulated after n of spark plugs differenceshigh -
high[-1 ]) (accumulated after n of spark plugs differences low[-1 ] -low)) with
the call of indicator it inquires the length of the window ofusredeneniya n; on
value of n = 13 is proposed to silence. Reading this indicator in
much is analogous RSI: it also forms the regions of perekuplennostiand
to pereprodannosti, frequently shows good divergences. At the sametime,
in the vmogikh situations it can have advantages, since it is more
the structure of spark plug fully is considered.
                ? 1997-2005, ?FOREX CLUB?
     http://www.fxclub.org/academy_lib_article/article17.html
     
In this indicator inside the calculation the classical algorithm ofthe averaging
it is substituted to the algorithm of averaging from indicator JRSXwith the aid of the function
JUR001Series is added the signal line, obtained by the additional
JMA by the smoothing of indicator.
*/
//+------------------------------------------------------------------+  
//|                                                  3c_JDemarkX.mq4 | 
//|                        Copyright ? 2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers  4
//the color of the indicator
#property indicator_color1  Blue
#property indicator_color2  Magenta
#property indicator_color3  Purple
#property indicator_color4  Aqua
//the thickness of the indicator lines
#property indicator_width1 3
#property indicator_width2 3 
#property indicator_width3 3
//the style of the signal line of the indicator
#property indicator_style4 4
//the parameters of the horizontal levels of the indicator
#property indicator_level1   50
#property indicator_level2  -50
#property indicator_level3   0
#property indicator_levelcolor DarkOrchid
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF INDICATOR
extern int Demark_Length = 10;
extern int Signal_Length = 15;
extern int Signal_Phase  = 100;
/
//the indicator buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
double Ind_Buffer3[];
double Ind_Buffer4[]; 
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+ 
//introduction to function JurXSeries
//introduction to function JurXSeriesResize
//introduction to function JurXSeriesAlert
//introduction to function JurX_.ErrDescr
#include <JurXSeries.mqh> 
//+------------------------------------------------------------------+    
//| JDemarkX initialization function                                 | 
//+------------------------------------------------------------------+  
int init()
  {
//4 indicator buffers are used for the calculation
if(!SetIndexBuffer(0,Ind_Buffer1) &&
   !SetIndexBuffer(1,Ind_Buffer2) &&
   !SetIndexBuffer(2,Ind_Buffer3) &&
   !SetIndexBuffer(3,Ind_Buffer4))
Print("Ne it was possible to establish indicator buffers!");
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID); 
   SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(3,DRAW_LINE);
//names for the windows of data and leyby for sub"okon
   IndicatorShortName ("JDemarkX"); 
   SetIndexLabel(0,"Up_Trend");
   SetIndexLabel(1,"Down_Trend");
   SetIndexLabel(2,"Straight_Trend");
   SetIndexLabel(3,"Signal");
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0); 
   SetIndexEmptyValue(3,0); 
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
   if (JJMASeriesResize(1)!=1)return(-1);
//a change in the sizes of the buffer variables of functionJurXSeries, nJurXnumber=2(Dva turning to function JurXSeries)
   if (JurXSeriesResize(2)!=2)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
   JurXSeriesAlert (0,"Demark_Length",Demark_Length);
   JJMASeriesAlert (0,"Signal_Length",Signal_Length);
   JJMASeriesAlert (1,"Sign_Phase",   Signal_Phase);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int drawbegin=Demark_Length+1; 
   SetIndexDrawBegin(0,drawbegin);
   SetIndexDrawBegin(1,drawbegin);
   SetIndexDrawBegin(2,drawbegin);  
   SetIndexDrawBegin(3,drawbegin+30);        
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(0);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+  
//| JDemarkX iteration function                                      | 
//+------------------------------------------------------------------+  
int start()
   { 
//the introduction of variables with the floating point
   double min_L,min_H,min_S,Jmin_H,Jmin_S,Demark,JDemarkX,trend,Signal; 
//checking a quantity of bars to the sufficiency for the calculation
   if (Bars-1<Demark_Length)return(0); 
//the introduction of entire variables and obtaining the alreadycalculated bars
   int reset,limit,MaxBarD,MaxBarJ,counted_bars=IndicatorCounted();
//checking to the possible errors
   if (counted_bars<0)return(-1);
//the last calculated bar must be converted
//(without this conversion for counted_.bars funktsi.b JJMASeries andJurXSeries they will work incorrectly!!!)
   if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
   limit=Bars-counted_bars-1;
//the determination of the number of the maximum oldest bar, beginningfrom which there will be proizeden the conversion of the new bars
   MaxBarD=Bars-2;MaxBarJ=MaxBarD-Demark_Length;
   if (limit>MaxBarD)limit=MaxBarD;
   
//THE BASIC CYCLE OF CALCULATION IYEDIKATORA
   for(int bar=limit; bar>=0; bar--) 
     {  
        min_H=High[bar]-High[bar+1];
        min_L=Low[bar+1]-Low[bar];
        //----+    
        if(min_H<0) min_H=0; 
        if(min_L<0) min_L=0; 
        min_S = min_L + min_H;
        //----+ ----------------------------------------------------------------+ 
//two parallel turnings to function JurXSeries after numbers 0, 1
//parameter nJurXLength does not change on each bar (nJurXdin=0)
        //----+ ----------------------------------------------------------------+     
        Jmin_H=JurXSeries(0,0,MaxBarD,limit,Demark_Length,min_H,bar,reset);
//checking to the absence of error in the previous operation
        if(reset!=0)return(-1);
        //----+ ----------------------------------------------------------------+ 
        Jmin_S=JurXSeries(1,0,MaxBarD,limit,Demark_Length,min_S,bar,reset);
//checking to the absence of error in the previous operation
        if(reset!=0)return(-1);                             
        //----+ ----------------------------------------------------------------+ 
        if (bar>MaxBarJ)continue;
//the calculation of the indicator Of demarka
        if(Jmin_S!=0)JDemarkX =(200*Jmin_H/Jmin_S)-100;else JDemarkX = 100;
                                    
//SSSSSSSSSSSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
        trend=JDemarkX-Ind_Buffer1[bar+1]-Ind_Buffer2[bar+1]-Ind_Buffer3[bar+1];     
        if     (trend>0){Ind_Buffer1[bar]=JDemarkX; Ind_Buffer2[bar]=0;        Ind_Buffer3[bar]=0;}
        else{if(trend<0){Ind_Buffer1[bar]=0;        Ind_Buffer2[bar]=JDemarkX; Ind_Buffer3[bar]=0;}
        else            {Ind_Buffer1[bar]=0;        Ind_Buffer2[bar]=0;        Ind_Buffer3[bar]=JDemarkX;}}    
        //---- +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+  
        
//the calculation of the signal line
        //----+ ---------------------------------------------------------------------------------------------------------------------------+   
//(one turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length they do not change on each bar(nJMA.din=0))
        Signal=JJMASeries(0,0,MaxBarJ,limit,Signal_Phase,Signal_Length,JDemarkX,bar,reset);
//checking to the absence of error in the previous operation
        if(reset!=0)return(-1); 
        Ind_Buffer4[bar]=Signal;             
        //----+ ---------------------------------------------------------------------------------------------------------------------------+          
     } 
     if(limit>=MaxBarJ){int iii=MaxBarJ;Ind_Buffer1[iii]=0;Ind_Buffer2[iii]=0;Ind_Buffer3[iii]=0;}      
//the completion of the calculations of the values of the indicator
   return(0);
   }  
//+-------------------------------------------------------------------------+
     
  
