/*
For the work of indicator should be placed the files
JJMASeries.mqh 
JurXSeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                    3c_JJRSX1.mq4 |
//|                           Copyright ? 2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers  3
//the color of the indicator
#property indicator_color1  BlueViolet
#property indicator_color2  Magenta
#property indicator_color3  Gray
//the thickness of the indicator lines
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
//the parameters of the horizontal levels of the indicator
#property indicator_level1  0.5
#property indicator_level2 -0.5
#property indicator_level3  0.0
#property indicator_levelcolor MediumBlue
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR
extern int Length = 8; //the depth of the smoothing of the indicator
extern int Smooth = 3; //depth additional JMA smoothing
extern int Smooth_.Phase = 100; //additional JMA smoothing, that ischanged within limits of -100... 100,
it //vliyaet to the quality of transient process;
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 
8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,11-Heiken Ashi Low, 12-Heiken Ashi High,  
13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- 
//the indicator buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
double Ind_Buffer3[]; 
//+------------------------------------------------------------------+  
//| JJRSX initialization function                                    |
//+------------------------------------------------------------------+ 
int init()
  {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM, STYLE_SOLID);
//4 indicator buffers are used for the calculation
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexBuffer(1,Ind_Buffer2);
   SetIndexBuffer(2,Ind_Buffer3);
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0); 
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
//names for the windows of data and leyby for sub"okon
   SetIndexLabel(0,"Up_Trend");
   SetIndexLabel(1,"Down_Trend");
   SetIndexLabel(2,"Straight_Trend");
   IndicatorShortName("JJRSX(Length="+Length+")");
//the installation of the size of accuracy (quantity of signs afterdecimal point)
//dlya of the visualization of the values of the indicator
   IndicatorDigits(0);
//korektsiya of the inadmissible value of parameter Length
  if(Length<1)Length=1; 
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int draw_begin=3*Length+30+1; 
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
   SetIndexDrawBegin(2,draw_begin);   
//the completion of the initialization
return(0);
  }
//+------------------------------------------------------------------+ 
//| JJRSX iteration function                                         |
//+------------------------------------------------------------------+ 
int start()
  {
//the introduction of the entire variables of the memory
   static int time2;
//the introduction of the variables of memory with the floating point
   static double VelueM;
//the introduction of variables with the floating point
	double Velue0,Velue1,trend; 
//the introduction of entire variables and obtaining the alreadycalculated bars
	int bar,limit,MaxBar,Tnew,counted_bars=IndicatorCounted();
//checking to the possible errors
	if (counted_bars<0)return(-1);
//the last calculated bar must be converted
	if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar,
//nachinaya from which there will be proizeden the conversion of allbars
	MaxBar=Bars-3*Length-30; 
//the determination of the number of the oldest bar,
//nachinaya from which there will be proizeden the conversion of thenew bars
	limit=Bars-counted_bars-1; 
//--- initialization of zero
	if (limit>=MaxBar)
	  for(bar=Bars-1;bar>=MaxBar;bar--)
	   {
	    limit=MaxBar;
	    Ind_Buffer1[bar]=0.0;
	    Ind_Buffer2[bar]=0.0;
	    Ind_Buffer3[bar]=0.0;
	   }
//--- the restoration of the values of variable========================
    Tnew=Time[limit+1];
    if (limit<MaxBar)
    if (Tnew==time2)
     {
      Velue1=VelueM;
     }
    else 
     {
      if (Tnew>time2)
Print("Owibka restoration of variables!!! Tnew time2");
Else Print("Owibka Restoration of variables!!! Tnew
Print("Budet is produced the conversion of indicator on all bars!");
      return(-1);  
     }
    //+--- +===========================================================+
	 
//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
	while (bar>=0)
 	 {
//--- the retention of the values of variable ====
     if (bar==1)
      {
       if(((limit==1)&&(time2==Time[2]))||(limit>1))
         {
          VelueM=Velue1;
          time2=Time[bar];
         }
      }
     //+---+====================================+     	 
		Velue0=iCustom( NULL,0,"JJRSX",Length,Smooth,Smooth_Phase,Input_Price_Customs,0,bar);
		if (bar==MaxBar)
		  {
		   Velue1=Velue0;
		   continue;
		  }		
//the trichromatic code of the indicator
		trend=Velue0-Velue1;     
		if(trend>0)     {Ind_Buffer1[bar]=Velue0; Ind_Buffer2[bar]=0;      Ind_Buffer3[bar]=0;}
		else{if(trend<0){Ind_Buffer1[bar]=0;      Ind_Buffer2[bar]=Velue0; Ind_Buffer3[bar]=0;}
		else            {Ind_Buffer1[bar]=0;      Ind_Buffer2[bar]=0;      Ind_Buffer3[bar]=Velue0;}}    
		//---- 
		Velue1=Velue0;
		//----+
		bar--;
	 } 
//the completion of the calculations of the values of the indicator
	return(0);
  }
//+-------------------------------------------------------------------------------+





