/*
For the work of indicator should be placed the files
JMASeries.mqh,
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \

Indicator Momentum (rate) measures the value of a price change ofpaper after
the specific period. Basic methods of using the indicator of the rate:
As the oscillator, which follows after the tendency, is analogousMACD. In
this case signal to the purchase appears, if indicator is formed
cavity begins grow; and signal to sale - when it reaches the peak
and it turns downward. For the more precision determination of themoments of the turn
indicator it is possible to use its short moving average. Extremely
the high or low values of the indicator of rate assume thecontinuation
the current tendency. Thus, if indicator reaches the extremely high
values and then it turns downward, it follows to expect furtherincrease
prices. But in any event with the discovery (or closing) of positionit is not necessary
to hurry until price they confirm the signal of indicator. In
the quality of the anticipating indicator. This method is based on theassumption
about the fact that the final phase of the ascending tendency usually
is accompanied by a swift increase in the prices (since everythingthey believe in it
continuation), and the end of bear market - by their sharp drop (thus
as all attempt to leave the market). Specifically, so frequently andit occurs, but
nevertheless this too wide a generalization.
In this indicator classical Momentum is smoothed with the aid of thealgorithm
JMA. 
*/
//+------------------------------------------------------------------+  
//|                                                 3c_JMomentum.mq4 | 
//|                        Copyright ? 2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 8 
//the color of the indicator
#property indicator_color1 Purple 
#property indicator_color2 Lime 
#property indicator_color3 OrangeRed
#property indicator_color4 Gray
//Bollinger Bands color
#property indicator_color5 Gray
#property indicator_color6 Gray
#property indicator_color7 Magenta
#property indicator_color8 Magenta
//the thickness of the indicator lines
#property indicator_width1 3
#property indicator_width2 1
#property indicator_width3 1 
#property indicator_width4 1
//the style of the envelope
#property indicator_style1 0
//the style of lines Bollinger Bands
#property indicator_style5 4
#property indicator_style6 4
#property indicator_style7 4
#property indicator_style8 4
//the parameters of the horizontal levels of the indicator
#property indicator_level1 0.0
#property indicator_levelcolor Blue
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Mom_.Period = 8; //period Momentum
extern int Smooth = 8; //depth JMA of the smoothing of the finishedindicator
extern int Smooth_.Phase = y00;///the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khJMA of the processes of the smoothing
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//introduction to function digits() for the installation of the sizeof accuracy (quantity of signs after decimal point) for thevisualization of the values of the indicator
int digits(){return(0);}
//introduction to function COUNT_.begin() for enumerating the numberof the bar, beginning from which will otrisovyvat'sya indicator andcalculated Bollinger Bands
int COUNT_begin(){return(Mom_Period+30);}
//the installation of the values of indicator, which not will be seenon the graph
int EmptyValue=0.0;
//the determination of the name indicator
string Label = "JMomentum";

//the start in the text of the indicator of its basic text
#include <3c_BB_Osc.mqh> 
//---- +-----------------------------------------------+
//introduction to function INDICATOR of--------------------------------------------------------------------------------------
//turning to initial indicator for obtaining the i.chkhodnykh values
double INDICATOR(int INDICATOR.bar)
 {
  return( iCustom( NULL, 0, "JMomentum", Mom_Period, Smooth, Smooth_Phase, 0, Input_Price_Customs, 0, INDICATOR.bar) );
 }
//---- -----------------------------------------------------------------------------------------------------------------+
 

