/*
For the work of indicator should be placed the files
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                 JAccelerator.mq4 |
//|                        Copyright ? 2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property  indicator_buffers 4
//the color of the indicator
#property indicator_color1  Gray
#property indicator_color2  Yellow
#property indicator_color3  Magenta
#property indicator_color4  Gray
//the thickness of the indicator lines
#property indicator_width1 0
#property indicator_width2 2 
#property indicator_width3 2
#property indicator_width4 2
//the style of the envelope of the indicator
#property indicator_style1 4
//the parameters of the horizontal levels of the indicator
#property indicator_level1 0.0
#property indicator_levelcolor Blue
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int FastJMA=05; //the depth of the smoothing of rapid JMA
extern int SlowJMA=34; //the depth of the smoothing of slow JMA
extern int SignJMA=05; //the depth of the smoothing of signal JMA
extern int JMAccD_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence the quality of perekhodny.khof processes JMACD
extern int Sign_.Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of perekhodny.kh of theprocesses of the signal line
extern int Input_.Price_.Customs = ya;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double     Ind_Buffer0[];
double     Ind_Buffer1[];
double     Ind_Buffer2[];
double     Ind_Buffer3[];
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| JAccelerator initialization function                             |
//+------------------------------------------------------------------+  
int init()
  {
//the styles of the image of the indicator
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(0);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0,61);
   SetIndexDrawBegin(1,61);
   SetIndexDrawBegin(2,61);
   SetIndexDrawBegin(3,61);
//3 indicator buffers are used for the calculation
   SetIndexBuffer(0,Ind_Buffer0);
   SetIndexBuffer(1,Ind_Buffer1);
   SetIndexBuffer(2,Ind_Buffer2);
   SetIndexBuffer(3,Ind_Buffer3);
//names for the windows of data and leyby for sub"okon
   IndicatorShortName("JAccelerator");
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=3(Tri turning to function JJMASeries)
   if (JJMASeriesResize(3)!=3)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
   JJMASeriesAlert (0,"FastJMA",FastJMA);
   JJMASeriesAlert (0,"SlowJMA",SlowJMA);
   JJMASeriesAlert (0,"SignJMA",SignJMA);
   JJMASeriesAlert (1,"JMACD_Phase", JMACD_Phase);
   JJMASeriesAlert (1,"Sign_Phase", Sign_Phase);
   PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+  
//| JAccelerator/Decelerator Oscillator                              |
//+------------------------------------------------------------------+  
int start()
{
//the introduction of variables with the floating point
double JMACD,JAccelerator,FastJ,SlowJ,Signal,Temp_Series,trend;
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar1,MaxBar2,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
//(without this conversion for counted_.bars function JJMASeries itwill work incorrectly!!!)
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar1=Bars-1; MaxBar2=MaxBar1-30;

for(int bar=limit; bar>=0; bar--)
 {
//turning to function PriceSeries for obtaining the input priceSeries
   Temp_Series=PriceSeries(Input_Price_Customs, bar);
   //+----------------------------------------------------------------------------+ 
//two turnings to function JJMASeries after numbers 0, 1.
//parameters nJMA.Phase and nJMA.Length do not change on each bar(nJMA.din=0)
   //+----------------------------------------------------------------------------+   
   FastJ=JJMASeries(0,0,MaxBar1,limit,JMACD_Phase,FastJMA,Temp_Series,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   //+----------------------------------------------------------------------------+ 
   SlowJ=JJMASeries(1,0,MaxBar1,limit,JMACD_Phase,SlowJMA,Temp_Series,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1); 
   //+----------------------------------------------------------------------------+ 
   
   JMACD=FastJ-SlowJ;
//a change in the unit of measurement JMACD to the points
   JMACD=JMACD/Point;  
   //+----------------------------------------------------------------------------+ 
//turning to function JJMASeries after to numbers 2.
//parameters nJMA.Phase and nJMA.Length do not change on each bar(nJMA.din=0)
   //+----------------------------------------------------------------------------+   
   Signal=JJMASeries(2,0,MaxBar2,limit,Sign_Phase,SignJMA,JMACD,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   //+----------------------------------------------------------------------------+ 
   JAccelerator=JMACD-Signal; 
   Ind_Buffer0[bar]=JAccelerator;
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
   trend=JAccelerator-Ind_Buffer0[bar+1];     
   if     (trend>0){Ind_Buffer1[bar]=JAccelerator; Ind_Buffer2[bar]=0;            Ind_Buffer3[bar]=0;}
   else{if(trend<0){Ind_Buffer1[bar]=0;            Ind_Buffer2[bar]=JAccelerator; Ind_Buffer3[bar]=0;}
   else            {Ind_Buffer1[bar]=0;            Ind_Buffer2[bar]=0;            Ind_Buffer3[bar]=JAccelerator;}}    
   //---- +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+    
 }
 if(limit>=MaxBar2){int iii=MaxBar2;Ind_Buffer1[iii]=0;Ind_Buffer2[iii]=0;Ind_Buffer3[iii]=0;}
//the completion of the calculations of the values of the indicator
   return(0);
}
//+------------------------------------------------------------------------------+

