/*
DDlya of the work of indicator should be placed the files
JJMASeries.mqh  
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
JFatl.mq4 
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \

On tsyfrovom display to the right are reflected the values of speedJFatl on
the second, first and zero bars
*/
//+------------------------------------------------------------------+ 
//|                                                  JFatlSpeedR.mq4 | 
//|                             Copyright ? 2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers  6
#property indicator_color1  MediumSeaGreen
#property indicator_color2  Crimson  
#property indicator_color3  Yellow
#property indicator_color4  Magenta 
#property indicator_color5  MediumSeaGreen  
#property indicator_color6  Crimson
//is upper the lower limitation of the scale of the window of theindicator
#property indicator_maximum 1.1
#property indicator_minimum 0.9
//the thickness of the indicator lines
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 4
#property indicator_width6 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Noise = 3; //the value of a price change, taken for noise;
extern int Length = 8; //depth JFatl of smoothing;
extern int Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence quality transient JFatl process;
extern int Smooth = 1; //the depth of the smoothing of the finishedindicator JFatlSpeed;
extern int Smooth_.Phase = 100; //the parameter, which is changedwithin limits of -100... 100, influence quality transient JFatlSpeedprocess;
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator:
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) 
extern int Simbol1=108; //the exterior view of symbol for the speedwith its drop to noise
extern int Simbol2=108; //the exterior view of symbol for the speedwith its drop to noise
extern int Simbol3=108; //the exterior view of symbol for the speedwith its change out of the noise level
extern int Simbol4=108; //the exterior view of symbol for the speedwith its change out of the noise level
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double UBuffer []; 
double DBuffer []; 
double Buffer1 [];
double Buffer2 []; 
double Buy1    [];
double Sell1   [];
double Buy2    [];
double Sell2   [];
//----
int Window;
//the introduction of constants with the floating point
double NOISE,VSHIFT; 
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+ 
//| JFatlSpeedR initialization function                              |
//+------------------------------------------------------------------+ 
int init() 
{ 
//the style of the performance of graph the form of the symbols
SetIndexStyle(0,DRAW_ARROW);
SetIndexStyle(1,DRAW_ARROW);
SetIndexStyle(2,DRAW_ARROW);
SetIndexStyle(3,DRAW_ARROW);
SetIndexStyle(4,DRAW_ARROW);
SetIndexStyle(5,DRAW_ARROW);
//the determination of the style of the point targets
SetIndexArrow(0,159);
SetIndexArrow(1,159);
SetIndexArrow(2,Simbol1);
SetIndexArrow(3,Simbol2);
SetIndexArrow(4,Simbol3);
SetIndexArrow(5,Simbol4);
//8 indicator buffers are used for the calculation
IndicatorBuffers(8);
SetIndexBuffer(0,UBuffer);
SetIndexBuffer(1,DBuffer);
SetIndexBuffer(2,Buy1);
SetIndexBuffer(3,Sell1);
SetIndexBuffer(4,Buy2);
SetIndexBuffer(5,Sell2); 
SetIndexBuffer(6,Buffer1);
SetIndexBuffer(7,Buffer2);
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
SetIndexDrawBegin(0,69); 
SetIndexDrawBegin(1,69);
SetIndexDrawBegin(2,69);
SetIndexDrawBegin(3,69);
SetIndexDrawBegin(4,69);
SetIndexDrawBegin(5,69);
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0);
SetIndexEmptyValue(1,0);
SetIndexEmptyValue(2,0);
SetIndexEmptyValue(3,0);
SetIndexEmptyValue(4,0);
SetIndexEmptyValue(5,0);
IndicatorShortName("JFatlSpeed("+Noise+","+Length+","+Phase+","+Smooth+","+Smooth_Phase+","+Input_Price_Customs+","+Simbol1+","+Simbol2+","+Simbol3+","+Simbol4+")"); 
NOISE=Noise*Point;
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
IndicatorDigits(0);
//the determination of the number of the window of the indicator
Window=WindowFind("JFatlSpeed("+Noise+","+Length+","+Phase+","+Smooth+","+
Smooth_Phase+","+Input_Price_Customs+","+Simbol1+","+Simbol2+","+Simbol3+","+Simbol4+")");
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Smooth",Smooth);
JJMASeriesAlert (1,"Smooth_Phase", Smooth_Phase);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the completion of the initialization
return(0); 
}
//+------------------------------------------------------------------+ 
//| JFatlSpeedR iteration function                                   |
//+------------------------------------------------------------------+ 
int start() 
{ 
//the introduction of variables with the floating point
double JFatlSpeed,JFS0,JFS1,JFS2,JFatl0,JFatl1,Series;
//the introduction of entire variables and obtaining the alreadycalculated bars
int bar,reset,MaxBar,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar=Bars-1-38-30-1;
//----+  
for(bar=limit;bar>=0;bar--)Buffer1[bar]=iCustom( NULL, 0, "JFatl",Length,Phase,0,Input_Price_Customs,0,bar); 
//korektsiya of the starting raschetogo bar in the cycle
//initialization of zero
if (limit>Bars-70)
  {
   for(bar=limit;bar>=MaxBar;bar--)
     {
      Buffer2[bar]=0.0;
      Buy1   [bar]=0.0;
      Sell1  [bar]=0.0;
      Buy2   [bar]=0.0;
      Sell2  [bar]=0.0;
     }
   limit=Bars-70;
  }

for(bar=limit;bar>=0;bar--)
  {
   JFatl0=Buffer1[bar+0];
   JFatl1=Buffer1[bar+1];    
   Series=JFatl0-JFatl1;
//the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
   JFatlSpeed=JJMASeries(0,0,MaxBar,limit,Smooth_Phase,Smooth,Series,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   Buffer2[bar]=JFatlSpeed;
  }
//korektsiya of the starting raschetogo bar in the cycle
//initialization of zero
if (limit>Bars-71)
  {
   for(bar=limit;bar>=MaxBar;bar--)
     {
      Buy1   [bar]=0.0;
      Sell1  [bar]=0.0;
      Buy2   [bar]=0.0;
      Sell2  [bar]=0.0;
     }
   limit=Bars-71;
  }
//----+
for(bar=limit;bar>=0;bar--)
  { 
   Buy1 [bar]=0;
   Sell1[bar]=0;
   Buy2 [bar]=0;
   Sell2[bar]=0;
   JFS0=Buffer2[bar+0];
   JFS1=Buffer2[bar+1];
   if (JFS0>0){UBuffer[bar]=1;DBuffer[bar]=0;}
   if (JFS0<0){UBuffer[bar]=0;DBuffer[bar]=1;}
   
   if (MathAbs(JFS1)<=NOISE)
    { 
     if(JFS0> NOISE)Buy2 [bar]=1;
     if(JFS0<-NOISE)Sell2[bar]=1;
    }
   else
    {
     if((JFS1<-NOISE)&&(MathAbs(JFS0)<=NOISE))Buy1 [bar]=1;
     if((JFS1> NOISE)&&(MathAbs(JFS0)<=NOISE))Sell1[bar]=1;
     if((JFS1<-NOISE)&&(JFS0> NOISE))Buy2 [bar]=1;
     if((JFS1> NOISE)&&(JFS0<-NOISE))Sell2[bar]=1; 
    }
  }
//----+
//the creation of the text units
JFS0=Buffer2[0];
JFS1=Buffer2[1];  
JFS2=Buffer2[2]; 
//---
int JFSpeed0=JFS0/Point;
int JFSpeed1=JFS1/Point;
int JFSpeed2=JFS2/Point;
//---  
int JFStime2=Time[0] +120*Period();
int JFStime1=JFStime2+240*Period();
int JFStime0=JFStime1+240*Period();    
//---
CreateTextObject("JFatlSpeed0"+Window+"",JFStime0,JFSpeed0,JFS0);
CreateTextObject("JFatlSpeed1"+Window+"",JFStime1,JFSpeed1,JFS1);
CreateTextObject("JFatlSpeed2"+Window+"",JFStime2,JFSpeed2,JFS2);
//----+ +-------------------------+
return(0); 
} 
//+---------------------------------------------------------------------------------------------------------------------------+
//introduction to function CreateTextObject
void CreateTextObject(string name,int time,int text,double param)
{ 
 ObjectDelete(name);
 ObjectCreate(name, OBJ_TEXT, Window, time, 1.08); 
 if (param >0)ObjectSetText(name, ""+text+"", 14, "Courier New", Lime);
 if (param <0)ObjectSetText(name, ""+text+"", 14, "Courier New", Red);
 if (param==0)ObjectSetText(name, ""+text+"", 14, "Courier New", DodgerBlue);
}
//+-------------------------------------------------------------------------------------------------------------------------------------+
