//+------------------------------------------------------------------+  
//|                                                       JNRTRX.mq4 |
//|                    http://www.gustis.narod.ru;     gsb51@mail.ru |
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 2
//the color of the indicator
#property indicator_color1 Lime 
#property indicator_color2 Red
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Length = 12; //the depth of the smoothing
extern int  Smoth_ATR=18;
extern int Multipiller = 10; //coefficient;
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
extern bool Line_Style=false;
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double JNRTRX[];
double UpTrendBuffer[];
double DownTrendBuffer[];
//+------------------------------------------------------------------+  
//introduction to function JurXSeries
//introduction to function JurXSeriesResize
//introduction to function JurXSeriesAlert
//introduction to function JurX_.ErrDescr
#include <JurXSeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| NRTR indicator initialization function                           | 
//+------------------------------------------------------------------+  
int init() 
{  
//3 indicator buffers are used for the calculation
IndicatorBuffers(3);
SetIndexBuffer(0,UpTrendBuffer); 
SetIndexBuffer(1,DownTrendBuffer); 
SetIndexBuffer(2,JNRTRX);
if (Line_Style==true)
 {
//the style of the performance of the graph
  SetIndexStyle(0,DRAW_LINE); 
  SetIndexStyle(1,DRAW_LINE); 
 }
else
 {
  SetIndexStyle(0,DRAW_ARROW); 
  SetIndexStyle(1,DRAW_ARROW); 
  SetIndexArrow(0,159); 
  SetIndexArrow(1,159); 
 }
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);
SetIndexEmptyValue(1,0.0);
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("JNRTRX( Length="+Length+", Multipiller="+Multipiller+")"); 
SetIndexLabel (0, "Up_Trend");
SetIndexLabel (1, "Down_Trend"); 
//a change in the sizes of the buffer variables of functionJurXSeries, nJurXnumber=1(Odno turning to function JurXSeries)
if (JurXSeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
JurXSeriesAlert(0,"Length",Length); 
PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| NRTR iteration function                                         | 
//+------------------------------------------------------------------+  
int start() 
{ 
//the introduction of variables with the floating point
double Price,JurX,ATR,Resalt;
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-1; int limit=MaxBar-counted_bars;
//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(int bar=limit;bar>=0;bar--)
  {
DownTrendBuffer[bar]=0;
UpTrendBuffer  [bar]=0;
//turning to function PriceSeries for obtaining the input priceSeries
Price=PriceSeries(Input_Price_Customs,bar);
//+----------------------------------------------------------------------------+ 
//one turning to function JJMASeries after the numbers 0 parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
//+----------------------------------------------------------------------------+   
JurX=JurXSeries(0,0,MaxBar,limit,Length,Price,bar,reset);
//checking to the absence of error in the previous operation
if(reset!=0)return(-1);
//+----------------------------------------------------------------------------+ 
ATR =iATR(NULL,0,Smoth_ATR,bar)*Multipiller/10;
//-Strict the line- switch of ------------
//turning to function PriceSeries for obtaining the input priceSeries
Price=PriceSeries(Input_Price_Customs,bar+1);
if(Price>JNRTRX[bar+1]){Resalt= JurX-ATR; UpTrendBuffer[bar]=Resalt;}
else
if(Price<JNRTRX[bar+1]){Resalt= JurX+ATR; DownTrendBuffer[bar]=Resalt;}
else  Resalt= JurX;
JNRTRX[bar]=Resalt;
  }
//the completion of the calculations of the values of the indicator
return(0); 
} 

//+--------------------------------------------------------+


