/*
/ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//.Version October 1, 2006 |
Editing Nikolay Kositsin 15.06.2006 farria@mail.redcom.ru |
/ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
*/
//------------------------------------------------------------------
//| 3Color_.KeltnerCh.mqh |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
/*
# property copyright "Nikolay Kositsin"
# property link "farria@mail.redcom.ru"
/ otrisovka of indicator in the main window
# property indicator_.chart_.window
/ a quantity of the indicator buffers
# property indicator_.buffers 6
/ the color of the indicator
# property indicator_.color1 Lime
# property indicator_.color2 Lime
# property indicator_.color3 Red
# property indicator_.color4 Red
# property indicator_.color5 Gray
# property indicator_.color6 Gray
*/
// THE INPUT PARAMETERS OF THE INDICATOR OF------------------------------------
extern int Keltner_.period = 50; //the period of the channel Ofkeltnera
extern int Keltner_.Step = 9; //the parameter, the predelyashchiy sizeof the fluctuations of those taken for flet (tsyfrovoy the step ofdiscreteness in the points)
extern int Ind_.Shift = 0; //cdvig indicator along the time axis
extern int Trend_.Minimum = 0; //the minimum speed of trend in thepoints
// -----------------------------------------------------------------
// the indicator buffers
double Buffer1 [];
double Buffer2 [];
double Buffer3 [];
double Buffer4 [];
double Buffer5 []; 
double Buffer6 []; 
double Buffer7 []; 
double Buffer8 []; 
//
double Value_Buffer[4]; 
// the introduction of the logical constants
bool   ReStart=false;
// the introduction of constants with the floating point
double MINIMUM,Norma;
// the introduction of variables with the floating point
double Value1,Value0;
// the introduction of the entire variables
int bar,ind_N1,ind_N2;
// introduction to function GetKeltner
// (file GetKeltner.mqh should be assumed into the folder (directory):MetaTrader\.experts\.include)
#include <GetKeltner.mqh>
//------------------------------------------------------------------
//| 3Color_.KeltnerCh initialization function |
//------------------------------------------------------------------
int init() 
  { 
// the styles of the image of the indicator
   SetIndexStyle  (0, DRAW_LINE); 
   SetIndexStyle  (1, DRAW_LINE);
   SetIndexStyle  (2, DRAW_LINE);
   SetIndexStyle  (3, DRAW_LINE); 
   SetIndexStyle  (4, DRAW_LINE);
   SetIndexStyle  (5, DRAW_LINE); 
   SetIndexStyle  (6, DRAW_LINE);
   SetIndexStyle  (7, DRAW_LINE); 
// 8 indicator buffers are used for the calculation
   IndicatorBuffers(8);   
   SetIndexBuffer (0, Buffer1);
   SetIndexBuffer (1, Buffer2);
   SetIndexBuffer (2, Buffer3);   
   SetIndexBuffer (3, Buffer4);
   SetIndexBuffer (4, Buffer5);   
   SetIndexBuffer (5, Buffer6); 
   SetIndexBuffer (6, Buffer7);   
   SetIndexBuffer (7, Buffer8);          
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,EmptyValue);
   SetIndexEmptyValue(1,EmptyValue);
   SetIndexEmptyValue(2,EmptyValue);
   SetIndexEmptyValue(3,EmptyValue);
   SetIndexEmptyValue(4,EmptyValue);
   SetIndexEmptyValue(5,EmptyValue); 
   SetIndexEmptyValue(6,EmptyValue);
   SetIndexEmptyValue(7,EmptyValue); 
// the installation of sdiga of the values of indicator along the timeaxis
   SetIndexShift(0,Ind_Shift); 
   SetIndexShift(1,Ind_Shift); 
   SetIndexShift(2,Ind_Shift); 
   SetIndexShift(3,Ind_Shift); 
   SetIndexShift(4,Ind_Shift); 
   SetIndexShift(5,Ind_Shift); 
   SetIndexShift(6,Ind_Shift); 
   SetIndexShift(7,Ind_Shift);    
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int drow_begin;  
   if (COUNT_begin()>=0)
   {
   drow_begin=COUNT_begin()+Ind_Shift+3;  
   SetIndexDrawBegin(0,drow_begin);
   SetIndexDrawBegin(1,drow_begin);
   SetIndexDrawBegin(2,drow_begin); 
   SetIndexDrawBegin(3,drow_begin);
   SetIndexDrawBegin(4,drow_begin);
   SetIndexDrawBegin(5,drow_begin); 
   SetIndexDrawBegin(6,drow_begin);
   SetIndexDrawBegin(7,drow_begin); 
   }
// the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(digits());
// names for the windows of data and leyby for sub"okon
   IndicatorShortName(""+Label+"");
   SetIndexLabel(0,"Up_Trend");
   SetIndexLabel(1,"Up_Trend");
   SetIndexLabel(2,"Down_Trend");
   SetIndexLabel(3,"Down_Trend");
   SetIndexLabel(4,"Straight_Trend");
   SetIndexLabel(5,"Straight_Trend"); 
   SetIndexLabel(6,"Channals_UP");
   SetIndexLabel(7,"Channals_DOUN"); 
// the initialization of the constants
   MINIMUM=Trend_Minimum*Point;
   Norma=Keltner_Step*Point;
// the completion of the initialization
return(0); 
  } 
//------------------------------------------------------------------
//| 3Color KeltnerChannel code |
//------------------------------------------------------------------
int start() 
{ 
// the introduction of variables with the floating point
double Trend0,Trend1,Trend2,Keltner,Line,UpLine,DnLine;
// the introduction of entire variables and obtaining the alreadycalculated bars
int limit,size,MaxBar,MaxBar1,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-1;
limit=MaxBar-counted_bars;  
size=limit+4;
if (size>MaxBar+1)size=MaxBar+1;
ArrayResize(Value_Buffer,size);        
// the load of the values of initial indicator into the buffer
for(bar=size-1; bar>=0; bar--)Value_Buffer[bar]=INDICATOR(bar);
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of all bars
if ((counted_bars==0)&&(COUNT_begin()==-1))
 {
  for(bar=MaxBar; bar>=0; bar--)if (Value_Buffer[bar]!=EmptyValue){MaxBar1=bar-3;break;}
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   int drow_begin;  
   drow_begin=MaxBar-MaxBar1+Ind_Shift;  
   SetIndexDrawBegin(0,drow_begin);
   SetIndexDrawBegin(1,drow_begin);
   SetIndexDrawBegin(2,drow_begin); 
   SetIndexDrawBegin(3,drow_begin);
   SetIndexDrawBegin(4,drow_begin);
   SetIndexDrawBegin(5,drow_begin); 
//
 }
else MaxBar1=MaxBar-COUNT_begin()-3;  

// korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
// initialization of zero
if (limit>MaxBar1)
 {
  limit=MaxBar1; 
  for(int ttt=MaxBar;ttt>MaxBar1;ttt--)
   {
    Buffer1[ttt]=EmptyValue; Buffer2[ttt]=EmptyValue; 
    Buffer3[ttt]=EmptyValue; Buffer4[ttt]=EmptyValue;
    Buffer5[ttt]=EmptyValue; Buffer6[ttt]=EmptyValue; 
    Buffer7[ttt]=EmptyValue; Buffer8[ttt]=EmptyValue; 
   }
 }
// the calculation of the channels
for(bar=limit; bar>=0; bar--)
  {
   Line=Value_Buffer[bar];
   Keltner=GetKeltner(Symbol(),0,Keltner_period,bar);
//
   UpLine=Line+Keltner;
   DnLine=Line-Keltner;
// the normalization of the obtained values
   UpLine/=Norma;
   DnLine/=Norma;
//
   UpLine=NormalizeDouble(UpLine,0);
   DnLine=NormalizeDouble(DnLine,0);
//
   UpLine*=Norma;
   DnLine*=Norma;
//
   Buffer7[bar]=UpLine;     
   Buffer8[bar]=DnLine; 
  }
bar=limit;
// THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
//| |
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
//Input indicator buffer: Value_.Buffer. |
//Output indicator buffers: Buffer1, Buffer2, Buffer1, Buffer2,Buffer1, Buffer2. | |
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
while(bar>=0)   
 {    
     if (!ReStart)
       { 
        Trend2=Value_Buffer[bar+2]-Value_Buffer[bar+3]; 
        Trend1=Value_Buffer[bar+1]-Value_Buffer[bar+2];
//
        if (MathAbs(Trend2)<MINIMUM)Trend2=0;
        if (MathAbs(Trend1)<MINIMUM)Trend1=0;  
//
        if (Trend2>0) ind_N2=1; else {if (Trend2<0) ind_N2=3; else ind_N2=5;}    
        if (Trend1>0) ind_N1=1; else {if (Trend1<0) ind_N1=3; else ind_N1=5;}
       } 
//---------------------------------------------------------------------------------------------------------------
     if((ReStart)&&(bar==limit))
       {
        Trend2=Value_Buffer[bar+2]-Value_Buffer[bar+3]; 
        Trend1=Value_Buffer[bar+1]-Value_Buffer[bar+2];
//
        if (MathAbs(Trend2)<MINIMUM)Trend2=0;
        if (MathAbs(Trend1)<MINIMUM)Trend1=0;   
//
        for(int iii=bar;iii<=bar;iii++)
         {
          if (Trend2> 0){if (Buffer1[iii+2]!=EmptyValue){ind_N2=1;break;} if (Buffer2[iii+2]!=EmptyValue){ind_N2=2;break;}}
          if (Trend2< 0){if (Buffer3[iii+2]!=EmptyValue){ind_N2=3;break;} if (Buffer4[iii+2]!=EmptyValue){ind_N2=4;break;}}
          if (Trend2==0){if (Buffer5[iii+2]!=EmptyValue){ind_N2=5;break;} if (Buffer6[iii+2]!=EmptyValue){ind_N2=6;break;}}
         }
//
        for(int kkk=bar;kkk<=bar;kkk++)
         {
          if (Trend1> 0){if (Buffer1[kkk+1]!=EmptyValue){ind_N1=1;break;} if (Buffer2[kkk+1]!=EmptyValue){ind_N1=2;break;}}
          if (Trend1< 0){if (Buffer3[kkk+1]!=EmptyValue){ind_N1=3;break;} if (Buffer4[kkk+1]!=EmptyValue){ind_N1=4;break;}}
          if (Trend1==0){if (Buffer5[kkk+1]!=EmptyValue){ind_N1=5;break;} if (Buffer6[kkk+1]!=EmptyValue){ind_N1=6;break;}}
         }
//
        }
//---------------------------------------------------------------------------------------------------------------
     Value0 = Value_Buffer[bar+0];   
     Value1 = Value_Buffer[bar+1];             
     Trend0 = Value0 - Value1; 
     if (MathAbs(Trend0)<MINIMUM)Trend0=0;   
//======================================================================
    switch(ind_N1)
            {  
// ----------------------------------------------------------
             case 1 :{ Buffer2[bar+1]=EmptyValue;   Buffer3[bar+1]=EmptyValue;
                       Buffer4[bar+1]=EmptyValue;   Buffer5[bar+1]=EmptyValue;
                       Buffer6[bar+1]=EmptyValue;}  break;
// ----------------------------------------------------------
             case 2 :{ Buffer1[bar+1]=EmptyValue;   Buffer3[bar+1]=EmptyValue;
                       Buffer4[bar+1]=EmptyValue;   Buffer5[bar+1]=EmptyValue;
                       Buffer6[bar+1]=EmptyValue;}  break;
// ----------------------------------------------------------
             case 3 :{ Buffer1[bar+1]=EmptyValue;   Buffer2[bar+1]=EmptyValue;
                       Buffer4[bar+1]=EmptyValue;   Buffer5[bar+1]=EmptyValue;
                       Buffer6[bar+1]=EmptyValue;}  break;
// ----------------------------------------------------------
             case 4 :{ Buffer1[bar+1]=EmptyValue;   Buffer2[bar+1]=EmptyValue;
                       Buffer3[bar+1]=EmptyValue;   Buffer5[bar+1]=EmptyValue;
                       Buffer6[bar+1]=EmptyValue;}  break;
// ----------------------------------------------------------
             case 5 :{ Buffer1[bar+1]=EmptyValue;   Buffer2[bar+1]=EmptyValue;
                       Buffer3[bar+1]=EmptyValue;   Buffer4[bar+1]=EmptyValue;
                       Buffer6[bar+1]=EmptyValue;}  break;
// ----------------------------------------------------------
             case 6 :{ Buffer1[bar+1]=EmptyValue;   Buffer2[bar+1]=EmptyValue;
                       Buffer3[bar+1]=EmptyValue;   Buffer4[bar+1]=EmptyValue;
                       Buffer5[bar+1]=EmptyValue;}  break;  
// ----------------------------------------------------------
            } 
//======================================================================
                       Buffer1[bar+0]=EmptyValue;   Buffer2[bar+0]=EmptyValue;                                                                                                            
                       Buffer3[bar+0]=EmptyValue;   Buffer4[bar+0]=EmptyValue;                            
                       Buffer5[bar+0]=EmptyValue;   Buffer6[bar+0]=EmptyValue;  
//=============================================================================================
        if(!ReStart)  
             {
              if(Trend0 >0){Buffer1[bar]=Value0; Buffer1[bar+1]=Value1; ind_N1=1; ReStart=true;}  
              if(Trend0 <0){Buffer3[bar]=Value0; Buffer3[bar+1]=Value1; ind_N1=3; ReStart=true;}  
              if(Trend0==0){Buffer5[bar]=Value0; Buffer5[bar+1]=Value1; ind_N1=5; ReStart=true;}
             }
//=============================================================================================
        
        if(Trend0>0)Up_Trend();else if(Trend0<0)Down_Trend();else No_trend(); 
  bar--; 
 }
// THE BASIC CYCLE
        
//

for(kkk=2; kkk>=0; kkk--)Value_Buffer[kkk+1]=Value_Buffer[kkk];
return(0); 
} 
//------------------------------------------------------------------------------------------------------

//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
//
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
void Up_Trend(){switch(ind_N1)
{   
 case 1 :          {Buffer1[bar]=Value0;  Buffer1[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=1;}break;
 case 2 :          {Buffer2[bar]=Value0;  Buffer2[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=2;}break;         
 case 3 :{switch(ind_N2)
         {case 1 : {Buffer2[bar]=Value0;  Buffer2[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=2;}break;          
         default : {Buffer1[bar]=Value0;  Buffer1[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=1;}}}break;                           
 case 4 :{switch(ind_N2)
         {case 1 : {Buffer2[bar]=Value0;  Buffer2[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=2;}break;  
         default : {Buffer1[bar]=Value0;  Buffer1[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=1;}}}break;                            
 case 5 :{switch(ind_N2)
         {case 1 : {Buffer2[bar]=Value0;  Buffer2[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=2;}break;    
         default : {Buffer1[bar]=Value0;  Buffer1[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=1;}}}break;         
 case 6 :{switch(ind_N2)
         {case 1 : {Buffer2[bar]=Value0;  Buffer2[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=2;}break;
         default : {Buffer1[bar]=Value0;  Buffer1[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=1;}}} }
}
//================================================================================================
void Down_Trend(){switch(ind_N1)
{   
 case 3 :          {Buffer3[bar]=Value0;  Buffer3[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=3;}break;
 case 4 :          {Buffer4[bar]=Value0;  Buffer4[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=4;}break;         
 case 1 :{switch(ind_N2)
         {case 3 : {Buffer4[bar]=Value0;  Buffer4[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=4;}break; 
         default : {Buffer3[bar]=Value0;  Buffer3[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=3;}}}break;                           
 case 2 :{switch(ind_N2)
         {case 3 : {Buffer4[bar]=Value0;  Buffer4[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=4;}break;
         default : {Buffer3[bar]=Value0;  Buffer3[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=3;}}}break;                           
 case 5 :{switch(ind_N2)
         {case 3 : {Buffer4[bar]=Value0;  Buffer4[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=4;}break;
         default : {Buffer3[bar]=Value0;  Buffer3[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=3;}}}break;       
 case 6 :{switch(ind_N2)
         {case 3 : {Buffer4[bar]=Value0;  Buffer4[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=4;}break;
         default : {Buffer3[bar]=Value0;  Buffer3[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=3;}}} }
}
//================================================================================================
void No_trend(){switch(ind_N1)
{   
 case 5 :          {Buffer5[bar]=Value0;  Buffer5[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=5;}break;
 case 6 :          {Buffer6[bar]=Value0;  Buffer6[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=6;}break;         
 case 1 :{switch(ind_N2)
         {case 5 : {Buffer6[bar]=Value0;  Buffer6[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=6;}break; 
         default : {Buffer5[bar]=Value0;  Buffer5[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=5;}}}break;                          
 case 2 :{switch(ind_N2)
         {case 5 : {Buffer6[bar]=Value0;  Buffer6[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=6;}break;
         default : {Buffer5[bar]=Value0;  Buffer5[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=5;}}}break;                           
 case 3 :{switch(ind_N2)
         {case 5 : {Buffer6[bar]=Value0;  Buffer6[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=6;}break;
         default : {Buffer5[bar]=Value0;  Buffer5[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=5;}}}break;         
 case 4 :{switch(ind_N2)
         {case 5 : {Buffer6[bar]=Value0;  Buffer6[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=6;}break;
         default : {Buffer5[bar]=Value0;  Buffer5[bar+1]=Value1;  ind_N2=ind_N1;  ind_N1=5;}}} }
}
//================================================================================================
                
