/*
//------------------------------------------------------------------
//| 3c_.BBJ_.Osc.mqh |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
# property copyright "Nikolay Kositsin"
# property link "farria@mail.redcom.ru"
# property indicator_.separate_.window
/ the color of the indicator
# property indicator_.buffers 8
# property indicator_.color1 Blue
# property indicator_.color2 Lime
# property indicator_.color3 OrangeRed
# property indicator_.color4 Gray
/ color Bollinger Bands
# property indicator_.color5 Gray
# property indicator_.color6 Gray
# property indicator_.color7 Gray
# property indicator_.color8 Gray
*/
// THE INPUT PARAMETERS OF THE INDICATOR OF---------------------------------------------------------------------------------------------------
extern int Length = 5; //depth JMA of the smoothing
extern int Phase = 100; //parameter JMA of smoothing, which is changedwithin limits of -100... 100, influence the quality of transientprocess;
extern int Bands_.Period = y00;// Bollinger Bands averaging, ifBands_.Period=0, then Bollinger Bands is moved away from the graph
extern double Bands_.Deviations = 1.0; //deviatatsiya
extern int Drow_.style = 0; //the style of the performance of graph 0- in the form of point line, 1 - in the form of histogram, anothervalue - is simple the line
extern int Ind_.Shift = 0; //cdvig indicator along the time axis
extern int BB_.Shift = 0; //cdvig BollingerBands along the time axis
extern double TrendMinimum = 0; //the minimum speed of trend in thepoints
//-------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double Ind_Buffer1 [];
double Ind_Buffer2 [];
double Ind_Buffer3 [];
double Ind_Buffer4 [];
double Ind_Buffer5 [];
double Ind_Buffer6 [];
double Ind_Buffer7 [];
double Ind_Buffer8 [];
//------------------------------------------------------------------
// introduction to function JJMASeries
// introduction to function JJMASeriesResize
// introduction to function JJMASeriesAlert
// introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//------------------------------------------------------------------
//| Custom indicator initialization function |
//------------------------------------------------------------------
int init() 
{
// 4 indicator buffers are used for the calculation
SetIndexBuffer(0,Ind_Buffer1 );
SetIndexBuffer(1,Ind_Buffer2 );
SetIndexBuffer(2,Ind_Buffer3 );
SetIndexBuffer(3,Ind_Buffer4 );
if (Bands_Period>0)
{
// 4 additional indicator buffers are added for the calculation
IndicatorBuffers(8);
 SetIndexBuffer(4,Ind_Buffer5 );
 SetIndexBuffer(5,Ind_Buffer6 );
 SetIndexBuffer(6,Ind_Buffer7 ); 
 SetIndexBuffer(7,Ind_Buffer8 ); 
// the horizontal shift Bollinger Bands
 SetIndexShift (4, BB_Shift ); 
 SetIndexShift (5, BB_Shift ); 
 SetIndexShift (6, BB_Shift ); 
 SetIndexShift (7, BB_Shift ); 
// the installation of the number of the bar, beginning from which willotrisovyvat'sya Bollinger Bands
 int draw_beginBB=COUNT_begin()+Bands_Period+BB_Shift+1;
 SetIndexDrawBegin(4,draw_beginBB+Bands_Period);
 SetIndexDrawBegin(5,draw_beginBB+Bands_Period);
 SetIndexDrawBegin(6,draw_beginBB+Bands_Period);
 SetIndexDrawBegin(7,draw_beginBB+Bands_Period);
// the installation of the values of indicator, which not will be seenon the graph
 SetIndexEmptyValue(4,EmptyValue);
 SetIndexEmptyValue(5,EmptyValue);
 SetIndexEmptyValue(6,EmptyValue);
 SetIndexEmptyValue(7,EmptyValue);
// names for the windows of data and leyby for sub"okon
 SetIndexLabel   (4,"BollingerBands+1"  );
 SetIndexLabel   (5,"BollingerBands-1"  );
 SetIndexLabel   (6,"BollingerBands+2"  );
 SetIndexLabel   (7,"BollingerBands-2"  );
}
// the horizontal shift of the indicator lines
SetIndexShift (0, Ind_Shift); 
SetIndexShift (1, Ind_Shift); 
SetIndexShift (2, Ind_Shift); 
SetIndexShift (3, Ind_Shift); 

// the determination of the style of the performance of the graph
SetIndexStyle(0,DRAW_LINE);
if (Drow_style==0)
{
// the style of the performance of graph the form of the point line
 SetIndexStyle(1,DRAW_ARROW);
 SetIndexStyle(2,DRAW_ARROW);
 SetIndexStyle(3,DRAW_ARROW);
// the determination of the style of the point targets
 SetIndexArrow(1,159);
 SetIndexArrow(2,159);
 SetIndexArrow(3,159);
//
}
if (Drow_style==1)
{
// the style of the performance of graph the form of the histogram
 SetIndexStyle(1,DRAW_HISTOGRAM);
 SetIndexStyle(2,DRAW_HISTOGRAM);
 SetIndexStyle(3,DRAW_HISTOGRAM);
//
}
// the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,EmptyValue);
SetIndexEmptyValue(1,EmptyValue);
SetIndexEmptyValue(2,EmptyValue);
SetIndexEmptyValue(3,EmptyValue);
// names for the windows of data and leyby for sub"okon
IndicatorShortName(""+Label+"");
SetIndexLabel   (0,NULL);
SetIndexLabel   (1,"Up_Trend");
SetIndexLabel   (2,"Down_Trend");
SetIndexLabel   (3,"Straight_Trend");
// the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
IndicatorDigits(digits());
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
int draw_begin=COUNT_begin()+Ind_Shift+1;
SetIndexDrawBegin(0,draw_begin);
SetIndexDrawBegin(1,draw_begin);
SetIndexDrawBegin(2,draw_begin);
SetIndexDrawBegin(3,draw_begin);
// the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Length",Length);
JJMASeriesAlert (1,"Phase", Phase);
// a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
// the completion of the initialization
return(0); 
} 
//------------------------------------------------------------------
//| JTRIX iteration function |
//------------------------------------------------------------------
int start() 
{
// the introduction of variables with the floating point
double Resalt,Out_Series,trend,deviation,sumtotal,midline,priceswing; 
// the introduction of entire variables and obtaining the alreadycalculated bars
int bar,limit,reset,kkk,MaxBar,MaxBarBB,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar=Bars-1-COUNT_begin()-1; MaxBarBB=MaxBar+1-Bands_Period;          
// the load of the values of initial indicator into the buffer
for(bar=limit; bar>=0; bar--)
  {
// turning to function JJMASeries after to numbers 0. ParametersnJMAPhase and nJMALength do not change on each bar (nJMAdin=0)
   Resalt=JJMASeries(0,0,MaxBar,limit,Phase,Length,INDICATOR(bar),bar,reset);
// checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   Ind_Buffer1[bar]=Resalt;
  }
// korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
// initialization of zero
if (limit>MaxBar)
 {
  limit=MaxBar; 
  for(int ttt=Bars-1;ttt>MaxBar;ttt--)
   {
    Ind_Buffer2[ttt]=EmptyValue; 
    Ind_Buffer3[ttt]=EmptyValue; 
    Ind_Buffer4[ttt]=EmptyValue;
    Ind_Buffer5[ttt]=EmptyValue; 
    Ind_Buffer6[ttt]=EmptyValue; 
    Ind_Buffer7[ttt]=EmptyValue;
    Ind_Buffer8[ttt]=EmptyValue; 
   }
 }

// the calculation of the indicator
for(bar=limit;bar>=0;bar--)
{
Out_Series=Ind_Buffer1[bar];

// SSSSSSSSSSSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
trend=Out_Series-Ind_Buffer1[bar+1]; if(MathAbs(trend)<TrendMinimum)trend=0;   
if(trend>0)     {Ind_Buffer2[bar]=Out_Series; Ind_Buffer3[bar]=EmptyValue; Ind_Buffer4[bar]=EmptyValue;}
else{if(trend<0){Ind_Buffer2[bar]=EmptyValue; Ind_Buffer3[bar]=Out_Series; Ind_Buffer4[bar]=EmptyValue;}
else            {Ind_Buffer2[bar]=EmptyValue; Ind_Buffer3[bar]=EmptyValue; Ind_Buffer4[bar]=Out_Series;}}    
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
} 

// calculation Bollinger Bands from the indicator

if (Bands_Period<=0)return(0);
// korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
// initialization of zero
if(limit<MaxBarBB) bar=limit; 
else
 {
  bar=MaxBarBB;
  for(int yyy=MaxBar;yyy>MaxBarBB;yyy--)
   {
    Ind_Buffer5[yyy]=EmptyValue; 
    Ind_Buffer6[yyy]=EmptyValue; 
    Ind_Buffer7[yyy]=EmptyValue;
    Ind_Buffer8[yyy]=EmptyValue; 
   }
 }
//
while(bar>=0)
 {
  sumtotal=0.0;
  kkk=bar+Bands_Period-1;
  midline=0.0;
  for(int iii=0;iii<=Bands_Period-1;iii++)midline=midline+Ind_Buffer1[bar+iii];
  midline=midline/Bands_Period;
  while(kkk>=bar)
   {
    priceswing=Ind_Buffer1[kkk]-midline;
    sumtotal+=priceswing*priceswing;
    kkk--;
   }
  deviation=Bands_Deviations*MathSqrt(sumtotal/Bands_Period); 
  Ind_Buffer5[bar]=midline+deviation; Ind_Buffer6[bar]=midline-deviation;
//
  deviation=2*deviation; 
  Ind_Buffer7[bar]=midline+deviation; Ind_Buffer8[bar]=midline-deviation;
//
  bar--;
 }
// the completion of the calculations of the values of the indicator

return(0); 
} 

//--------------------------------------------------------------------

