/*
For the work of indicator should be assumed fayl.sINDIccATOR_.cOUNTED.mqh
in the folder (directory): MetaTrader\.experts\.include \

//------------------------------------------------------------------
//| 3c_.BB_.Osc.mqh |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
# property copyright "Nikolay Kositsin"
# property link "farria@mail.redcom.ru"
*/
// THE INPUT PARAMETERS OF THE INDICATOR OF------------------------------------------------------------------------------------------------------
extern bool Fast_.Slow_.BB = true; //the selection of the indicator,on which is produced calculation Bollinger Bands
extern int Bands_.Period = y00;// Bollinger Bands averaging, ifBands_.Period=0, then Bollinger Bands is moved away from the graph
extern double Bands_.Deviations = 1.0; //deviatatsiya
extern int Drow_.style = 0; //the style of the performance of graph 0- in the form of point line, 1 - in the form of histogram, anothervalue - is simple the line
extern int Ind_.Shift = 0; //cdvig indicator along the time axis
extern int BB_.Shift = 0; //cdvig BollingerBands along the time axis
extern double TrendMinimum = 0; //the minimum speed of trend in thepoints
//----------------------------------------------------------------------------------------------------------------------------------
// the indicator buffers
double Ind_Buffer1 [];
double Ind_Buffer2 [];
double Ind_Buffer3 [];
double Ind_Buffer4 [];
double Ind_Buffer5 [];
double Ind_Buffer6 [];
double Ind_Buffer7 [];
double Ind_Buffer8 [];
//------------------------------------------------------------------
//| Custom indicator initialization function |
//------------------------------------------------------------------
int init() 
{
// 4 indicator buffers are used for the calculation
SetIndexBuffer(0,Ind_Buffer1 );
SetIndexBuffer(1,Ind_Buffer2 );
SetIndexBuffer(2,Ind_Buffer3 );
SetIndexBuffer(3,Ind_Buffer4 );
if (Bands_Period>0)
{
// 4 additional indicator buffers are added for the calculation
IndicatorBuffers(8);
 SetIndexBuffer(4,Ind_Buffer5 );
 SetIndexBuffer(5,Ind_Buffer6 );
 SetIndexBuffer(6,Ind_Buffer7 ); 
 SetIndexBuffer(7,Ind_Buffer8 ); 
// the horizontal shift Bollinger Bands
 SetIndexShift (4, BB_Shift ); 
 SetIndexShift (5, BB_Shift ); 
 SetIndexShift (6, BB_Shift ); 
 SetIndexShift (7, BB_Shift ); 
// the installation of the number of the bar, beginning from which willotrisovyvat'sya Bollinger Bands
 int draw_beginBB=COUNT_begin()+Bands_Period+BB_Shift+1;
 SetIndexDrawBegin(4,draw_beginBB+Bands_Period);
 SetIndexDrawBegin(5,draw_beginBB+Bands_Period);
 SetIndexDrawBegin(6,draw_beginBB+Bands_Period);
 SetIndexDrawBegin(7,draw_beginBB+Bands_Period);
// the installation of the values of indicator, which not will be seenon the graph
 SetIndexEmptyValue(4,EmptyValue);
 SetIndexEmptyValue(5,EmptyValue);
 SetIndexEmptyValue(6,EmptyValue);
 SetIndexEmptyValue(7,EmptyValue);
// names for the windows of data and leyby for sub"okon
 SetIndexLabel   (4,"BollingerBands+1"  );
 SetIndexLabel   (5,"BollingerBands-1"  );
 SetIndexLabel   (6,"BollingerBands+2"  );
 SetIndexLabel   (7,"BollingerBands-2"  );
}
// the horizontal shift of the indicator lines
SetIndexShift (0, Ind_Shift); 
SetIndexShift (1, Ind_Shift); 
SetIndexShift (2, Ind_Shift); 
SetIndexShift (3, Ind_Shift); 

// the determination of the style of the performance of the graph
SetIndexStyle(0,DRAW_LINE);
if (Drow_style==0)
{
// the style of the performance of graph the form of the point line
 SetIndexStyle(1,DRAW_ARROW);
 SetIndexStyle(2,DRAW_ARROW);
 SetIndexStyle(3,DRAW_ARROW);
// the determination of the style of the point targets
 SetIndexArrow(1,159);
 SetIndexArrow(2,159);
 SetIndexArrow(3,159);
//
}
if (Drow_style==1)
{
// the style of the performance of graph the form of the histogram
 SetIndexStyle(1,DRAW_HISTOGRAM);
 SetIndexStyle(2,DRAW_HISTOGRAM);
 SetIndexStyle(3,DRAW_HISTOGRAM);
//
}
// the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,EmptyValue);
SetIndexEmptyValue(1,EmptyValue);
SetIndexEmptyValue(2,EmptyValue);
SetIndexEmptyValue(3,EmptyValue);
// names for the windows of data and leyby for sub"okon
IndicatorShortName(""+Label+"");
SetIndexLabel   (0,"Fast_"+Label+"");
SetIndexLabel   (1,"Up_Trend");
SetIndexLabel   (2,"Down_Trend");
SetIndexLabel   (3,"Straight_Trend");
// the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
IndicatorDigits(digits());
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
int draw_begin=COUNT_begin()+Ind_Shift+1;
SetIndexDrawBegin(0,draw_begin);
SetIndexDrawBegin(1,draw_begin);
SetIndexDrawBegin(2,draw_begin);
SetIndexDrawBegin(3,draw_begin);
// the style of the performance of the horizontal levels
SetLevelStyle(Levels_Style,Levels_Width,Levels_Color); 
// the completion of the initialization
return(0); 
} 
//------------------------------------------------------------------
//| JTRIX iteration function |
//------------------------------------------------------------------
int start() 
{ 
// the introduction of the variables c by the floating point
double Series,Out_Series,trend,deviation,sumtotal,midline,priceswing,Indicator2[1];
// the introduction of entire variables and obtaining the alreadycalculated bars
int limit,delta,size,bar,kkk,MaxBar,MaxBarBB,counted_bars=IndicatorCounted();
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar=Bars-1-COUNT_begin()-1; MaxBarBB=MaxBar+1-Bands_Period;          
// korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
// initialization of zero
if (limit>MaxBar)
 {
  limit=MaxBar; 
  for(int ttt=Bars-1;ttt>=MaxBar;ttt--)
   {
    Ind_Buffer2[ttt]=EmptyValue; 
    Ind_Buffer3[ttt]=EmptyValue; 
    Ind_Buffer4[ttt]=EmptyValue;
    Ind_Buffer5[ttt]=EmptyValue; 
    Ind_Buffer6[ttt]=EmptyValue; 
    Ind_Buffer7[ttt]=EmptyValue;
    Ind_Buffer8[ttt]=EmptyValue; 
   }
 } 
// THE CALCULATION OF THE RAPID ONE-COLOR JCCIX
for(bar=limit;bar>=0;bar--)Ind_Buffer1[bar]=INDICATOR1(bar);
//
// the load of the values of the slow trichromatic JCCIX into thebuffer for the calculation
  if (Bands_Period<1)delta=2;else delta=Bands_Period;
  size=limit+delta;
  if(size>MaxBar+1)size=MaxBar+1;
  if(ArrayResize(Indicator2,size)<size)
     {
       Print("It was impossible to change the dimensions of buffer Indicator2");
       return(-1);
     }
  for(bar=size-1;bar>=0;bar--)Indicator2[bar]=INDICATOR2(bar);
//

// THE CALCULATION OF THE SLOW TRICHROMATIC JCCIX
for(bar=limit;bar>=0;bar--)
 {
  Out_Series=Indicator2[bar];
  trend=Out_Series-Indicator2[bar+1]; 
  if(MathAbs(trend)<TrendMinimum)trend=0; 
// SSSSSSSSSSSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
  if(trend>0)     {Ind_Buffer2[bar]=Out_Series; Ind_Buffer3[bar]=EmptyValue; Ind_Buffer4[bar]=EmptyValue;}
  else{if(trend<0){Ind_Buffer2[bar]=EmptyValue; Ind_Buffer3[bar]=Out_Series; Ind_Buffer4[bar]=EmptyValue;}
  else            {Ind_Buffer2[bar]=EmptyValue; Ind_Buffer3[bar]=EmptyValue; Ind_Buffer4[bar]=Out_Series;}}    
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
 } 

// CALCULATION BOLLINGER BANDS

if (Bands_Period<=0)return(0);
// korektsiya of the maximum number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
// initialization of zero
if(limit>=MaxBarBB)  
 {
  limit=MaxBarBB;
  for(int yyy=MaxBar;yyy>MaxBarBB;yyy--)
   {
    Ind_Buffer5[yyy]=EmptyValue; 
    Ind_Buffer6[yyy]=EmptyValue; 
    Ind_Buffer7[yyy]=EmptyValue;
    Ind_Buffer8[yyy]=EmptyValue; 
   }
 }
bar=limit;
while(bar>=0)
 {
  sumtotal=0.0;
  kkk=bar+Bands_Period-1;
  midline=0.0;
//
  if(Fast_Slow_BB)for(int iii=0;iii<=Bands_Period-1;iii++)midline+=Ind_Buffer1[bar+iii];
  else for(int jjj=0;jjj<=Bands_Period-1;jjj++)midline+=Indicator2[bar+jjj];
//
  midline/=Bands_Period;
  while(kkk>=bar)
   {
    if(Fast_Slow_BB)priceswing=Ind_Buffer1[kkk]-midline;
    else priceswing=Indicator2[kkk]-midline;
//
    sumtotal+=priceswing*priceswing;
    kkk--;
   }
  deviation=Bands_Deviations*MathSqrt(sumtotal/Bands_Period); 
  Ind_Buffer5[bar]=midline+deviation; Ind_Buffer6[bar]=midline-deviation;
//
  deviation*=2; 
  Ind_Buffer7[bar]=midline+deviation; Ind_Buffer8[bar]=midline-deviation;
//
  bar--;
 }
// the completion of the calculations of the values of the indicator

return(0); 
} 

//----------------------------------------------------------------------------
