//transfer is conducted by Nikolai kositsin 01.12.2006
//------------------------------------------------------------------
//| ErrorDescription_.RUS.mqh |
//| Copyright ? 2004, MetaQuotes Software Corp. |
//| http://www.metaquotes.net/ |
//------------------------------------------------------------------
string ErrorDescription_RUS(int error_code)
 {
  string error_string;
//
  switch(error_code)
    {
// the codes, returned by the commercial server
     case    0:                                                                                                          break;
     case    1: error_string="??? ?????? = "+error_code+". ??? ??????";                                                  break;
     case    2: error_string="??? ?????? = "+error_code+". ????? ??????";                                                break;
     case    3: error_string="??? ?????? = "+error_code+". ???????????? ???????? ?????????";                             break;
     case    4: error_string="??? ?????? = "+error_code+". ???????? ?????? ?????";                                       break;
     case    5: error_string="??? ?????? = "+error_code+". ?????? ??????????? ????????? ????????";                       break;
     case    6: error_string="??? ?????? = "+error_code+". ??? ?????????? ? ???????? ????????";                          break;
     case    7: error_string="??? ?????? = "+error_code+". ???????????? ????";                                           break;
     case    8: error_string="??? ?????? = "+error_code+". ??????? ?????? ??????? ?? ???????? ??????";                   break;
     case    9: error_string="??? ?????? = "+error_code+". ???????????? ????????, ?????????? ???????????????? ???????";  break;
     case   64: error_string="??? ?????? = "+error_code+". ???? ????????????";                                           break;
     case   65: error_string="??? ?????? = "+error_code+". ???????????? ????? ?????";                                    break;
     case  128: error_string="??? ?????? = "+error_code+". ????? ???? ???????? ?????????? ??????";                       break;
     case  129: error_string="??? ?????? = "+error_code+". ?????????? ????";                                             break;
     case  130: error_string="??? ?????? = "+error_code+". ?????????? ????";                                             break;
     case  131: error_string="??? ?????? = "+error_code+". ?????????? ???????? ?????";                                   break;
     case  132: error_string="??? ?????? = "+error_code+". ????? ??????";                                                break;
     case  133: error_string="??? ?????? = "+error_code+". ???????? ?????????";                                          break;
     case  134: error_string="??? ?????? = "+error_code+". ???????????? ????? ??? ?????????? ????????";                  break;
     case  135: error_string="??? ?????? = "+error_code+". ???? ??????????";                                             break;
     case  136: error_string="??? ?????? = "+error_code+". ??? ???";                                                     break;
     case  137: error_string="??? ?????? = "+error_code+". ?????? ?????";                                                break;
     case  138: error_string="??? ?????? = "+error_code+". ????? ????";                                                  break;
     case  139: error_string="??? ?????? = "+error_code+". ????? ???????????? ? ??? ??????????????";                     break;
     case  140: error_string="??? ?????? = "+error_code+". ????????? ?????? ???????";                                    break;
     case  141: error_string="??? ?????? = "+error_code+". ??????? ????? ????????";                                      break;
     case  145: error_string="??? ?????? = "+error_code+". ??????????? ?????????, ??? ??? ????? ??????? ?????? ? ?????"; break;
     case  146: error_string="??? ?????? = "+error_code+". ?????????? ???????? ??????";                                  break;
     case  147: error_string="??? ?????? = "+error_code+". ????????????? ???? ????????? ?????? ????????? ????????";      break;   
     case  148: error_string="??? ?????? = "+error_code
                                +". ?????????? ???????? ? ?????????? ??????? ???????? ???????, ?????????????? ????????"; break;
// MQL4 error
     case 4000: error_string="??? ?????? = "+error_code+". ??? ??????";                                                  break;
     case 4001: error_string="??? ?????? = "+error_code+". ???????????? ????????? ???????";                              break;
     case 4002: error_string="??? ?????? = "+error_code+". ?????? ??????? ?? ????????????? ??? ???????";                 break;
     case 4003: error_string="??? ?????? = "+error_code+". ??? ?????? ??? ????? ???????";                                break;
     case 4004: error_string="??? ?????? = "+error_code+". ???????????? ????? ????? ???????????? ??????";                break;
     case 4005: error_string="??? ?????? = "+error_code+". ?? ????? ??? ?????? ??? ???????? ??????????";                 break;
     case 4006: error_string="??? ?????? = "+error_code+". ??? ?????? ??? ?????????? ?????????";                         break;
     case 4007: error_string="??? ?????? = "+error_code+". ??? ?????? ??? ????????? ??????";                             break;
     case 4008: error_string="??? ?????? = "+error_code+". ???????????????????? ??????";                                 break;
     case 4009: error_string="??? ?????? = "+error_code+". ???????????????????? ?????? ? ???????";                       break;
     case 4010: error_string="??? ?????? = "+error_code+". ??? ?????? ??? ?????????? ???????";                           break;
     case 4011: error_string="??? ?????? = "+error_code+". ??????? ??????? ??????";                                      break;
     case 4012: error_string="??? ?????? = "+error_code+". ??????? ?? ??????? ?? ????";                                  break;
     case 4013: error_string="??? ?????? = "+error_code+". ??????? ?? ????";                                             break;
     case 4014: error_string="??? ?????? = "+error_code+". ??????????? ???????";                                         break;
     case 4015: error_string="??? ?????? = "+error_code+". ???????????? ??????? (never generated error)";                break;
     case 4016: error_string="??? ?????? = "+error_code+". ???????????????????? ??????";                                 break;
     case 4017: error_string="??? ?????? = "+error_code+". ?????? DLL ?? ?????????";                                     break;
     case 4018: error_string="??? ?????? = "+error_code+". ?????????? ????????? ??????????";                             break;
     case 4019: error_string="??? ?????? = "+error_code+". ?????????? ??????? ???????";                                  break;
     case 4020: error_string="??? ?????? = "+error_code+". ?????? ??????? ???????????? ??????? ?? ?????????";            break;
     case 4021: error_string="??? ?????? = "+error_code+". ???????????? ?????? ??? ??????, ???????????? ?? ???????";     break;
     case 4022: error_string="??? ?????? = "+error_code+". ??????? ?????? (never generated error)";                      break;
     case 4050: error_string="??? ?????? = "+error_code+". ???????????? ?????????? ?????????? ???????";                  break;
     case 4051: error_string="??? ?????? = "+error_code+". ???????????? ???????? ????????? ???????";                     break;
     case 4052: error_string="??? ?????? = "+error_code+". ?????????? ?????? ????????? ???????";                         break;
     case 4053: error_string="??? ?????? = "+error_code+". ?????? ???????";                                              break;
     case 4054: error_string="??? ?????? = "+error_code+". ???????????? ????????????? ???????-?????????";                break;
     case 4055: error_string="??? ?????? = "+error_code+". ?????? ????????????????? ??????????";                         break;
     case 4056: error_string="??? ?????? = "+error_code+". ??????? ????????????";                                        break;
     case 4057: error_string="??? ?????? = "+error_code+". ?????? ????????? ??????????? ??????????";                     break;
     case 4058: error_string="??? ?????? = "+error_code+". ?????????? ?????????? ?? ??????????";                         break;
     case 4059: error_string="??? ?????? = "+error_code+". ??????? ?? ????????? ? ???????? ??????";                      break;
     case 4060: error_string="??? ?????? = "+error_code+". ??????? ?? ????????????";                                     break;
     case 4061: error_string="??? ?????? = "+error_code+". ?????? ???????? ?????";                                       break;
     case 4062: error_string="??? ?????? = "+error_code+". ????????? ???????? ???? string";                              break;
     case 4063: error_string="??? ?????? = "+error_code+". ????????? ???????? ???? integer";                             break;
     case 4064: error_string="??? ?????? = "+error_code+". ????????? ???????? ???? double";                              break;
     case 4065: error_string="??? ?????? = "+error_code+". ? ???????? ????????? ????????? ??????";                       break;
     case 4066: error_string="??? ?????? = "+error_code+". ??????????? ???????????? ?????? ? ????????? ??????????";      break;
     case 4067: error_string="??? ?????? = "+error_code+". ?????? ??? ?????????? ???????? ????????";                     break;
     case 4099: error_string="??? ?????? = "+error_code+". ????? ?????";                                                 break;
     case 4100: error_string="??? ?????? = "+error_code+". ?????? ??? ?????? ? ??????";                                  break;
     case 4101: error_string="??? ?????? = "+error_code+". ???????????? ??? ?????";                                      break;
     case 4102: error_string="??? ?????? = "+error_code+". ??????? ????? ???????? ??????";                               break;
     case 4103: error_string="??? ?????? = "+error_code+". ?????????? ??????? ????";                                     break;
     case 4104: error_string="??? ?????? = "+error_code+". ????????????? ????? ??????? ? ?????";                         break;
     case 4105: error_string="??? ?????? = "+error_code+". ?? ???? ????? ?? ??????";                                     break;
     case 4106: error_string="??? ?????? = "+error_code+". ??????????? ??????";                                          break;
     case 4107: error_string="??? ?????? = "+error_code+". ???????????? ???????? ???? ??? ???????? ???????";             break;
     case 4108: error_string="??? ?????? = "+error_code+". ???????? ????? ??????";                                       break;
     case 4109: error_string="??? ?????? = "+error_code+". ???????? ?? ?????????";                                       break;
     case 4110: error_string="??? ?????? = "+error_code+". ??????? ??????? ?? ?????????";                                break;
     case 4111: error_string="??? ?????? = "+error_code+". ???????? ??????? ?? ?????????";                               break;
     case 4200: error_string="??? ?????? = "+error_code+". ?????? ??? ??????????";                                       break;
     case 4201: error_string="??? ?????? = "+error_code+". ????????? ??????????? ???????? ???????";                      break;
     case 4202: error_string="??? ?????? = "+error_code+". ?????? ?? ??????????";                                        break;
     case 4203: error_string="??? ?????? = "+error_code+". ??????????? ??? ???????";                                     break;
     case 4204: error_string="??? ?????? = "+error_code+". ??? ????? ???????";                                           break;
     case 4205: error_string="??? ?????? = "+error_code+". ?????? ????????? ???????";                                    break;
     case 4206: error_string="??? ?????? = "+error_code+". ?? ??????? ????????? ???????";                                break;
     case 4207: error_string="??? ?????? = "+error_code+". ?????? ??? ?????? ? ????????";                                break;
     default:   error_string="??? ?????? = "+error_code+". ??????????? ??????";
    }
//
  return(error_string);
 }
//------------------------------------------------------------------

