/*
/ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//.Version July 1, 2006 |
Editing Nikolay Kositsin 15.06.2006 farria@mail.redcom.ru |
/ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HTF.mqh - this is the file, created for the maximum simplification
writing the indicators, which calculate their values on the basis ofdata s
the drawing of another, larger taymfreyma. Example of use -
file J2JMA_.htf.mq4
//------------------------------------------------------------------
//| HTF.mqh |
//| Copyright ? 2006, GS Conversion only |
//| http://www.gustis.narod.ru; gsb51@mail.ru |
//------------------------------------------------------------------
# property copyright "Copyright ? 2006, GS Conversion only"
# property link "http://www.gustis.narod.ru; gsb51@mail.ru "
/ otrisovka of indicator in the basic window
# property indicator_.chart_.window
/ a quantity of the indicator buffers
# property indicator_.buffers 4
/ the color of the indicator
# property indicator_.color1 Red
# property indicator_.color2 Lime
# property indicator_.color3 Magenta
# property indicator_.color4 Gray
*/
// THE INPUT PARAMETERS OF THE INDICATOR OF-------------------------------------------------------------------------
extern int TFrame_.Period = 240; //elder period in the minutes
extern int Smooth = 48; //sglazhianiye of obtained muvinga. Theoptimum value is equal to the ratio of the periods of elder taymfreymato the period of the graph
extern bool Trend_.Visible = true;// the visualization of theindication of the trend
extern int Trend_.Minimum = 5; //the minimum speed of muvinga, takenfor the trend
extern int Shift = 0; //cdvig indicator along the time axis
//------------------------------------------------------------------------------------------------------
datetime TFrame_Times[]; 
// the indicator buffers
double Ind_Buffer0[];
double Ind_Buffer1[];
double Ind_Buffer2[];
double Ind_Buffer3[];
double Vel_Buffer [];
//
double MINIMUM;
int NTF,time1,weight;
//------------------------------------------------------------------
//| HTF initialization function |
//------------------------------------------------------------------
int init() 
  { 
// the indicators of ----------------------------------------------

// the style of the performance of graph in the line
   SetIndexStyle(0,DRAW_LINE);
// the style of the performance of graph the form of the point line
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
// the determination of the style of the point targets
   SetIndexArrow(1,159);
   SetIndexArrow(2,159);
   SetIndexArrow(3,159);
// the horizontal shift of the indicator lines
   SetIndexShift(0, Shift); 
   SetIndexShift(1, Shift);
   SetIndexShift(2, Shift);
   SetIndexShift(3, Shift);
// name for the windows of data and leyby for sub"okon
   IndicatorShortName(""+Label+"");
   SetIndexLabel   (0,""+Label+""+"_HTF3");
   SetIndexLabel   (1,"Up_Trend");
   SetIndexLabel   (2,"Down_Trend");
   SetIndexLabel   (3,"Straight_Trend");
// 5 indicator buffers are used for the calculation
   IndicatorBuffers(5);
   SetIndexBuffer(0,Ind_Buffer0);
   SetIndexBuffer(1,Ind_Buffer1); 
   SetIndexBuffer(2,Ind_Buffer2); 
   SetIndexBuffer(3,Ind_Buffer3); 
   SetIndexBuffer(4,Vel_Buffer); 
// the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,EmptyValue); 
   SetIndexEmptyValue(1,EmptyValue); 
   SetIndexEmptyValue(2,EmptyValue); 
   SetIndexEmptyValue(3,EmptyValue); 
// the initialization of the constants
   MINIMUM=Trend_Minimum*Point;
   weight=0;
   if (Smooth>1)for(int fff=1; fff<=Smooth; fff++)weight+=fff;
   NTF=TFrame_Period/Period(); 
// the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(digits());
// the Alerts of ------------------------------------------------
   if (TFrame_Period !=1 && TFrame_Period !=5 && TFrame_Period !=15 && TFrame_Period !=30 && TFrame_Period !=60 && TFrame_Period !=240 && TFrame_Period !=1440 && TFrame_Period != 10080)
      { 
       Alert("Chart ", Symbol(), "???????? TimeFrame_period ????? ???? ?????? ?????????: 1, 5, 15, 30, 60, 240, 1440, 7200, 10080.\n" +
                                 "????????? ????? ???????????? ??????? ?????? ???????");
       TFrame_Period=Period();
      }
   if (Period()>= TFrame_Period) 
      {
       TFrame_Period = Period();
       Alert("???????? TimeFrame_period ?????? ???? ?????? ??????? ???????! ????????? ????? ???????????? ??????? ?????? ???????");
      }
//
//everything Time[ ] series of time are sorted out in the direction ofthe decrease
   ArrayCopySeries(TFrame_Times,MODE_TIME,Symbol(),TFrame_Period); 
   return(0); 
  } 
//------------------------------------------------------------------
//| HTF iteration function |
//------------------------------------------------------------------
int start() 
  { 
// the introduction of the entire variables
   int TFlimit,MaxBar,MaxBarS,bar,bar0,bar1,Dbar,MaxBarTF,TFbar,limit; 
// the introduction of variables with the floating point
   double Vel0,Vel1,trend,sum,price,lsum;
//
// the determination of the maximum values of the numbers of bars inthe cycles
   MaxBar=Bars-1; 
   MaxBarTF=iBarShift(NULL,TFrame_Period,Time[MaxBar-1],false)-2;
   MaxBarS=iBarShift(NULL,0,TFrame_Times[MaxBarTF+1],false)-Smooth;
   
//
// obtaining the already calculated bars
// the search for the last neposchitannogo bar
   if (time1!=0)
     {
       TFlimit=iBarShift(NULL,TFrame_Period,time1,false); 
       if (TFlimit<=0)
        {
         TFlimit=MaxBarTF;
         Print("The last neposchitannyy bar is not found");
         Print("The calculation of indicator will be produced on all bars");
        }
     }
   else TFlimit=MaxBarTF;
// the retention of the time of the discovery the last neposchitannogobar
   time1=TFrame_Times[1]; 
//
// initialization of zero
   if (TFlimit>=MaxBarTF)
     {
      TFlimit=MaxBarTF;
Limit=(.TFlimit Y)*.NTF of y;//.limit=.iBarSyuift(.NULL,0.TFrame_.Times[.TFlimit 1].false) 1;
      for(int nnn=MaxBar;nnn>limit;nnn--)
        {
         Vel_Buffer [nnn]=EmptyValue;
         Ind_Buffer0[nnn]=EmptyValue;
         Ind_Buffer1[nnn]=EmptyValue;
         Ind_Buffer2[nnn]=EmptyValue;
         Ind_Buffer3[nnn]=EmptyValue;
        }  
     }
else limit=(.TFlimit Y)*.NTF of 2;//.limit=.iBarSyuift(.NULL,0.TFrame_.Times[.TFlimit 1].truye) 1;
//
 
   if (limit>MaxBarS)
     {
      for(int xxx=limit;xxx>MaxBarS;xxx--)
         {
         Vel_Buffer [xxx]=EmptyValue;
         Ind_Buffer0[xxx]=EmptyValue;
         Ind_Buffer1[xxx]=EmptyValue;
         Ind_Buffer2[xxx]=EmptyValue;
         Ind_Buffer3[xxx]=EmptyValue;
        }  
      limit=MaxBarS;
     }   
// --------------------
   
// THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
   for(TFbar=TFlimit;TFbar>=-1;TFbar--)  
      {  
        if (TFbar!=-1)bar=iBarShift(NULL,0,TFrame_Times[TFbar],false);else bar=0; 
        Vel_Buffer[bar]=INDICATOR(TFbar+1);
        if ((TFbar==0)&&(bar==0))break;
      }
// linear interpolation of the absent values
   if (TFlimit==MaxBarTF)TFlimit--;    
   for(TFbar=TFlimit;TFbar>=-1;TFbar--) 
      {
// the determination of points and interval of interpolation
       if (TFbar!=-1)bar0=iBarShift(NULL,0,TFrame_Times[TFbar],false);else bar0=0;
       bar1=iBarShift(NULL,0,TFrame_Times[TFbar+1],false);
       Dbar=bar1-bar0;
// the determination of values at the points of interpolation
       Vel1=Vel_Buffer[bar1];
       Vel0=Vel_Buffer[bar0];
// checking to the absence of the error
       if((Vel1==0)||( Vel0==0)||(Dbar==0))
         { 
           Print("Error with obtaining of values at the points of interpolation");
           Print("The conversion of indicator will be produced on all bars");
           return(-1);
         }
// linear interpolation
       for(int iii=Dbar-1;iii>0;iii--) Vel_Buffer[bar0+iii]=Vel1+(Vel0-Vel1)*(Dbar-iii)/Dbar;
       if ((TFbar==0)&&(bar0==0))break;
      } 
//
// LWMA the smoothing of obtained muvinga
   if (Smooth> 1)
    {
     sum=0;
     lsum=0;
     bar=limit+Smooth;
     for(int sss=1;sss<=Smooth;sss++,bar--)
      {
      price=Vel_Buffer[bar];
      sum+=price*sss;
      lsum+=price;
      }
     sss=Smooth;
     for(bar=limit;bar>=0;bar--)   
      {
       Ind_Buffer0[bar]=sum/weight;
       if(bar==0) break;
       price=Vel_Buffer[bar];
       sum=sum-lsum+price*Smooth;
       lsum-=Vel_Buffer[bar+sss];
       lsum+=price;
      }
    }
//
   if (Smooth<=1)for(bar=limit;bar>=0;bar--)Ind_Buffer0[bar]=Vel_Buffer [bar];  
      
// the calculation of the indicators of the trend
   if (Trend_Visible==true)
      {
// initialization of zero
        for(int kkk=limit;kkk>=0;kkk--) 
          {
            Ind_Buffer1[kkk]=EmptyValue;
            Ind_Buffer2[kkk]=EmptyValue;
            Ind_Buffer3[kkk]=EmptyValue;
          }
//
        if (TFlimit==MaxBarTF-1)TFlimit--; 
       for(TFbar=TFlimit+1;TFbar>=-1;TFbar--) 
          {
           if (TFbar!=-1)bar0=iBarShift(NULL,0,TFrame_Times[TFbar],false);else bar0=0;
           bar1=iBarShift(NULL,0,TFrame_Times[TFbar+1],false);
// the trichromatic code
          trend=Ind_Buffer0[bar0]-Ind_Buffer0[bar1];
          if (MathAbs(trend)<MINIMUM)trend=0;
          if (trend>0)Ind_Buffer1[bar0]=Ind_Buffer0[bar0];
          else if (trend<0)Ind_Buffer2[bar0]=Ind_Buffer0[bar0];
          else Ind_Buffer3[bar0]=Ind_Buffer0[bar0];
          if ((TFbar==0)&&(bar0==0))break;
//
         }
      } 
// the completion of the calculations of the values of the indicator
    return(0);
  }
//--------------------------------------------------------------------

