//.Version January 1, 2007
//------------------------------------------------------------------
//| PriceSeries.mqh |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
//function PriceSeries() returns the input price of bar according toits number nPriceSeries.Bar and
//according to the number of price PriceSeries.Input_.Price_.Customs:
TO //(0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH,
//Y0-0.SHCH*.TRENDFOLLOSH, yy-.Yueiken Ashi High, y2-.Yueiken AshiLow, ye-.Yueiken Ashi Open, yya-.Yueiken Ashi Close,
//the example: minuse = PriceSeries(.Input_.Price_.Customs, bar) -PriceSeries(.Input_.Price_.Customs, bar 1);
//or; Momentum = PriceSeries(.Input_.Price_.Customs, bar) -PriceSeries(.Input_.Price_.Customs, bar Momentum_.Period);
  
//.SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
//|
//.SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

double PriceSeries(int PriceSeries.Input_Price_Customs, int nPriceSeries.Bar)
 {
  double dPriceSeries;
  switch(PriceSeries.Input_Price_Customs)
   {
    case  0: dPriceSeries = Close[nPriceSeries.Bar];break;
    case  1: dPriceSeries = Open [nPriceSeries.Bar];break;
    case  2: dPriceSeries = High [nPriceSeries.Bar];break;
    case  3: dPriceSeries = Low  [nPriceSeries.Bar];break;
    case  4: dPriceSeries =(High [nPriceSeries.Bar]+Low  [nPriceSeries.Bar])/2;break;
    case  5: dPriceSeries =(Close[nPriceSeries.Bar]+High [nPriceSeries.Bar]+Low[nPriceSeries.Bar])/3;break;
    case  6: dPriceSeries =(Open [nPriceSeries.Bar]+High [nPriceSeries.Bar]+Low[nPriceSeries.Bar]+Close[nPriceSeries.Bar])/4;break;
    case  7: dPriceSeries =(Open [nPriceSeries.Bar]+Close[nPriceSeries.Bar])/2;break;
    case  8: dPriceSeries =(Close[nPriceSeries.Bar]+High [nPriceSeries.Bar]+Low[nPriceSeries.Bar]+Close[nPriceSeries.Bar])/4;break;
    case  9: dPriceSeries = TrendFollow00(nPriceSeries.Bar);break;
    case 10: dPriceSeries = TrendFollow01(nPriceSeries.Bar);break;
    case 11: dPriceSeries = iCustom(NULL,0,"Heiken Ashi#",0,nPriceSeries.Bar);break;
    case 12: dPriceSeries = iCustom(NULL,0,"Heiken Ashi#",1,nPriceSeries.Bar);break;
    case 13: dPriceSeries = iCustom(NULL,0,"Heiken Ashi#",2,nPriceSeries.Bar);break;
    case 14: dPriceSeries = iCustom(NULL,0,"Heiken Ashi#",3,nPriceSeries.Bar);break;

    default: dPriceSeries = Close[nPriceSeries.Bar];
   }
  return(dPriceSeries);
 }
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
// the introduction to function TrendFollow00. for case of 9--------------------------------------------
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
double TrendFollow00(int nTrendFollow00.Bar)
 {
  double dTrendFollow00;
  double dTrendFollow00.high= High [nTrendFollow00.Bar];
  double dTrendFollow00.low=  Low  [nTrendFollow00.Bar];
  double dTrendFollow00.open= Open [nTrendFollow00.Bar];
  double dTrendFollow00.close=Close[nTrendFollow00.Bar];

  if(dTrendFollow00.close>dTrendFollow00.open)dTrendFollow00 = dTrendFollow00.high;
  else
  {
  if(dTrendFollow00.close<dTrendFollow00.open)dTrendFollow00 = dTrendFollow00.low;
                                                 else dTrendFollow00 = dTrendFollow00.close;
  }
  return(dTrendFollow00);
 }
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
// the introduction to function TrendFollow01. for case of 10-------------------------------------------
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
double TrendFollow01(int nTrendFollow01.Bar)
 {
  double dTrendFollow01;
  double dTrendFollow01.high= High [nTrendFollow01.Bar];
  double dTrendFollow01.low=  Low  [nTrendFollow01.Bar];
  double dTrendFollow01.open= Open [nTrendFollow01.Bar];
  double dTrendFollow01.close=Close[nTrendFollow01.Bar];

  if(dTrendFollow01.close>dTrendFollow01.open)
                        dTrendFollow01 =(dTrendFollow01.high+dTrendFollow01.close)/2;
  else
   {
  if(dTrendFollow01.close<dTrendFollow01.open)
                        dTrendFollow01 = (dTrendFollow01.low+dTrendFollow01.close)/2;
                   else dTrendFollow01 = dTrendFollow01.close;
   }
  return(dTrendFollow01);
 }
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
// introduction to function PriceSeriesAlert of-----------------------------------------------------
//function PriceSeriesAlert() is intended for the indication of theinadmissible value of the parameter |
//PriceSeries.Input_.Price_.Customs transferred to functionPriceSeries(). |
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
void PriceSeriesAlert(int nPriceSeriesAlert.IPC)
 {
  if(nPriceSeriesAlert.IPC< 0)
      Alert("???????? Input_Price_Customs ?????? ???? ?? ?????  0" 
               + " ?? ????? ???????????? "+nPriceSeriesAlert.IPC+ " ????? ???????????? 0");
  if(nPriceSeriesAlert.IPC>14)
      Alert("???????? Input_Price_Customs ?????? ???? ?? ????? 14" 
               + " ?? ????? ???????????? "+nPriceSeriesAlert.IPC+ " ????? ???????????? 0");
 }
//---------------------------------------------------------------------------------------
