/*
//------------------------------------------------------------------
//| TrendSignalSupr.mqh |
//| TrendSignal: Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
## property copyright "Copyright ? 2006, Nikolay Kositsin"
# property link "farria@mail.redcom.ru"
/ otrisovka of indicator in the main window
# property indicator_.chart_.window
/ a quantity of the indicator buffers
# property indicator_.buffers 2
/ the color of the indicator
# property indicator_.color1 Magenta
# property indicator_.color2 Yellow
*/
// THE INPUT PARAMETERS OF THE INDICATOR OF----------------------------------------
extern int Swing = 10; //vertical cdvig indicator in the points
extern int Shift = 0; //cdvig indicator along the time axis
//---------------------------------------------------------------------
// the indicator buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
double Vel_Buffer [];
//
double SWING;
//------------------------------------------------------------------
//| TrendSignal indicator initialization function |
//------------------------------------------------------------------
int init() 
{ 
// the determination of the style of the performance of the graph
SetIndexStyle(0,DRAW_ARROW); 
SetIndexStyle(1,DRAW_ARROW); 
SetIndexArrow(0, Simbol1);
SetIndexArrow(1, Simbol2);
// 3 indicator buffers are used for the calculation
IndicatorBuffers(3);
SetIndexBuffer(0,Ind_Buffer1);
SetIndexBuffer(1,Ind_Buffer2); 
SetIndexBuffer(2,Vel_Buffer); 
// the horizontal shift of the indicator
SetIndexShift (0, Shift); 
SetIndexShift (1, Shift); 
// the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,EmptyValue); 
SetIndexEmptyValue(1,EmptyValue); 
// the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
int drow_begin=COUNT_begin()+Shift+2;  
SetIndexDrawBegin(0,drow_begin);
SetIndexDrawBegin(1,drow_begin); 
// names for the windows of data and leyby for sub"okon
IndicatorShortName(""+Label+""+"TrendSigmnal");
SetIndexLabel(0,"Up_Trend");
SetIndexLabel(1,"Up_Trend");
//
IndicatorDigits(digits());
// the initialization of the variable
SWING=Swing*Point;
// the completion of the initialization
return(0); 
} 

//------------------------------------------------------------------
//| TrendSigmnal iteration function |
//------------------------------------------------------------------
int start() 
{ 
// the introduction of variables with the floating point
double trend1,trend0,JurX,Error,Price;
// the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,limit,bar,counted_bars=IndicatorCounted(); 
// checking to the possible errors
if (counted_bars<0)return(-1);
// the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
// the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; 
MaxBar=Bars-1-COUNT_begin()-2;           
// the load of the values of initial indicator into the buffer
for(bar=limit; bar>=0; bar--)Vel_Buffer[bar]=INDICATOR(bar);

// initialization of zero
if (limit>MaxBar)   
 {
  for(bar=MaxBar;bar>=MaxBar;bar--)
   {
    Ind_Buffer1[bar]=0;
    Ind_Buffer2[bar]=0;
   }
  limit=MaxBar;
 }  
// THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(bar=limit;bar>=0;bar--)
 { 
 
  Ind_Buffer1[bar]=0;
  Ind_Buffer2[bar]=0; 
   
  trend1=Vel_Buffer[bar+1]-Vel_Buffer[bar+2];
  trend0=Vel_Buffer[bar+0]-Vel_Buffer[bar+1];
  
  if      ((trend1>=0)&&(trend0<0))Ind_Buffer1[bar]=High[bar]+SWING;
  else if ((trend1<=0)&&(trend0>0))Ind_Buffer2[bar]=Low [bar]-SWING;   
 }

// the completion of the calculations of the values of the indicator
return(0); 
} 
//------------------------------------------------------------------------


