//redaktirovano and are corrected 1.07.2006 Nikolai kositsin
/*
For the work of indicator should be placed the files
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.experts\.indicators \
*/
//+------------------------------------------------------------------+
//|                                                           AMA.mq4|
//|                                                                  |
//| GOODMAN
//+------------------------------------------------------------------+
# property copyright "Copyright ? 2004, by GOODMAN
#property link      ""
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of indicator bufferov
#property indicator_buffers 1
//the color of the indicator
#property indicator_color1 Red
//---- input parameters
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int periodAMA = 9; //period AMA
extern int nfast = 2; //period of rapid YEMA
extern int nslow = 30; //period of slow YEMA
extern double G = 2.0; //the degree, into which is raised smoothingout konsttanta
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//---- buffers
double kAMAbuffer[];
//the introduction of variables with the floating point
double dSC,slowSC,fastSC;
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//|  AMA initialization function                                     |
//+------------------------------------------------------------------+
int init()
  {
//the determination of the style of the performance of the graph
   SetIndexStyle(0,DRAW_LINE);
//1 indicator buffer is used for the calculation
   SetIndexBuffer(0,kAMAbuffer); 
//the installation of Alerts at the inadmissible values of the inputparameters
   PriceSeriesAlert(Input_Price_Customs);
//the initialization of the constants
   slowSC=(2.0 /(nslow+1));
   fastSC=(2.0 /(nfast+1)); 
   dSC=fastSC-slowSC; 
//the installation of the size of the accuracy of mapping theindicator
   IndicatorDigits(Digits);
//name for the windows of data and leyba for sub"okon
   IndicatorShortName ("AMA( periodAMA="+periodAMA+")"); 
   SetIndexLabel (0, "AMA");
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+
//|  AMA iteration function                                          |
//+------------------------------------------------------------------+
int start()
  {
//checking a quantity of bars to the sufficiency for the calculation
if (Bars<periodAMA+2)return(0);
//the introduction of variables with the floating point
double noise,AMA,signal,ER,ERSC,SSC,price0,price1;
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,bar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-periodAMA-2;
bar=Bars-counted_bars-1; 
//initialization of zero
if (bar>MaxBar)
      {
       for (int ii=bar; ii>MaxBar;ii--)kAMAbuffer[ii]=0.0;
       bar=MaxBar;
       AMA=PriceSeries(Input_Price_Customs,bar + 1);
      }
else AMA=kAMAbuffer[bar+1];
//the basic cycle
while (bar>=0)
     {
      noise=Point/100000;
      for(int jj=0;jj<periodAMA;jj++)
                {
                 price0=PriceSeries(Input_Price_Customs,bar+jj+0);
                 price1=PriceSeries(Input_Price_Customs,bar+jj+1);
                 noise=noise+MathAbs(price0-price1);
                }
      price0=PriceSeries(Input_Price_Customs,bar);
      price1=PriceSeries(Input_Price_Customs,bar+periodAMA);                         
      signal=MathAbs(price0-price1);
      ER =signal/noise;
      ERSC=ER*dSC;
      SSC=ERSC+slowSC;
      AMA=AMA+(MathPow(SSC,G)*(price0-AMA));  
      kAMAbuffer[bar]=AMA;
      bar--;
     }
//----
   return(0);
  }
//+-----------------------------------------------------+

