//redaktirovano and are corrected 17.04.2006 Nikolai kositsin
/*
For the work of indicator should be placed the files
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
*/
//+------------------------------------------------------------------+ 
//|                                          BrainTrend1StopLine.mq4 |          
//|                               Copyright ? 2005, BrainTrading Inc |
//|                                      http://www.braintrading.com |
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2005, BrainTrading Inc."
#property link      "http://www.braintrading.com"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Aqua
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//indicator buffery
double Ind_Buffer1[];
double Ind_Buffer2[];
//----
int f,x1,x2,value11,limit,p,MEMORY,time2;
double val1,val2,val3,r,s,d;
double value2,value3,value4,value5,value6,Range,range1;
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+ 
int init()
{
//indicator 0
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,Ind_Buffer1);
//indicator 1
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Ind_Buffer2);
//names for the windows of data and leyby for sub"okon
string short_name;
short_name="BrainTrend1StopLine";
IndicatorShortName(short_name);
SetIndexLabel(0,""+short_name+"_SELL");
SetIndexLabel(1,""+short_name+"_BUY" );
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
IndicatorDigits(Digits);
//the installation of Alerts at the inadmissible values of the inputparameters
PriceSeriesAlert(Input_Price_Customs);
//----
s=1.5; d=2.3; f=7; value11 = 9; x1 = 53; x2 = 47;
//----
return(0);
}
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+ 
int start()
{
//checking a quantity of bars to the sufficiency for the calculation
if (Bars < 11)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars

int MaxBar,Tnew,bar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of all bars
MaxBar=Bars-1-10;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion only of new bars
limit=Bars-counted_bars-1; 
if (limit>MaxBar)limit=MaxBar;
Comment("BrainTrading Inc. System 7.0");
Tnew=Time[limit+1];
//--- the restoration of the values of variable======================
if (limit<MaxBar)
 if (Tnew==time2)p=MEMORY; 
 else
  {
   if (Tnew>time2)
Print("Owibka restoration of variables!!! Tnew time2");
Else Print("Owibka Restoration of variables!!! Tnew
Print("Budet is produced the conversion of indicator on all bars!");
   return(-1);  
  }
//+--- +=========================================================+
   bar=limit;
   while(bar>=0)
      {
//--- the retention of the values of variable ====
      if (bar==1)
       if(((limit==1)&&(time2==Time[2]))||(limit>1))
        {
         time2=Time[2];
         MEMORY=p;
        }
      //+---+====================================+
Range  = iATR(NULL,0,f, bar) / d;
range1 = iATR(NULL,0,10,bar) * s;
value2 = iStochastic(NULL,0,value11,value11,1,0,0,0,bar);
val1 = 0;
val2 = 0;
val3 = MathAbs(PriceSeries(Input_Price_Customs,bar) - PriceSeries(Input_Price_Customs,bar+2));
if (value2 < x2 && val3 > Range&& p != 1 )
{
value3 = High[bar] + range1 / 4;
val1 = value3;
p = 1;
r = val1;
Ind_Buffer1[bar]=val1;
Ind_Buffer2[bar]=EMPTY_VALUE;
}
if (value2 > x1 && val3 > Range&& p != 2 )
{
value3 = Low[bar] - range1 / 4;
val2 = value3;
p = 2;
r = val2;
Ind_Buffer1[bar]=EMPTY_VALUE;
Ind_Buffer2[bar]=val2;
}
value4 = High[bar] + range1;
value5 = Low [bar] - range1;
if (val1 == 0 && val2 == 0 && p == 1)
{
if (value4 < r)
{
r = value4;
Ind_Buffer1[bar]=r;
Ind_Buffer2[bar]=EMPTY_VALUE;
}
else
{
//r = r;
Ind_Buffer1[bar]=r;
Ind_Buffer2[bar]=EMPTY_VALUE;
}
}
if (val1 == 0 && val2 == 0 && p == 2 )
{
if (value5 > r )
{
r = value5;
Ind_Buffer1[bar]=EMPTY_VALUE;
Ind_Buffer2[bar]=r;
}
else
{
//r = r;
Ind_Buffer1[bar]=EMPTY_VALUE;
Ind_Buffer2[bar]=r;
}
}
bar--;
}
//----
return(0);
}
//+----------------------------------------------------+

