//redaktirovano and are corrected 17.04.2006 Nikolai kositsin
/*
For the work of indicator should be placed the files
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.experts\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                  BrainTrend2.mq4 |
//|                               Copyright ? 2005, BrainTrading Inc |
//|                                      http://www.braintrading.com |
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2005, BrainTrading Inc."
#property link      "http://www.braintrading.com"
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 2
//the color of the indicator
#property indicator_color1 BlueViolet 
#property indicator_color2 Red
//is upper the lower limitation of the scale of the window of theindicator
#property indicator_maximum 1.1
#property indicator_minimum 0.9
//the thickness of the indicator lines
#property indicator_width1 0
#property indicator_width2 0
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close.)
extern int Simbol1=108; //the exterior view of symbol for the growingtrend
extern int Simbol2=108; //the exterior view of symbol for the fallingtrend
//---- -------------------------------------------------------------------------------------------------------------------------------+
//indicator buffery
double Ind_Buffer1[];
double Ind_Buffer2[];
double spread;
//----
bool   river=True,RIVER;
int    artp,limit,Curr,glava,time2,GLAVA;
double dartp,cecf,Emaxtra,widcha,TR,EMAXTRA,VALUES[1];
double Values[1],ATR,Weight,val1,val2,low,high,Series1;
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+ 
//| BrainTrend2 initialization function                              |
//+------------------------------------------------------------------+ 
int init()
  {
//the style of the performance of graph the form of the symbols
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
//the determination of the style of the point targets
   SetIndexArrow(0,Simbol1);
   SetIndexArrow(1,Simbol2);
//2 indicator buffers are used for the calculation
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexBuffer(1,Ind_Buffer2);
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(0);
   spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;
//the installation of Alerts at the inadmissible values of the inputparameters
   PriceSeriesAlert(Input_Price_Customs);
//----  
   dartp=7.0; cecf=0.7; artp=7;  
//a change in the sizes of the buffers
   ArrayResize( Values, artp);
   ArrayResize( VALUES, artp);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+ 
//| BrainTrend2 iteration function                                   |
//+------------------------------------------------------------------+ 
int start()
  {
//checking a quantity of bars to the sufficiency for the calculation
if (Bars < 11)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int limit,MaxBar,bar,J,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of all bars
MaxBar=Bars-3;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion only of new bars
limit=(Bars-1-counted_bars);
//initialization of zero
if(limit>=MaxBar)
 {
  limit = MaxBar;
  Emaxtra = PriceSeries(Input_Price_Customs,limit+1);
  glava=0;
  double T_Series2=PriceSeries(Input_Price_Customs,limit+2);
  double T_Series1=PriceSeries(Input_Price_Customs,limit+1);
  if(T_Series2 > T_Series1) river = True; else river = False;
  for (int ii=Bars-1; ii>MaxBar;ii--)
   { 
    Ind_Buffer1[ii]=0.0;
    Ind_Buffer2[ii]=0.0;
   }
 } 
//----
//--- the restoration of the values of variable ================
int Tnew=Time[limit+1];
if (limit<MaxBar)
 if (Tnew==time2)
   {
    for(int xx=0;xx<=artp-1;xx++)Values[xx]=VALUES[xx];
    glava=GLAVA;
    Emaxtra=EMAXTRA;
    river = RIVER;
   }  
 else
  {
   if (Tnew>time2)
Print("Owibka restoration of variables!!! Tnew time2");
Else Print("Owibka Restoration of variables!!! Tnew
Print("Budet is produced the conversion of indicator on all bars!");
   return(-1);  
  }
//+--- +==================================================+
//--- the basic cycle of the calculation of the indicator
bar=limit;
while(bar>=0)      
   {  
//--- the retention of the values of variable =============
      if (bar==1)
         if(((limit==1)&&(time2!=Time[2]))||(limit>1))
           {
            for(int kk=0;kk<=artp-1;kk++)VALUES[kk]=Values[kk];
            GLAVA=glava;
            EMAXTRA=Emaxtra;
            RIVER=river;
            time2=Time[2];
           }
      //+---+============================================+
      Series1=PriceSeries(Input_Price_Customs,bar + 1);
      low=Low [bar];high=High[bar];
      TR = spread + high - low;
      if( MathAbs(spread + high - Series1) > TR ) TR = MathAbs(spread + high - Series1);
      if( MathAbs(low - Series1) > TR)  TR = MathAbs(low - Series1);
      if (bar == MaxBar)for(J=0;bar<=artp-1;J++)Values[J] = TR;    
 		Values[glava] = TR;
      ATR = 0;
      Weight = artp;
      Curr = glava;
      for (J = 0;J<=artp - 1;J++) 
      {
      ATR += Values[Curr] * Weight;
      Weight -= 1.0;
      Curr--;
      if (Curr == -1) Curr = artp - 1;
      }
      ATR = 2.0 * ATR / (dartp * (dartp + 1.0));
      glava++;
      if (glava == artp) glava = 0;
      widcha = cecf * ATR;
      if (river && low < Emaxtra - widcha) 
      {
         river = False;
         Emaxtra = spread + high;
      }
      if (!river && spread + high > Emaxtra + widcha) 
      {
         river = True;
         Emaxtra = low;
      }
      if (river && low > Emaxtra) 
      {
         Emaxtra = low;
      }
      if (!river && spread + high < Emaxtra ) 
      {
         Emaxtra = spread + high;
      }
      //Range1 = iATR(NULL,0,10,bar);
      if( river==true ) 
      {
         val1 = 1;
         val2 = 0;
      } 
      else 
      {
         val1 = 0;
         val2 = 1;
      }
      Ind_Buffer1[bar]=val1;
      Ind_Buffer2[bar]=val2;  
      bar--;
   }  
//----
   return(0);
  }
//+---------------------------------------------------+

