/*
//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+ 
//Version  July 20, 2006                                             |
Editing   Nikolay Kositsin  15.06.2006  farria@mail.redcom.ru        |
//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+ 
*/
//+------------------------------------------------------------------+
//|                                                         NRTR.mq4 |
//|                                        Ramdass - Conversion only |
//+------------------------------------------------------------------+
#property copyright "CRamdass - Conversion only" 
#property link "" 
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of indicator bufferov
#property indicator_buffers 2 
//the color of the indicator
#property indicator_color1 Blue
#property indicator_color2 DarkOrange
//the thickness of the indicator lines
#property indicator_width1 1
#property indicator_width2 1
//THE INPUT PARAMETERS OF THE INDICATOR OF -----
extern int AveragePeriod = 10;
extern int    UpSymbol   = 167;//= 159;
extern int    DownSymbol = 167;//= 159;
//---- +---------------------------------+
//indicator buffery
double Ind_Buffer1[];
double Ind_Buffer2[];
//+------------------------------------------------------------------+
//| NRTR initialization function                                     |
//+------------------------------------------------------------------+
int init()
  {
//2 indicator buffera are used for the calculation
   SetIndexBuffer(0, Ind_Buffer1);
   SetIndexBuffer(1, Ind_Buffer2);
//the style of the performance of the graph
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(0, UpSymbol);
   SetIndexArrow(1, DownSymbol);
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
//name for the windows of data and leyba for sub"okon
   SetIndexLabel(0, "NRTRUp(" + AveragePeriod + ")");    
   SetIndexLabel(1, "NRTRDown(" + AveragePeriod + ")"); 
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0,AveragePeriod); 
   SetIndexDrawBegin(1,AveragePeriod); 
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
   IndicatorDigits(Digits);  
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+
//| NRTR                                                             |
//+------------------------------------------------------------------+
int start()
  {
//checking a quantity of bars to the sufficiency for the calculation
   if(Bars <= AveragePeriod)return(0);
//the introduction of the variables of the memory
   static double PRICE,RESALT; static bool TREND; static int time2;
//the introduction of variables with the floating point
   double Resalt,close,open,dK,AvgRange,price,NewVel;
//the introduction of the logical variables
   bool   trend;
//the introduction of entire variables and obtaining the alreadycalculated bars
   int bar, MaxBar,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
   if (counted_bars<0)return(-1);
//the last calculated bar must be converted
   if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich will be produced the complete conversion of all bars
   MaxBar=Bars-1-AveragePeriod;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion only of new bars
   limit=Bars-1-counted_bars;
//--- the restoration of the values of variable=============================
   int Tnew=Time[limit+1];
   if (limit<MaxBar)
   if (Tnew==time2)
     {
       price=PRICE;   
       trend=TREND; 
       Resalt=RESALT;
     } 
   else 
     {
      if (Tnew>time2)
Print("Owibka restoration of variables!!! Tnew time2");
Else Print("Owibka Restoration of variables!!! Tnew
Print("Budet is produced the conversion of indicator on all bars!");
      return(-1);  
     }
   //+--- +================================================================+
//initialization of zero
   if(limit>=MaxBar)
    {
     for(int iii = 0; iii < AveragePeriod; iii++) 
         {
           Ind_Buffer1[MaxBar-iii] = 0.0;
           Ind_Buffer2[MaxBar-iii] = 0.0;
           limit=MaxBar-AveragePeriod;
         }
     //----
     AvgRange=0;
     for(int jjj = AveragePeriod-1; jjj >= 0; jjj--)AvgRange += MathAbs(High[MaxBar+jjj] - Low[MaxBar+jjj]);
     dK = AvgRange/(AveragePeriod*10000*Point );
     close=Close[MaxBar];
     open =Open [MaxBar];
     price = close;
     //----
     if(close > open)
        {
           Resalt = close * (1 - dK);
           trend = true; 
        }
     //----
     if(close < open)  
        {
           Resalt = close * (1 + dK);
           trend = false; 
        }
     if( trend) Ind_Buffer1[MaxBar] = Resalt; 
     if(!trend) Ind_Buffer2[MaxBar] = Resalt; 
    }
     //----
     
//the basic cycle of the calculation of indiatora
   bar = limit;
   while(bar >= 0)
    {   
//--- the retention of the values of variable ==========
       if (bar==1)
           if(((limit==1)&&(time2==Time[2]))||(limit>1))
             {
               time2=Time[2];
               PRICE=price;
               TREND=trend;
               RESALT=Resalt;
             }
       //+---+==========================================+   
       AvgRange=0; 
       for(int kkk = AveragePeriod-1; kkk >= 0; kkk--)AvgRange += MathAbs(High[bar+kkk] - Low[bar+kkk]);
       dK = AvgRange/(AveragePeriod*10000*Point );  
       close=Close[bar];
       Ind_Buffer1[bar]=0; 
       Ind_Buffer2[bar]=0;
       //----
       if(trend)
         {
           if(close > price)
             {
               price  = close;
               NewVel = close * (1 - dK);
               if(NewVel > Resalt) Resalt=NewVel;
             }
           else
           if(close < Resalt)
             {
               price  = close;
               Resalt = close * (1 + dK);
               trend  = false;
             }
         } 
       //---- 
       if(!trend)
         {
           if(close < price)
             {  
               price  = close;
               NewVel = close * (1 + dK);
               if(NewVel < Resalt) Resalt=NewVel;
             } 
           else  
           if(close > Resalt) 
             {
               price  = close;
               Resalt = close * (1 - dK);
               trend  = true;
             }
         }
       //----
       if( trend) Ind_Buffer1[bar] = Resalt; 
       if(!trend) Ind_Buffer2[bar] = Resalt; 
       bar--;
     }
//the completion of the basic cycle
    return(0);
   }
//+-----------------------------------------------------------------------------+

