//+------------------------------------------------------------------+
//|                                                     Trigger Line |
//|                             Copyright ? 2005 dwt5 and adoleh2000 |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright ? 2005 dwt5 and adoleh2000 "
#property link "http://www.metaquotes.net/"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of indicator bufferov
#property indicator_buffers 4 
//the color of the indicator
#property indicator_color1 Blue 
#property indicator_color2 Blue
#property indicator_color3 Red 
#property indicator_color4 Red 
//THE INPUT PARAMETERS OF THE INDICATOR OF -------
extern int Rperiod = 15;
extern int LSMA_Period = 5;
//---- ------------------------------------+
//indicator buffery
double Ind_Buffer1[];
double Ind_Buffer2[];
double Ind_Buffer3[];
double Ind_Buffer4[];
//+------------------------------------------------------------------+
//| Trigger Line initialization function                             |
//+------------------------------------------------------------------+
int init()
{
//the style of the performance of the graph
SetIndexStyle(0,DRAW_LINE);
SetIndexStyle(1,DRAW_LINE);
SetIndexStyle(2,DRAW_LINE);
SetIndexStyle(3,DRAW_LINE);
//4 indicator buffera are used for the calculation
SetIndexBuffer(0,Ind_Buffer1);
SetIndexBuffer(1,Ind_Buffer2);
SetIndexBuffer(2,Ind_Buffer3);
SetIndexBuffer(3,Ind_Buffer4);
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);
SetIndexEmptyValue(1,0.0);
//name for the windows of data and leyba for sub"okon
IndicatorShortName("Trigger Line");
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
SetIndexDrawBegin(0,2*Rperiod+6); 
SetIndexDrawBegin(1,2*Rperiod+6); 
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
IndicatorDigits(Digits);  
//the completion of the initialization
return(0);
}
//+------------------------------------------------------------------+
//| Trigger Line iteration function                                  |
//+------------------------------------------------------------------+
int start()
{ 
double Vel0,Vel1,LSMA,sum;
//the introduction of entire variables and obtaining the alreadycalculated bars
int bar,limit,MaxBar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of all bars
MaxBar = Bars-2*Rperiod-6;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1;
//initialization of zero
if(limit>=MaxBar)
  {
    limit=MaxBar;
    for(bar = Bars-1; bar >= MaxBar; bar--) 
      {
        Ind_Buffer1[bar] = 0; 
        Ind_Buffer2[bar] = 0; 
        Ind_Buffer3[bar] = 0; 
        Ind_Buffer4[bar] = 0; 
      }
  }
//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(bar = limit; bar >= 0; bar--) 
  { 
    sum = 0; 
    for(int iii = Rperiod; iii >= 1 ; iii--) sum+= ( iii - (Rperiod + 1.0)/3)*Close[bar+Rperiod-iii]; 
    //----
    Vel0 = sum*6/(Rperiod*(Rperiod+1.0)); 
    Vel1 = Ind_Buffer1[bar+1];
    LSMA = Vel0 + (Vel0-Vel1)* 2/(LSMA_Period+1);
    //----
    Ind_Buffer1[bar] = Vel0; 
    Ind_Buffer2[bar] = LSMA; 
    Ind_Buffer3[bar] = Vel0; 
    Ind_Buffer4[bar] = LSMA; 
    //----
    if (Vel0 < LSMA)
     {
      Ind_Buffer4[bar] = EMPTY_VALUE;
      Ind_Buffer3[bar] = EMPTY_VALUE;
     } 
  }
//THE COMPLETION OF THE BASIC CYCLE
return(0);
}
//+---------------------------------------------------+

