/*
For the work of indicator should be placed the files
JJMASeries.mqh
PriceSeries.mqh
3Color.mqh
in the folder (directory): MetaTrader\.experts\.include \
JDFilter.mq4
Heiken Ashi#..mq4
in the folder (directory): MetaTrader\.indicators \
*/
//------------------------------------------------------------------
//| 3c_.JDFilter.mq4 |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
// otrisovka of indicator in the main window
#property indicator_chart_window 
// a quantity of the indicator buffers
#property indicator_buffers 6
// the color of the indicator
#property indicator_color1 Gold
#property indicator_color2 Gold
#property indicator_color3 Magenta 
#property indicator_color4 Magenta 
#property indicator_color5 Gray
#property indicator_color6 Gray
// the thickness of the indicator lines
#property indicator_width1 2
#property indicator_width2 2 
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 3 
#property indicator_width6 3
// THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Length = 5; //the depth of the smoothing
extern int Phase = 100; //the parameter of smoothing, which is changedwithin limits of -100... 100, influence the quality of transientprocess;
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator
TO //(0-.CHLOSE, Y-.OPEN, 2-.YUIGYU, E-.LOSH, YA-.MEDIAN,SHCH-.TYPICHAL, '-.SHEIGYUTED, "-.Yueiken Ashi Close, 8-.SIMPL,9-.TRENDFOLLOSH, Y0-0.SHCH*.TRENDFOLLOSH,
//yy-.Yueiken Ashi High, y2-.Yueiken Ashi Low, ye-.Yueiken Ashi Open,yya-.Yueiken Ashi Close.)
extern int FilterType = 0; //Tip of filter with the finishedparameters of the library of the filters
//---------------------------------------------------------------------------------------
//we indicate the parameters of the filter
extern int FType=0;//Tip filter: 0 - FNCH (FATL/SATL/KGLP), 1 - FVCH(KGHP), 2 - BAND (RBCI/KGBP), 3 - REJECTOR (KGBS)
extern int P1=28;//Period cutoff P1, bars
extern int D1=19;//Period cutoff of the transient process of D1, thebar
extern int A1=40;//Zatuxanie in the strip of delay Ay, dB
extern int P2=0;//Period cutoff P2, bars
extern int D2=0;//Period cutoff of the transient process of D2, thebar
extern int A2=0;//Zatuxanie in the strip of delay A2, dB
extern int Delay=0;//Zaderjka, the bar
extern double Ripple=0.08;//Bieni4 in the passband, dB
extern bool Print_.Filter=.false;/* the press the parameters of filterinto LOG file of the periodical of experts in the folder of\.MetaTrader\.GBPZhPY\.EKhPERTS\.LOGS
one should not the parameter "Print_.Filter" leave with equal "true",after tuning of indicator. "FALSE" - THE PROHIBITION OF THE PRESS THEPARAMETERS,
"true" THE PRESS THE PARAMETERS */
//-------------------------------------------------------------------------------------------------------------------------------
// introduction to function digits() for the installation of the sizeof accuracy (quantity of signs after decimal point) for thevisualization of the values of the indicator
int digits(){return(Digits);}
// introduction to function COUNT_.begin() for enumerating the numberof the bar, beginning from which will otrisovyvat'sya the indicator
// with COUNT_.begin()=-1 will be made the automatic search for thisvalue in terms of the first naydenomu value, not equal to EmptyValue
int COUNT_begin(){return(-1);}
// the installation of the values of indicator, which not will be seenon the graph
int EmptyValue=0;
string Label="JDFilter";                 
// the start in the text of the indicator of its basic text
#include <3Color.mqh>
// introduction to function INDICATOR of------------------------------------------------------------------------------------------------------
// turning to initial indicator for obtaining the i.chkhodnykh values
double INDICATOR(int INDICATOR.bar)
 {
  return( iCustom(NULL,0,"JDFilter",Length,Phase,0,Input_Price_Customs,FilterType,FType,P1,D1,A1,P2,D2,A2,Delay,Ripple,Print_Filter,0,INDICATOR.bar) );
 }
//---------------------------------------------------------------------------------------------------------------------------------
