/*
//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+ 
//Version  July 1, 2006                                              |
Editing   Nikolay Kositsin  15.06.2006  farria@mail.redcom.ru        |
//----+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+ 
*/
//+------------------------------------------------------------------+ 
//|                                                        JLSMA.mg4 |
//|                             Copyright ? 2005 dwt5 and adoleh2000 |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2005 dwt5 and adoleh2000 "
#property link "http://www.metaquotes.net/"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Red 
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int LSMA_period = 10;
extern int JMA_.Lenght = 6; //the depth of the smoothing
extern int JMA_.Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence the quality of transient process;
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer[];
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+   
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| JLSMA initialization function                                    |
//+------------------------------------------------------------------+  
int init()
{
//the style of the performance of the graph
SetIndexStyle(0,DRAW_LINE);
//1 indicator buffer is used for the calculation
SetIndexBuffer(0,Ind_Buffer);
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);
//name for the windows of data and leyba for sub"okon
IndicatorShortName("Trigger Line");
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
SetIndexDrawBegin(0,LSMA_period); 
//the installation of the size of the accuracy of mapping theindicator
IndicatorDigits(Digits);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=2(Dva turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"LSMA_period",LSMA_period);
JJMASeriesAlert (0,"JMA_Lenght",JMA_Lenght);
JJMASeriesAlert (1,"JMA_Phase", JMA_Phase);
PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
return(0);
}
//+------------------------------------------------------------------+  
//| JLSMA iteration function                                         |
//+------------------------------------------------------------------+  
int start()
{
//checking a quantity of bars to the sufficiency for furthercalculation
if (Bars-1<LSMA_period+31)return(0);
//the introduction of variables with the floating point
double LSMA,Sum,JLSMA,Price;
//the introduction of entire variables and obtaining the alreadycalculated bars
int bar,limit,MaxBar,reset,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of all bars
MaxBar = Bars-LSMA_period;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1;
//initialization of zero
if(limit>=MaxBar)
  {
    limit=MaxBar;
    for(bar = Bars-1; bar >= MaxBar; bar--)Ind_Buffer[bar] = 0; 
  }
//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(bar = limit; bar >= 0; bar--) 
  { 
    Sum = 0; 
    for(int iii = 1; iii <= LSMA_period ; iii++) 
      {  
        Price=PriceSeries(Input_Price_Customs, bar+LSMA_period-iii);
        Sum+= ( iii - (LSMA_period + 1.0)/3)*Price; 
      }
    //----
    LSMA = Sum*6/(LSMA_period*(LSMA_period+1.0));    
//JMA the smoothing of the obtained indicator, parameter nJMA.MaxBaris reduced by the size of filter nf
//the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
    JLSMA=JJMASeries(0,0,MaxBar,limit,JMA_Phase,JMA_Lenght,LSMA,bar,reset);
//checking to the absence of error in the previous operation
    if(reset!=0)return(-1);
    //----
    Ind_Buffer[bar] = JLSMA; 
  }
//THE COMPLETION OF THE BASIC CYCLE
return(0);
}
//+---------------------------------------------------+

