/*
For the work of indicator should be placed the files
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \

TRIX - this is momentum of ostsilator of price, introduced into therevolution by jack k.
Khatssonom ("Goog TRIX", Technical Analysis of Stock
1:5,  http://www.forexua.com/indicators/www.traders.com).
TRIX - one-day difference in the triple exponential smoothing
the logarithm of the price of closing. Indicator is calculated intosix stages:
1. the logarithm of the day price of closing is obtained;
2. they smooth out logarithm with the aid of ESS;
3. is obtained ESS of the exponential moving average, found on
stage 2;
4. is obtained ESS of the exponential moving average, found on
stage 3;
5. they calculate the one-day difference between the results of thetriple
the smoothing: for this value of the stage of 4 present days they readfrom
the value of the stage of 4 previous days;
6. value, obtained in stage 5, they multiply (for the convenientmapping
on the graph) to 10 000.
Tuning T.RIKH in accordance with one or other commercial cycle oranother
it is carried out, as in the case of other indicators, by changing thenumber
days on the exponential moving average. There are several
the possible ways of interpretation T.RIKH. The simplest rectilinear
the rule of making commercial decisions for strategy of movement afterthe trend
it says: to buy, when T.RIKH changes direction from that falling on
growing. To sell, when T.RIKH changes directions from that growing on
falling.
Copyright ? 2003  Forex company http://www.forexua.com

In this indicator the triple smoothing of input price with the aid of
the exponential moving average is substituted to the the double JMA
smoothing.
*/
//+------------------------------------------------------------------+  
//|                                                        JTRIX.mq4 | 
//|                        Copyright ? 2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 1 
//the color of the indicator
#property indicator_color1 Blue
//the parameters of the horizontal levels of the indicator
#property indicator_level1 0.0
#property indicator_levelcolor BlueViolet
#property indicator_levelstyle 4
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int Length = 5; //the depth of the dual smoothing of the inputprice
extern int Phase = 100; //the parameter of dual smoothing, which ischanged within limits of -100... 100, influence the quality oftransient process;
extern int Smooth = 5; //the depth of the smoothing of the finishedindicator
extern int Mom_.Period = 1; //Momentum the period of the indicator
extern int Ind_.Shift = 0; //cdvig indicator along the time axis
extern int Input_.Price_.Customs = 0;/* The selection of prices, onwhich is produced the calculation of the indicator
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.) */
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer1 [];
double Smooth_Price[];
//variables with the floating point
double Series,Temp_Series,Trix,JTRIX;
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| JTRIX initialization function                                    | 
//+------------------------------------------------------------------+  
int init() 
{  
//2 indicator buffers are used for the calculation
IndicatorBuffers(2);
SetIndexBuffer(0,Ind_Buffer1 );
SetIndexBuffer(1,Smooth_Price);
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0); 
//the horizontal shift of the indicator lines
SetIndexShift (0, Ind_Shift); 
//the style of the performance of graph the form of the point line
SetIndexStyle(0,DRAW_LINE);
//names for the windows of data and leyby for sub"okon
IndicatorShortName ("JTRIX( Length="+Length+", Smooth="+Smooth+", Mom_Period="+Mom_Period+")"); 
SetIndexLabel   (0, "JTRIX"); 
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
IndicatorDigits(0);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=3(Tri turning to function JJMASeries)
if (JJMASeriesResize(3)!=3)return(-1);
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"Mom_Period",Mom_Period);
JJMASeriesAlert (0,"Length",Length);
JJMASeriesAlert (0,"Smooth",Smooth);
JJMASeriesAlert (1,"Phase", Phase);
PriceSeriesAlert(Input_Price_Customs);
//korektsiya of the inadmissible value of parameter Mom_.Period
if(Mom_Period<1)Mom_Period=1; 
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| JTRIX iteration function                                         | 
//+------------------------------------------------------------------+  
int start() 
{ 
//checking a quantity of bars to minimally necessary for calculationJTRIX
if (Bars-1<Mom_Period-60)return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,limit,MaxBar1,MaxBar2,MaxBarJ,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1;
MaxBar1=Bars-1; MaxBar2=MaxBar1-30; MaxBarJ=MaxBar2-30-Mom_Period; 

//the cycle of the calculation of the logarithm of input price withthe dual smoothing
for(int bar=limit;bar>=0;bar--)
  {
//turning to function TimeJJMASeries for obtaining the input price
   Series=PriceSeries(Input_Price_Customs, bar);
//taking the logarithm of the input price
   Temp_Series=MathLog(Series);
//two sequential turnings to function JJMASeries after numbers 0, 1parameters nJMA.Phase and nJMA.Length do not change on each bar(nJMA.din=0)
//(in the second rotation parameter nJMA.MaxBar it is reduced by 30since this repeated JMA smoothing)
   Temp_Series=JJMASeries(0,0,MaxBar1,limit,Phase,Length,Temp_Series,bar,reset); if(reset!=0)return(-1);
   Temp_Series=JJMASeries(1,0,MaxBar2,limit,Phase,Length,Temp_Series,bar,reset); if(reset!=0)return(-1); 
   Smooth_Price[bar]=Temp_Series;
  }
//the initialization of neraschityvayemykh buffer elements zero and achange in the number of the oldest bar, beginning from which therewill be proizeden the conversion of the new bars
if(limit>MaxBarJ)
 {
  for(bar=limit;bar>=MaxBarJ;bar--)Ind_Buffer1[bar]=0.0;
  limit=MaxBarJ;
 }

//THE BASIC CYCLE OF THE CALCULATION OF INDICATOR JTRIX
for(bar=limit;bar>=0;bar--)
  {
  Trix=10000*(Smooth_Price[bar]-Smooth_Price[bar+Mom_Period]);
//the turning to function JJMASeries after number 2, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
//(V this rotation parameter nJMA.MaxBar is reduced by 30 more sincethis repeated JMA smoothing)
  JTRIX=JJMASeries(2,0,MaxBarJ,limit,100,Smooth,Trix,bar,reset); if(reset!=0)return(-1); 
  Ind_Buffer1[bar]=JTRIX; 
  }
//the completion of the calculations of the values of the indicator

return(0); 
} 
//+-----------------------------------------------------------------------------+

