//+------------------------------------------------------------------+  
//|                                                       JsNRTR.mq4 |
//|                    http://www.gustis.narod.ru;     gsb51@mail.ru |
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
//otrisovka of indicator in the main window
#property indicator_chart_window 
//a quantity of the indicator buffers
#property indicator_buffers 2
//the color of the indicator
#property indicator_color1 Lime 
#property indicator_color2 Red
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int MA_.method = 0; //the method of the averaging
extern int Length = 12; //the depth of the smoothing
extern int MA_.Smooth = 8; //the depth of the smoothing
extern int MA_.Phase = y00;///the parameter of smoothing, which ischanged within limits of -100... 100, influence the quality oftransient process;
extern int  Smoth_ATR=18;
extern int Multipiller = 10; //coefficient;
extern int Input_.Price_.Customs = 0;//Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
extern bool Line_Style=false;
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double NRTR[];
double UpTrendBuffer[];
double DownTrendBuffer[];
//+------------------------------------------------------------------+  
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| JsNRTR indicator initialization function                         | 
//+------------------------------------------------------------------+  
int init() 
{  
//3 indicator buffers are used for the calculation
IndicatorBuffers(3);
SetIndexBuffer(0,UpTrendBuffer); 
SetIndexBuffer(1,DownTrendBuffer); 
SetIndexBuffer(2,NRTR);
if (Line_Style==true)
 {
//the style of the performance of graph in the form of the line
  SetIndexStyle(0,DRAW_LINE); 
  SetIndexStyle(1,DRAW_LINE); 
 }
else
 {
//the style of the performance of graph in the form of the pointtargets
  SetIndexStyle(0,DRAW_ARROW); 
  SetIndexStyle(1,DRAW_ARROW); 
  SetIndexArrow(0,159); 
  SetIndexArrow(1,159); 
 }
//the installation of the values of indicator, which not will be seenon the graph
SetIndexEmptyValue(0,0.0);
SetIndexEmptyValue(1,0.0);
//name for the windows of data and leyba for sub"okon
IndicatorShortName ("NRTR( Length="+Length+", Multipiller="+Multipiller+")"); 
SetIndexLabel (0, "Up_Trend");
SetIndexLabel (1, "Down_Trend"); 
//the installation of Alerts at the inadmissible values of theexternal variables
PriceSeriesAlert(Input_Price_Customs);
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+  
//| JsNRTR iteration function                                        | 
//+------------------------------------------------------------------+  
int start() 
{ 
//checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=MathMax(Length, Smoth_ATR)) return(0);
//variables with the floating point
double Resalt,ATR,Price,Moving;
//the introduction of entire variables and obtaining the alreadycalculated bars
int bar,limit,MaxBar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
MaxBar=Bars-1-MathMax(Length, Smoth_ATR); limit=Bars-1-counted_bars;
//checking bar to the sufficiency for calculation Bollinger Bands
//initialization of zero
if (limit>=MaxBar)
     {
      for(bar=Bars-1;bar>=MaxBar;bar--)
       {
         NRTR[bar]=0;
         UpTrendBuffer[bar]=0;
         DownTrendBuffer[bar]=0;
       }
      limit=MaxBar;
     }
//---- 
//THE BASIC CYCLE OF THE CALCULATION OF THE INDICATOR
for(bar=limit;bar>=0;bar--)
  {
   DownTrendBuffer[bar]=0;
   UpTrendBuffer  [bar]=0;
   //----+
   ATR =iATR(NULL,0,Smoth_ATR,bar)*Multipiller/10;
   Moving=iCustom(NULL,0,"JMoving Avereges",Length,MA_method,MA_Smooth,MA_Phase,0,Input_Price_Customs,0,bar);
//turning to function PriceSeries for obtaining the input priceSeries
   Price=PriceSeries(Input_Price_Customs,bar+1);
//-Strict the line- switch of ------------
   if(Price>NRTR[bar+1]){Resalt= Moving-ATR; UpTrendBuffer[bar]=Resalt;}
   else
   if(Price<NRTR[bar+1]){Resalt= Moving+ATR; DownTrendBuffer[bar]=Resalt;}
   else  Resalt= Moving;
   NRTR[bar]=Resalt;
  }
//the completion of the calculations of the values of the indicator
return(0); 
} 

//+----------------------------------------------------------------------------+

