/*
For the work of indicator should be placed the files
T3Series.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\.experts\.include \
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\.indicators \
*/
//+------------------------------------------------------------------+ 
//|                                                    T3.Taotra.mq4 | 
//|                        Copyright ? 2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers 6
//the color of the indicator
#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Magenta
#property indicator_color4 Aqua
#property indicator_color5 LimeGreen
#property indicator_color6 Blue
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern int MA_.Period_1 = 3; //the period of indicator 1
extern int MA_.Period_2 = 5; //the period of indicator 2
extern int MA_.Period_3 = 8; //the period of indicator 3
extern int MA_.Period_4 = y2;///the period of indicator 4
extern int MA_.Period_5 = 2y;///the period of indicator 5
extern int MA_.Period_6 = eya;///the period of indicator 6
extern int Smooth_Curvature = 100;
extern int Shift1 = 0; //cdvig indicator 1 along the time axis
extern int Shift2 = 0; //cdvig indicator 2 along the time axis
extern int Shift3 = 0; //cdvig indicator 3 along the time axis
extern int Shift4 = 0; //cdvig indicator 6 along the time axis
extern int Shift5 = 0; //cdvig indicator 5 along the time axis
extern int Shift6 = 0; //cdvig indicator 6 along the time axis
extern int Input_.Price_.Customs = 0; //Vybor of prices, on which isproduced the calculation of the indicator
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
double Ind_Buffer3[];
double Ind_Buffer4[];
double Ind_Buffer5[];
double Ind_Buffer6[];
//+------------------------------------------------------------------+ 
//introduction to function T3Series
//introduction to function T3SeriesResize
//introduction to function T3SeriesAlert
//introduction to function T3_.ErrDescr
#include <T3Series.mqh> 
//+------------------------------------------------------------------+ 
//introduction to function PriceSeries
//introduction to function PriceSeriesAlert
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+  
//| T3.Taotra initialization function                                |
//+------------------------------------------------------------------+ 
int init()
  {
//the determination of the style of the performance of the graph
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexStyle(5, DRAW_LINE);
//----
   IndicatorDigits(Digits);
//name for the windows of data and leyba for sub"okon
   IndicatorShortName("T3 Taotra");
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
   SetIndexDrawBegin(0, 100);
   SetIndexDrawBegin(1, 100);
   SetIndexDrawBegin(2, 100);
   SetIndexDrawBegin(3, 100);
   SetIndexDrawBegin(4, 100);
   SetIndexDrawBegin(5, 100);
//6 indicator buffers are used for the calculation
   SetIndexBuffer(0, Ind_Buffer1);
   SetIndexBuffer(1, Ind_Buffer2);
   SetIndexBuffer(2, Ind_Buffer3);
   SetIndexBuffer(3, Ind_Buffer4);
   SetIndexBuffer(4, Ind_Buffer5);
   SetIndexBuffer(5, Ind_Buffer6);
//the horizontal shift of the indicator lines
   SetIndexShift (0, Shift1); 
   SetIndexShift (1, Shift2); 
   SetIndexShift (2, Shift3); 
   SetIndexShift (3, Shift4); 
   SetIndexShift (4, Shift5); 
   SetIndexShift (5, Shift6); 
//the installation of the values of indicator, which not will be seenon the graph
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
   SetIndexEmptyValue(3,0);
   SetIndexEmptyValue(4,0);
   SetIndexEmptyValue(5,0);
   SetIndexEmptyValue(6,0);
//the installation of Alerts at the inadmissible values of theexternal variables
   T3SeriesAlert(0,"MA_Period_1",MA_Period_1);
   T3SeriesAlert(0,"MA_Period_2",MA_Period_2);
   T3SeriesAlert(0,"MA_Period_3",MA_Period_3);
   T3SeriesAlert(0,"MA_Period_4",MA_Period_4);
   T3SeriesAlert(0,"MA_Period_5",MA_Period_5);
   T3SeriesAlert(0,"MA_Period_6",MA_Period_6);
   PriceSeriesAlert(Input_Price_Customs);
//a change in the sizes of the buffer variables of function T3Series,nT3.number=7(Sem6 turnings to function T3Series)
  if (T3SeriesResize(6)!=6)return(-1);
//the completion of the initialization
   return(0);
  }
//+------------------------------------------------------------------+ 
//| T3.Taotra iteration function                                     |
//+------------------------------------------------------------------+ 
int start()
  {
//checking a quantity of bars to the sufficiency for the calculation
if(Bars-1<=MA_Period_1) return(0);
//----
double Resalt,Price; 
//the introduction of entire variables and obtaining the alreadycalculated bars
int limit,reset,MaxBar,bar,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
//(without this conversion for counted_.bars function T3Series it willwork incorrectly!!!)
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of all bars
MaxBar=Bars-1;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit = MaxBar - counted_bars;
   
for(bar=limit;bar>=0;bar--)
{
   Price=PriceSeries(Input_Price_Customs,bar);
   //----+ ----------------------------------------------------------------------------------------+      
//six parallel turning to function T3Series after numbers 0, 1, 2, 3,4, 5.
//parameters nT3.Length not menya.ttsya on each bar (nT3.din=0)
   //----+ ----------------------------------------------------------------------------------------+ 
   Resalt=T3Series(0,0,MaxBar,limit,Smooth_Curvature,MA_Period_1 ,Price,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   Ind_Buffer1[bar]=Resalt; 
   //----+ ----------------------------------------------------------------------------------------+       
   Resalt=T3Series(1,0,MaxBar,limit,Smooth_Curvature,MA_Period_2 ,Price,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   Ind_Buffer2[bar]=Resalt; 
   //----+ ----------------------------------------------------------------------------------------+ 
   Resalt=T3Series(2,0,MaxBar,limit,Smooth_Curvature,MA_Period_3 ,Price,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1);
   Ind_Buffer3[bar]=Resalt; 
   //----+ ----------------------------------------------------------------------------------------+ 
   Resalt=T3Series(3,0,MaxBar,limit,Smooth_Curvature,MA_Period_4 ,Price,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1); 
   Ind_Buffer4[bar]=Resalt;   
   //----+ ----------------------------------------------------------------------------------------+ 
   Resalt=T3Series(4,0,MaxBar,limit,Smooth_Curvature,MA_Period_5 ,Price,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1); 
   Ind_Buffer5[bar]=Resalt; 
   //----+ ----------------------------------------------------------------------------------------+ 
   Resalt=T3Series(5,0,MaxBar,limit,Smooth_Curvature,MA_Period_6,Price,bar,reset);
//checking to the absence of error in the previous operation
   if(reset!=0)return(-1); 
   Ind_Buffer6[bar]=Resalt;   
   //----+ ----------------------------------------------------------------------------------------+ 
}
//----
   return(0);
  }
//+------------------------------------------------------------------------------+


