/*
Indicator is intended for the work only on the day size of graph.
The indicator does not work on another taymfreymakh!
*/
//+------------------------------------------------------------------+ 
//|                                              VGridLinesD4.LC.mq4 |
//|                             Copyright ? 2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+  
#property copyright "Copyright ? 2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//otrisovka of indicator in all windows
#property indicator_chart_window 
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------
extern int Ind_.Shift = 0; //cdvig indicator along the time axis inthe bars
extern int Count_.Bar = 300; //a quantity of last bars for calculatingthe indicator
extern int Ind_.Style = 0; //the style of the image of indicator (0 -on silence)
extern bool AllDelate = false; //the removal of all cycles and allvertical lines
//--+
extern int Shift0 = 0; //cdvig four week old cycle in the bars
extern color COLOR0 = C'193,0,193 '; //the color of the line of thefour week old cycle
extern int Line_.Style0 = 3; //the style of the image of the line ofthe four week old cycle
extern int Line_.Width0 = 0; //the thickness of the line of the fourweek old cycle
//--+
extern int Shift1 = 0; //cdvig weekly cycle in the bars
extern color COLOR1 = C'130,0,185 '; //the color of the line of theweekly cycle
extern int Line_.Style1 = 4; //the style of the image of the line ofthe weekly cycle
extern int Line_.Width1 = 0; //the thickness of the line of the weeklycycle
//---- -------------------------------------------------------------------------------------+
//the indicator buffers
double Buffer[];
//the entire variables
int hour,day,month,year;
int time0,time1,Wind_total,Del_time,Start_Time,ii,bar,MaxBar;
//+------------------------------------------------------------------+  
//| VGridLinesD4.LC initialization function                          | 
//+------------------------------------------------------------------+  
int init() 
{
if (Period()!=1440)return(0);
//- - the removal of all vertical lines and cycles from the graph
if (AllDelate==true){ObjectsDeleteAll(EMPTY, OBJ_VLINE);ObjectsDeleteAll(EMPTY,OBJ_CYCLES);}
//- - the calculation of all existing windows of the graph
Wind_total=WindowsTotal();
//1 indicator buffer is used for the calculation
SetIndexBuffer(0,Buffer);
//the completion of the initialization
return(0); 
} 
//+------------------------------------------------------------------+ 
//| VGridLinesD4.LC deinitialization function                        |
//+------------------------------------------------------------------+ 
int deinit()
  {
//- - removal of vertical lines and cycles from all windows, createdwith the work of the indicator
VLineDelateAll("VLine_Grid");
CycleDelateAll();
//ObjectsDeleteAll(EMPTY,OBJ_VLINE) ;
//ObjectsDeleteAll(EMPTY,OBJ_CYCLES); 
//the completion of the deinitializaton
   return(0);
  }
//+------------------------------------------------------------------+ 
//| VGridLinesD4.LC iteration function                               |
//+------------------------------------------------------------------+ 
int start()
{
if (Period()!=1440)return(0);
MaxBar=Bars-1;
//checking a quantity of bars to the sufficiency
if (Count_Bar<7500/Period())Count_Bar=7500/Period();
if (Count_Bar>MaxBar)Count_Bar=MaxBar;
if (Count_Bar<4500/Period())Count_Bar=4500/Period();
if (Count_Bar>MaxBar)return(0);
//the initialization of the variables
if ((hour!=Hour())||(day!=Day())||(month!=Month())||(year!=Year()))
 {
  hour=Hour(); 
  day=Day();
  month=Month(); 
  year=Year();
 }
else return(0);
//the introduction of entire variables and obtaining the alreadycalculated bars

int weekl_lewelx1,weekl_lewelx4;
//--- initialization of zero with the change of the day of the week
time0=Time[0];
time1=Time[1];
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
int limit=Count_Bar; 
//--- removal of vertical lines from windows, created at the previousstart of the indicator
//the initialization of all elements of the massif with value of -1
VLineDelateAll("VLine_Grid");
CycleDelateAll();
ArrayInitialize(Buffer,-1);
   
//--- the construction of vertical grid in the form of the sequence ofthe separate vertical lines
for(int bar=limit;bar>=0;bar--)
  //+------+
 {
  if(Buffer[bar]!=-1)continue; 
  else                   
   //+---+ 
  {
   ObjectDelete("VLine_Grid"+Time[bar]+"");                   
   time0=Time[bar+0];
   time1=Time[bar+1];
   weekl_lewelx1=086400*(07*MathFloor(time0/0604800)+Shift1+Ind_Shift+2); 
   weekl_lewelx4=086400*(28*MathFloor(time0/2419200)+Shift0+Ind_Shift+2+21);   
   //+---+
//--- of three turnings to function VLineCreate for constructing thevertical lines
   if((time0>=weekl_lewelx4)&&(time1<weekl_lewelx4)){VLineCreate("VLine_Grid",time0,COLOR0,Line_Style0,Line_Width0);Buffer[bar]=0;}else
   if((time0>=weekl_lewelx1)&&(time1<weekl_lewelx1)){VLineCreate("VLine_Grid",time0,COLOR1,Line_Style1,Line_Width1);Buffer[bar]=1;}  
   //+---+   
  } 
//--- the removal of the vertical lines, which emerge abroad ofCount_.Bar
  Del_time=Time[bar+Count_Bar];
  ObjectDelete("VLine_Grid"+Del_time+"");
  //+---+
 }
//--- finishing grid after zero bar from the cycles
if(Buffer[0]==-1)
 {
//--- removal of lines of cycles from windows, created at the previousstart of the indicator
   CycleDelateAll();
//--- the search for the beginning of the weekly cycle
   for(int aa=0;aa<=MaxBar;aa++){if (Buffer[aa]==0)break;}  
   Start_Time=86400*(MathCeil(Time[aa]/86400)-Ind_Shift+5);
   //+---+ 
//--- one turning to function CycleCreate for creating one weeklycycle
   for(ii=0;ii<Wind_total;ii++)CycleCreate("Cycle_Grid1",Start_Time,Shift1,05,COLOR1,Line_Style1,Line_Width1,ii);  
   CycleDelate("Cycle_GridW");
//--- the search for the beginning of the four week old cycle
   for(int bb=0;bb<=MaxBar;bb++){if (Buffer[bb]==1)break;}  
   Start_Time=86400*(MathCeil(Time[bb]/86400)-Ind_Shift+12+15);
   //+---+ 
//--- one turning to function CycleCreate for creating one four weekold cycle
   for(ii=0;ii<Wind_total;ii++)CycleCreate("Cycle_GridW",Start_Time,Shift0,20,COLOR0,Line_Style0,Line_Width0,ii);   
 }
//--- the completion of the construction of the cycles
return(0);
}
//--- of-------------------------------------------------------------------------------------------
void  VLineDelateAll(string  VLineDelateAll.Line_Name)
  {
   for(int pp=MaxBar;pp>=0;pp--)ObjectDelete(VLineDelateAll.Line_Name+Time[pp]+"");
  }
//--- of---------------------------------------------------------------------------------------------
void  CycleDelate(string CycleDelate.Cycle_Name)
  {
   int TT=WindowsTotal();
   for(int rr=0; rr<TT; rr++)ObjectDelete(CycleDelate.Cycle_Name+rr+"");  
  } 
//--- of------------------------------------------------------------------------------------------
void  CycleDelateAll()
  {
   CycleDelate("Cycle_GridW");CycleDelate("Cycle_Grid1"); 
  } 
//--- of----------------------------------------------------------------------------------------------
void VLineCreate
(
string VLineCreate.Line_Name, int VLineCreate.time, color VLineCreate.Color, int VLineCreate.Line_Style, int VLineCreate.width
)
//+---+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -   - - - + 
{
   for(int ii=0;ii<WindowsTotal();ii++)
   ObjectCreate(VLineCreate.Line_Name+VLineCreate.time+"", OBJ_VLINE, ii, VLineCreate.time, EMPTY);  
   ObjectSet   (VLineCreate.Line_Name+VLineCreate.time+"", OBJPROP_BACK, true);
   ObjectSet   (VLineCreate.Line_Name+VLineCreate.time+"", OBJPROP_STYLE, VLineCreate.Line_Style);
   ObjectSet   (VLineCreate.Line_Name+VLineCreate.time+"", OBJPROP_COLOR, VLineCreate.Color);  
   ObjectSet   (VLineCreate.Line_Name+VLineCreate.time+"", OBJPROP_WIDTH, VLineCreate.width); 
}  

//--- of---------------------------------------------------------------------------------------------
void CycleCreate
(
string CycleCreate.Cycle_Name, int CycleCreate.Start_Time, int CycleCreate.Shift,  int CycleCreate.Period, 
color  CycleCreate.Color,      int CycleCreate.Style,      int CycleCreate.Width,  int CycleCreate.Window
)
//--- parameter CycleCreate.Period is measured in the days
//--- parameter CycleCreate.Start_.Time izmkryaetsya in seconds
//+---+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - + 
{  
  int CycleCreate.St_time=CycleCreate.Start_Time+CycleCreate.Shift*86400; 
  int CycleCreate.Object_time=CycleCreate.St_time+CycleCreate.Period*86400;
   
  ObjectCreate(CycleCreate.Cycle_Name+CycleCreate.Window+"", OBJ_CYCLES,CycleCreate.Window,CycleCreate.St_time,-1000,CycleCreate.Object_time,-1000);  
  ObjectSet   (CycleCreate.Cycle_Name+CycleCreate.Window+"", OBJPROP_BACK, true);
  ObjectSet   (CycleCreate.Cycle_Name+CycleCreate.Window+"", OBJPROP_STYLE,  CycleCreate.Style);
  ObjectSet   (CycleCreate.Cycle_Name+CycleCreate.Window+"", OBJPROP_COLOR,  CycleCreate.Color);
  ObjectSet   (CycleCreate.Cycle_Name+CycleCreate.Window+"", OBJPROP_WIDTH,  CycleCreate.Width);
}
//+---+ --------------------------------------------------------------------------------------------------------------------------------+
